#include <time.h>
#include "CSendMail.h"

CSendMail::CSendMail()
{
    deb_file = NULL;
    timeout = TIMEOUT_VALUE;

}
CSendMail::~CSendMail()
{
    Disconnect();
    WSACleanup();

}
bool CSendMail::Connect(char *server,int port)
{
    struct in_addr	addr;

    WSAStartup(MAKEWORD(1,1),&Data);

    addr.s_addr=inet_addr(server);
    serverHostent=gethostbyaddr((char*)&addr,sizeof(struct in_addr),AF_INET);
    if(serverHostent==NULL){
        serverHostent=gethostbyname(server);
    }
    if(serverHostent==NULL) return false;
    else{
        memcpy((char FAR *)&serverSokAdr.sin_addr,serverHostent->h_addr,serverHostent->h_length);
        serverSokAdr.sin_port = htons(port);
        serverSokAdr.sin_family = AF_INET;

        sock = socket( AF_INET, SOCK_STREAM, 0);
        if(sock==INVALID_SOCKET){
            return false;
        }
        if(connect(sock, (LPSOCKADDR) &serverSokAdr,sizeof(serverSokAdr))<0){
            return false;
        }
        if( setsockopt( sock, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(timeout)) != NO_ERROR ) return false;
        if( setsockopt( sock, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(timeout)) != NO_ERROR ) return false;
    }
    return true;
}
 bool CSendMail::Disconnect()
{
    if(closesocket(sock) == SOCKET_ERROR) return false;
    return true;
}
 int CSendMail::Send(char *data)
{
    int n=send(sock,data,strlen(data),NO_FLAGS_SET);
    return n;
}
 int CSendMail::Recv(char *data,int max_size)
{
    int n=recv(sock,data,max_size,NO_FLAGS_SET);
    return n;
}
//body  true = file
//      false = text
bool CSendMail::Mail(char *mail_from,char *mail_to,char *subject,char *fname,bool body)
{
	char	recv_msg[MSGMAXLEN+1];
	char	msg[MSGMAXLEN+1];
	char	row_buff[5000];
	FILE	*f;

	if(body) if((f=fopen(fname,"rt"))==NULL) return false;
//send mail	
	Send("");
	Recv(recv_msg,MSGMAXLEN);
	Send("helo server\n");
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'HELO'");
        return false;
    }
	sprintf(msg,"MAIL FROM: %s\n",mail_from);
	Send(msg);
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'MAIL FROM'\n");
        goto Quit;
    }
	sprintf(msg,"RCPT TO: %s\n",mail_to);
	Send(msg);
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'RCPT TO'\n");
        goto Quit;
    }
	Send("DATA\n");
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"354",3)){
        AddLog("Error 'DATA'\n");
        goto Quit;
    }
// header	
	sprintf(msg,"From: %s\r\n",mail_from);
	Send(msg);
	sprintf(msg,"To: %s\r\n",mail_to);
	Send(msg);
	sprintf(msg,"Subject: %s\r\n",subject);
	Send(msg);
// konec hlavicky	
	Send("\r\n");
//send body (file)	
        if(body){
                while(fgets(row_buff,4999,f)!=NULL){
                Send(row_buff);
            }
            fclose(f);
        }
 //send text
        else Send(fname);       
//end of data
	Send("\r\n.\r\n");
	Recv(recv_msg,MSGMAXLEN);
    Send("QUIT\n");
	Recv(recv_msg,MSGMAXLEN);
return true;
Quit:
    Send("QUIT\n");
	Recv(recv_msg,MSGMAXLEN);
return false;

}
bool CSendMail::SendMail(char* smtp_server,char* mail_from,char* mail_to,char* subject,char* fname,bool body)
{
    if(Connect(smtp_server)==true){
        if(Mail(mail_from,mail_to,subject,fname,body)==false) return false;
        Disconnect();
    }
    else return false;
return true;
}
void CSendMail::StartLog( char *file )
{
    deb_file = strdup(file);
}
//add log data
void CSendMail::AddLog( char* text )
{
FILE *f;
char retez_datum[100];
//    printf("%s",text);

    if (deb_file) {    
		f=fopen (deb_file,"at");
		if (f){
            SYSTEMTIME syst;
            GetLocalTime (&syst);
            sprintf (retez_datum,"%.2d/%.2d/%.4d %.2d:%.2d:%.2d ",syst.wDay,syst.wMonth,syst.wYear,
                syst.wHour,syst.wMinute,syst.wSecond);
            fputs (retez_datum,f);
            fputs (text,f);
            fclose (f);
		}
	}

}
void CSendMail::EndLog( void )
{
    deb_file = NULL;
}
bool CSendMail::Mail( TMail *m )
{
	char	recv_msg[MSGMAXLEN+1];
	char	msg[MSGMAXLEN+1];
	char	row_buff[5000];
	FILE	*f;
    time_t time_of_day;

	if(m->fname) if((f=fopen(m->fname,"rt"))==NULL) return false;
//send mail	
	Send("");
	Recv(recv_msg,MSGMAXLEN);
	Send("helo ovex\n");
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'HELO'");
        return false;
    }
	sprintf(msg,"MAIL FROM: %s\n",m->mail_from);
	Send(msg);
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'MAIL FROM'\n");
        goto Quit;
    }
	sprintf(msg,"RCPT TO: %s\n",m->mail_to);
	Send(msg);
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"250",3)){
        AddLog("Error 'RCPT TO'\n");
        goto Quit;
    }
	Send("DATA\n");
	Recv(recv_msg,MSGMAXLEN);
	if(strnicmp(recv_msg,"354",3)){
        AddLog("Error 'DATA'\n");
        goto Quit;
    }
// header	
	sprintf(msg,"From: %s %s\r\n",(m->mail_from_name?m->mail_from_name:""),m->mail_from);
	Send(msg);
	sprintf(msg,"To: %s %s\r\n",(m->mail_to_name?m->mail_to_name:""),m->mail_to);
	Send(msg);
	sprintf(msg,"Content-Type: %s\r\n",(m->content_type?m->content_type:""));
	Send(msg);
	sprintf(msg,"Content-Transfer-Encoding: %s\r\n",(m->content_transfer_encoding?m->content_transfer_encoding:""));
	Send(msg);
	sprintf(msg,"X-Mailer: %s\r\n",(m->mailer?m->mailer:"unknown"));
	Send(msg);
    time_of_day = time( NULL );
    strftime( msg, 100, "Date: %a,%d %b %Y %H:%M:%S GMT\r\n",gmtime( &time_of_day ) );
	Send(msg);
    sprintf(msg,"Subject: %s\r\n",m->subject);
	Send(msg);
// konec hlavicky	
	Send("\r\n");
//send body (file)	
        if(m->fname){
                while(fgets(row_buff,4999,f)!=NULL){
                Send(row_buff);
            }
            fclose(f);
        }
 //send text
        else Send(m->body_text);       
//end of data
	Send("\r\n.\r\n");
	Recv(recv_msg,MSGMAXLEN);
    Send("QUIT\n");
	Recv(recv_msg,MSGMAXLEN);
return true;
Quit:
    Send("QUIT\n");
	Recv(recv_msg,MSGMAXLEN);
return false;


}
bool CSendMail::SendMail(char* smtp_server,TMail *m)
{
    if(Connect(smtp_server)==true){
        if(Mail(m)==false) return false;
        Disconnect();
    }
    else return false;
return true;

}
CSendMail::SetTimeout( int t )
{
    timeout = t;
}
