#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include <time.h>
#include "Dialog.h"
#include "KWindow.h"
#include "Misc.h"
#include "Globals.h"
#include "Input.h"
#include "File.h"
#include "Edit.h"
#include "Reminder.h"
#include "CSendMail.h"


#define		OVERWRITE			1
#define		OVERWRITE_ALL		2
#define		SKIP				3
#define		SKIP_ALL			4

#define		TEST_RETKEY			if(retkey == 13 || retkey == 27) break


char	work_mutex_name[100];

HANDLE	hWaitThread;

//sleep between IO (for thread switching)
DWORD	g_KulakSleep = 5;

//for copy thread
DWORD	dwCopiedBytes;
//only for printing status
DWORD	globalFSize;
DWORD	globalActionTimeBegin;

long		globalNFiles;
long		g_max_find_files = 1000;
long		g_find_files;
long		g_n_scaned_files;

char		sLastFindMask[STR_SIZE] = "*.*";

DWORD		dwActionStart;			//for alarm
/////////////////////////////////////

//ext highlight
long			g_nExtHighlight = 8;
TExtHighlight	g_ExtHighlight [8] = 
{
	{ "",0,T_GREEN_L },
	{ "",0,T_GREENBLUE_L },
	{ "",0,T_RED_L },
	{ "",0,T_VIOLET_L },
	{ "",0,T_GREENBLUE_D },
	{ "",0,T_WHITE_L },
	{ "",0,T_WHITE_D },
	{ "",0,T_YELLOW_D },
};
BOOL			g_bHighlight_on = TRUE;
//fast macros
char	g_FastMacro[10][STR_SIZE] = {0};

void InfoMessage(HANDLE hC,char *label,char *text)
{
	int x = 20, y = 12;
	KWindow w(hC);

	w.Init(label,x,y,40,5,ctError,cbError,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctError,cbError,x+3,y+2,"%s",text);
	mygetch();	
	w.RestoreBG();
}

void InfoWaitMessage(HANDLE hC,char *label,char *text,DWORD wait)
{
	int x = 20, y = 12;
	KWindow w(hC);

	w.Init(label,x,y,40,5,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctDialog,cbDialog,x+3,y+2,"%s",text);
	Sleep(wait);
	w.RestoreBG();
}


char YesNoCancelMessage(HANDLE hC,char *label,char *text)
{
	char ret;
	int x = 20, y = 9;
	KWindow w(hC);

	w.Init(label,x,y,40,7,ctError,cbError,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctError,cbError,x+3,y+2,"%s",text);
	clprintf(hC,ctDialog,cbDialog,x+15,y+4," Y/N/Esc ");
	while(1)
	{
		ret = toupper(mygetch());
		if(ret == 'Y' || ret == 'N' || ret == 27) break;
		if(ret == 13)
		{
			ret = 'Y';
			break;
		}
	}
	w.RestoreBG();
return (ret);
}

void ErrorMesage(void)
{
	char serror[STR_SIZE];
	DWORD err = GetLastError();

	switch(err)
	{
		case ERROR_ALREADY_EXISTS : sprintf(serror,"ALREADY_EXISTS");break;
		case ERROR_SHARING_VIOLATION : sprintf(serror,"SHARING_VIOLATION");break;
		default: sprintf(serror,"error : %ld",err);
	}
	InfoMessage(GetStdHandle(STD_OUTPUT_HANDLE),"ERROR",serror);
}

//-------------------------------------------------

void WaitWorking(void)
{
	char ch = '-';
	HANDLE h_mutex = OpenMutex(MUTEX_ALL_ACCESS,FALSE,work_mutex_name);

	while(1)
	{
		WaitForSingleObject(h_mutex,INFINITE);
		switch(ch)
		{
			case '-' : ch = '\\'; break;
			case '\\' : ch = '|'; break;
			case '|' : ch = '/'; break;
			case '/' : ch = '-'; break;
		}
		clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctPanel,cbPanel,aWindow->posX+aWindow->sizeX - 5,aWindow->posY,"[%c]",ch);
		ReleaseMutex(h_mutex);
	}
}

void WaitBegin(LPTHREAD_START_ROUTINE fce)
{
	DWORD id;

	dwActionStart = GetTickCount();
	CreateMutex(NULL,FALSE,work_mutex_name);
	hWaitThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)fce,NULL,0,&id);
}


void WaitEnd(void)
{
	HANDLE h_mutex = OpenMutex(MUTEX_ALL_ACCESS,FALSE,work_mutex_name);
	
	Sleep(10);
	WaitForSingleObject(h_mutex,1000);
	TerminateThread(hWaitThread,0);
	WaitForSingleObject(hWaitThread,INFINITE);
	if(GetTickCount() - dwActionStart > 7000)
	{
		SpeekerBeep(1);
	}
	while(kbhit()) mygetch();
	ReleaseMutex(h_mutex);
	CloseHandle(h_mutex);
}


////////////////////////////////////
//DialogDrives
//
// return drive 
////////////////////////////////////
char DialogDrives(char *text)
{
	DWORD	dwNumBytesForDriveStrings;
   	HANDLE	hHeap;
   	LPTSTR	lp;
   	int		nNumDrives = 0;
	char	drives[STR_SIZE];
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);

	memset(drives,' ',99);
   	dwNumBytesForDriveStrings = GetLogicalDriveStrings(0, NULL) * sizeof(TCHAR);

	if (dwNumBytesForDriveStrings != 0) 
	{
		hHeap = GetProcessHeap();
		lp = (LPTSTR) HeapAlloc(hHeap, HEAP_ZERO_MEMORY,dwNumBytesForDriveStrings);
	    GetLogicalDriveStrings(HeapSize(hHeap, 0, lp), lp);
		while (*lp != 0) 
		{
	        drives[(nNumDrives*2)] = toupper(lp[0]);
			nNumDrives++;
		    lp = strchr(lp, 0) + 1;   // Point to next string.
		}
		drives[(nNumDrives*2)] = 0;
		HeapFree(hHeap, 0, lp);
	}
	
	unsigned xsize = strlen(drives) + 5;
	short x = ( 80 - xsize ) / 2;
	short y = 10;
	char label[STR_SIZE];
	char key;

	sprintf(label,"%s drive",text);
	if(xsize < (strlen(label)+6)) xsize = (strlen(label)+6);
	w.Init(label,x,10,xsize,4,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctInput,cbInput,x + 2,y + 2," %s",drives);
	for(;;)
	{
		key = mygetchASCII();
		if(key == 27) 
		{
			w.RestoreBG();
			return 0;
		}
		if(key != ' ' && strchr(drives,toupper(key))) 
		{
			w.RestoreBG();
			return toupper(key);
		}
	}
return 0;
}


/////////////////////////////////////
//ActionSelectedSize
//
//return sie of selected files and directories
/////////////////////////////////////
BOOL RecurseSize(char *mask,DWORD &size,DWORD &compsize,long& nFiles)
{
	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;
	DWORD	dwSizeHigh;

	if((handle = FindFirstFile(mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }
			if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				if(SetCurrentDirectory(fd.cFileName))
				{
					if(!RecurseSize(mask,size,compsize,nFiles)) return FALSE;
				}
			}
			else
			{
				size += fd.nFileSizeLow;
				if(fd.dwFileAttributes & FILE_ATTRIBUTE_COMPRESSED)
				{
					compsize += GetCompressedFileSize(fd.cFileName,&dwSizeHigh);
				}
			}
			//switch to another thread		
			KulakSleep(g_KulakSleep);
			
			if((done = FindNextFile( handle, &fd )) != TRUE) SetCurrentDirectory("..");
		}
	}
	FindClose( handle );
return TRUE;
}

void ActionSize(void)
{
	long	nFiles;
	char	lastdir[STR_SIZE];
	char	startdir[STR_SIZE];
	BOOL	bSelected = FALSE;

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(nFiles > 0) bSelected = TRUE;

	GetCurrentDirectory(STR_SIZE-1,startdir);
	for(int i = 0 ; i < (*aPanel)->nFiles; i++ )
	{
 		if(strcmp((*aPanel)->Items[i].file.cFileName,".") && strcmp((*aPanel)->Items[i].file.cFileName,"..") && IsDir(&(*aPanel)->Items[i]))
		{
			if((*aPanel)->Items[i].selected || !bSelected)
			{
				GetCurrentDirectory(STR_SIZE-1,lastdir);
				SetCurrentDirectory((*aPanel)->Items[i].file.cFileName);
				(*aPanel)->Items[i].dirsize = 0;
				(*aPanel)->Items[i].dircompsize = 0;
				if(!RecurseSize("*.*",(*aPanel)->Items[i].dirsize,(*aPanel)->Items[i].dircompsize,nFiles))
				{
		 			break;
				}
				SetCurrentDirectory(lastdir);
			}
		}
	}
	while(kbhit()) mygetch();
	SetCurrentDirectory(startdir);
}

////////////////////////////////////
//DialogCopyFiles
//
// 
////////////////////////////////////

void PrintFileStatistic(HANDLE h,short x,short y,char *name)
{
	char stmp[STR_SIZE];
	char stmp1[STR_SIZE];
	int speed = (globalFSize/(int)(1+(clock() - globalActionTimeBegin)/CLK_TCK));

	strcpy(stmp,name);
	if( strlen(name) > 36 ) {
		stmp[0]='}';
		FormatStringRight(35,stmp+1);
	} else {
		CreateSpaceString(stmp,name,36);
	}
	clprintf(h,ctDialog,cbDialog,x+2,y+2,"%s",stmp);
	FormatFileSize(globalFSize,stmp);
	FormatFileSize(globalNFiles,stmp1);
	clprintf(h,ctDialog,cbDialog,x+2,y+3,"%s B    [ %s files ]",stmp,stmp1);
	FormatFileSize(speed,stmp);
	clprintf(h,ctDialog,cbDialog,x+2,y+4,"%s B/s   ",stmp);
}

#define		COPY_BUFFER_SIZE		64000
BOOL KulakCopyFile(char *src,char *dest,BOOL bFailIfExists)
{
	char percentage[STR_SIZE];	
	unsigned char	*buffer;
	FILE			*fsrc,*fdest;
	size_t			srcsize,copysize,readsize;
	HANDLE			h = GetStdHandle(STD_OUTPUT_HANDLE);
	COORD			dwWriteCoord;
	DWORD			cCharsWritten;
	int				key;

	FILETIME ct;
	FILETIME lat;
	FILETIME lwt;

	MyGetFileTime(src,&ct,&lat,&lwt);
	
	fdest = fopen(dest,"rb");
	if(fdest && bFailIfExists) 
	{
		fclose(fdest);
		SetLastError(ERROR_FILE_EXISTS);
		return FALSE;
	}
	if(fdest) fclose(fdest);
	
	fsrc = fopen(src,"rbc");
	if(!fsrc) return FALSE;
	fdest = fopen(dest,"wbc");
	if(!fdest) 
	{
		fclose(fsrc);
		return FALSE;
	}
	fseek(fsrc,0L,SEEK_END);
	srcsize = ftell(fsrc);
	fseek(fsrc,0L,SEEK_SET);
	copysize = 0;

	dwWriteCoord.X = 23;
	dwWriteCoord.Y = 10;
	FillConsoleOutputCharacter(h,g_FrameChar[6], 34,dwWriteCoord, &cCharsWritten);

	buffer = new unsigned char[COPY_BUFFER_SIZE];
	kASSERT(buffer!=NULL);
	while(1)
	{
		if(KeyPressed()) 
		{ 
			key = mygetch();
			if(key == 27) 
			{
				ungetch(key);
				fclose(fsrc);
				fclose(fdest);
				DeleteFile(dest);
				return TRUE; 
			}
		}
		readsize = fread(buffer,1,COPY_BUFFER_SIZE,fsrc);
		if(readsize > 0) 
		{
			if(fwrite(buffer,1,readsize,fdest) < readsize) 
			{
				fclose(fdest);
				fclose(fsrc);
				DeleteFile(dest);
				SetLastError(ERROR_DISK_FULL);
				return FALSE;
			}
			fflush(fdest);
		}
		if(readsize < COPY_BUFFER_SIZE) break;
		//switch to another thread		
		KulakSleep(g_KulakSleep);
		copysize += readsize;
//draw meter
		dwWriteCoord.X = 23;
		dwWriteCoord.Y = 10;
		FillConsoleOutputCharacter(h,g_FrameChar[7],(copysize/(srcsize/34)) ,dwWriteCoord, &cCharsWritten);

		sprintf(percentage," %d%% ",copysize/(srcsize/100));
		dwWriteCoord.X = 38;
		dwWriteCoord.Y = 10;
		WriteConsoleOutputCharacter(h,percentage,strlen(percentage),dwWriteCoord, &cCharsWritten);
	
	}
	fflush(fdest);
	fclose(fdest);
	fclose(fsrc);

	MySetFileTime(dest,&ct,&lat,&lwt);
	
	delete buffer;
return TRUE;
}

BOOL MyCopyFile(char *srcfile,char *destfile,DWORD size,short *AllFlag)
{
	char errlabel[50] = "";
	BOOL overwrite = TRUE;
	short tmpFlag;
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	BOOL	b_err;

	//print statistics
	PrintFileStatistic(hC,20,5,srcfile);
	if( !strcmp(srcfile,destfile) ) {
		InfoMessage(hC,"Error","Cannot copy file onto itself  !");
		return FALSE;
	}
	//if overwrite all
	if(*AllFlag == OVERWRITE_ALL || *AllFlag == OVERWRITE) 
	{
		SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
		overwrite = FALSE;
	}
	//copy file
	b_err = KulakCopyFile(srcfile,destfile,overwrite);
	if(!b_err)
	{
		//test error
		DWORD err = GetLastError();
		switch(err)
		{
			case ERROR_FILE_EXISTS	:  strcpy(errlabel,"error : FILE EXISTS"); break;
			case ERROR_ACCESS_DENIED:  strcpy(errlabel,"error : ACCESS DENIED"); break;
			case ERROR_DISK_FULL:		strcpy(errlabel,"error : DISK FULL"); break;
			case ERROR_SHARING_VIOLATION:  strcpy(errlabel,"error : SHARING VIOLATION"); break;
			default : sprintf(errlabel,"unhandled error : %d",err); break;
		}
		//if skip all don't overwrite
		if(*AllFlag != SKIP_ALL)
		{
			int x = 20, y = 12;
			KWindow w(hC);
			w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
			w.SaveBG();
			w.Show(hC);
			clprintf(hC,ctError,cbError,x + 2,y + 2,"Overwrite  All  Skip  aLl  Cancel");
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 2,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 13,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 18,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 25,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 29,y + 2,1);
			while(1)
			{
				if(KeyPressed())
				{
					char key = mygetchASCII();
					//overwrite
					if('O' == toupper(key) || key == 0xD )
					{
						w.RestoreBG();
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
						MyCopyFile(srcfile,destfile,size,&tmpFlag);						
						break;
					}
					//overwrite all
					if('A' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = OVERWRITE_ALL;
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
						MyCopyFile(srcfile,destfile,size,&tmpFlag);						
						break;
					}
					//skip all
					if('L' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = SKIP_ALL;
						break;
					}
					//skip
					if('S' == toupper(key))
					{
						w.RestoreBG();
						break;
					}
					//cancel
					if('C' == toupper(key) || 27 == key)
					{
						w.RestoreBG();
						return FALSE;
						break;
					}
				}
			}
			w.RestoreBG();
		}//skip all
	}
	else
	{
		globalNFiles++;
		globalFSize += size;
	}
return TRUE;
}


BOOL RecurseCopy(char *mask,char *destdir,short *copyflag)
{
	char stmp[STR_SIZE];
	char stmpdir[STR_SIZE];
	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;

	if((handle = FindFirstFile(mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }
			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						strcpy(stmpdir,destdir);
						DeleteLastBackslash(stmpdir);
						strcat(stmpdir,"\\");
						strcat(stmpdir,fd.cFileName);
						CreateDirectory(stmpdir,NULL);
						if(!RecurseCopy(mask,stmpdir,copyflag)) return FALSE;
					}
				}
				else
				{
					strcpy(stmp,destdir);
					DeleteLastBackslash(destdir);
					strcat(stmp,"\\");
					strcat(stmp,fd.cFileName);
					if(!MyCopyFile(fd.cFileName,stmp,fd.nFileSizeLow,copyflag)){
						FindClose( handle );
						return FALSE;
					}
				}
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) SetCurrentDirectory("..");
		}
	}
	FindClose( handle );
return TRUE;
}

BOOL CopyOneFile(char *src,char *dest,long nInPanel,short *copyflag)
{
	char srcf[STR_SIZE],destf[STR_SIZE],stmp[STR_SIZE];

	DeleteLastBackslash(src);
	//if find panel
	if( IS_PT((*aPanel)->pt,PT_FIND) )
	{
		strcpy(destf,(*aPanel)->Items[nInPanel].path);
		DeleteLastBackslash(destf);
		sprintf(srcf,"%s\\%s",destf,(*aPanel)->Items[nInPanel].file.cFileName);
		strcpy(destf,"");
	}
	//else
	else
		sprintf(srcf,"%s\\%s",src,(*aPanel)->Items[nInPanel].file.cFileName);
	strcpy(destf,dest);
	if(TestDir(destf))
	{
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,(*aPanel)->Items[nInPanel].file.cFileName);
	}
	if(IsMaskOrFile(destf))
	{
		
		CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
		strcpy(destf,stmp);				
	}
	MyCopyFile(srcf,destf,(*aPanel)->Items[nInPanel].file.nFileSizeLow,copyflag);
return TRUE;
}

BOOL CopyOneDirectory(char *src,char *dest,long nInPanel,short *copyflag)
{
	char lastdir[STR_SIZE];
	char srcf[STR_SIZE],destf[STR_SIZE],stmp[STR_SIZE];
	char retval = TRUE;

	if(IS_PT((*aPanel)->pt,PT_FIND)) return FALSE;

	DeleteLastBackslash(src);
	sprintf(srcf,"%s\\%s",src,(*aPanel)->Items[nInPanel].file.cFileName);
	strcpy(destf,dest);
	if(TestDir(destf) && destf[1] == ':')
	{
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,(*aPanel)->Items[nInPanel].file.cFileName);
	}
	GetCurrentDirectory(STR_SIZE-1,lastdir);
	if(destf[1] != ':') 
	{
		strcpy(stmp,destf);
		strcpy(destf,lastdir);
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,stmp);
	}
	if(SetCurrentDirectory(srcf))
	{
		if(IsMaskOrFile(destf))
		{
			
			CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
			strcpy(destf,stmp);				
		}
		if(strcmp(srcf,destf))
		{
			CreateDirectory(destf,NULL);
			if(!RecurseCopy("*.*",destf,copyflag)) retval = FALSE;
		}
		SetCurrentDirectory(lastdir);
		return retval;
	}
	else 
	{
		return FALSE;
	}
}

int DialogCopyFiles( INPUT_RECORD& inputBuffer )
{
	int				retkey;
	short			CopyFlag = 0;
	short			x = 10;
	short			y = 10;
	long			nFiles = 0;
	char			destdir[STR_SIZE],srcdir[STR_SIZE];
	HANDLE			hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow			w(hC);
	TInput			i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	globalNFiles = 0;
	globalFSize	= 0;
	globalActionTimeBegin = clock();

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(!nFiles)
	{
		//ignore dir ".."
		if(!strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,"..")) return 0;
	}
	w.Init("Copy",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	//print labels
	if(nFiles)
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%ld selected items",nFiles);
	else
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%s",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	if(ActivePanel == LEFT) 
	{
		strcpy(destdir,rDirectory);
		strcpy(srcdir,lDirectory);
	}
	else 
	{
		strcpy(destdir,lDirectory);
		strcpy(srcdir,rDirectory);
	}	
	
	if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED) && !nFiles ) {
		retkey = i.Input((*aPanel)->Items[(*aPanel)->curr].file.cFileName,x + 2,y + 3,56,ctInput,cbInput);
	}
	else 
	{
		retkey = i.Input(destdir,x + 2,y + 3,56,ctInput,cbInput);
	}
	w.RestoreBG();
	if(retkey == 13)
	{
//init statistic window
		x = 20;y = 5;
		w.Init("Copy",x,y,40,6,ctDialog,cbDialog,TRUE);
		w.SaveBG();
		w.Show(hC);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+2,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+3,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+4,36);
//copy files
		WaitBegin();
		if(nFiles)
		{
			//copy selected items
			for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
			{
				if((*aPanel)->Items[ii].selected)
				{
					if(IsDir(&(*aPanel)->Items[ii]))
					{
						if(!IS_PT((*aPanel)->pt,PT_FIND))
							if(!CopyOneDirectory(srcdir,i.GetText(),ii,&CopyFlag)) break;
						(*aPanel)->Items[ii].selected = FALSE;
					}
					else
					{
						if(CopyOneFile(srcdir,i.GetText(),ii,&CopyFlag))
							(*aPanel)->Items[ii].selected = FALSE;
					}
				}
			}

		}
		else
		{
			//copy one directory
			if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
			{
				CopyOneDirectory(srcdir,i.GetText(),(*aPanel)->curr,&CopyFlag);
			}
			//copy one file
			else
			{
				CopyOneFile(srcdir,i.GetText(),(*aPanel)->curr,&CopyFlag);
			}
		}
		WaitEnd();
		w.RestoreBG();
	}
	while(kbhit()) mygetch();
return retkey;	
}

////////////////////////////////////
//DialogDeleteFiles
//
// 
////////////////////////////////////

BOOL MyDeleteFile(char *srcfile,BOOL bDir,DWORD size,short *AllFlag)
{
	char errlabel[50] = "";
	short tmpFlag;
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	BOOL bError;

	//if overwrite all
	if(*AllFlag == OVERWRITE_ALL || *AllFlag == OVERWRITE) 
	{
		SetFileAttributes(srcfile,FILE_ATTRIBUTE_NORMAL);
	}
	//print statistics
	PrintFileStatistic(hC,20,5,srcfile);
	//delete file or directory
	if(bDir) bError = RemoveDirectory(srcfile);
	else bError = DeleteFile(srcfile);
	if(!bError)
	{
		//test error
		DWORD err = GetLastError();
		switch(err)
		{
			case ERROR_ACCESS_DENIED:  strcpy(errlabel,"error : ACCESS DENIED"); break;
			case ERROR_SHARING_VIOLATION:  strcpy(errlabel,"error : SHARING VIOLATION"); break;
			default : sprintf(errlabel,"unhandled error : %d",err); break;
		}
		//if skip all don't overwrite
		if(*AllFlag != SKIP_ALL)
		{
			int x = 20, y = 12;
			KWindow w(hC);
			w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
			w.SaveBG();
			w.Show(hC);
			clprintf(hC,ctError,cbError,x + 2,y + 2,"Delete     All  Skip  aLl  Cancel");
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 2,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 13,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 18,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 25,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 29,y + 2,1);
			while(1)
			{
				if(KeyPressed())
				{
					char key = mygetchASCII();
					//delete
					if('D' == toupper(key) || key == 0xD )
					{
						w.RestoreBG();
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(srcfile,FILE_ATTRIBUTE_NORMAL);
						MyDeleteFile(srcfile,bDir,size,&tmpFlag);
						break;
					}
					//overwrite all
					if('A' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = OVERWRITE_ALL;
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(srcfile,FILE_ATTRIBUTE_NORMAL);
						MyDeleteFile(srcfile,bDir,size,&tmpFlag);						
						break;
					}
					//skip all
					if('L' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = SKIP_ALL;
						break;
					}
					//skip
					if('S' == toupper(key) )
					{
						w.RestoreBG();
						break;
					}
					//cancel
					if('C' == toupper(key) || 27 == key)
					{
						w.RestoreBG();
						return FALSE;
						break;
					}
				}
			}
			w.RestoreBG();
		}//skip all
	}
	else
	{
		globalNFiles++;
		globalFSize += size;
	}
return TRUE;
}


BOOL RecurseDelete(char *mask,short *copyflag)
{
	char stmp[STR_SIZE];
	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;

	if((handle = FindFirstFile(mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }
			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{

				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						if(!RecurseDelete(mask,copyflag)){
							FindClose( handle );
							GetCurrentDirectory(STR_SIZE-1,stmp);
							SetCurrentDirectory("..");
							return FALSE;
						}
					}
				}
				else
				{
					if(!MyDeleteFile(fd.cFileName,FALSE,fd.nFileSizeLow,copyflag)){
						FindClose( handle );
						GetCurrentDirectory(STR_SIZE-1,stmp);
						SetCurrentDirectory("..");
						return FALSE;
					}
					//switch to another thread		
					KulakSleep(g_KulakSleep);
				}
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) 
			{
				FindClose( handle );
				GetCurrentDirectory(STR_SIZE-1,stmp);
				SetCurrentDirectory("..");
				MyDeleteFile(stmp,TRUE,fd.nFileSizeLow,copyflag);
			}
		}
	}
return TRUE;
}

BOOL DeleteOneFile(long n,short *copyflag)
{
	char stmp[STR_SIZE];
	char spath[STR_SIZE];

	strcpy(stmp,(*aPanel)->Items[n].file.cFileName);
	
	if(IS_PT((*aPanel)->pt,PT_FIND))
	{
		strcpy(spath,(*aPanel)->Items[n].path);
		DeleteLastBackslash(spath);
		sprintf(stmp,"%s\\%s",spath,(*aPanel)->Items[n].file.cFileName);
	}
	else DeleteLastBackslash(stmp);
//	if(TestDir(src))
//	{
//	}
	MyDeleteFile(stmp,FALSE,(*aPanel)->Items[n].file.nFileSizeLow,copyflag);
return TRUE;
}

BOOL DeleteOneDirectory(char *src,short *copyflag)
{
	char retval = TRUE;
	
	if(IS_PT((*aPanel)->pt,PT_FIND)) return TRUE;
	if(TestDir(src))
	{
//		DeleteLastBackslash(destf);
//		strcat(destf,"\\");
//		strcat(destf,(*aPanel)->Items[nInPanel].file.name);
	}
	if(SetCurrentDirectory(src))
	{
		if(!RecurseDelete("*.*",copyflag)) retval = FALSE;
		return retval;
	}
	else 
	{
		return FALSE;
	}
}


int DialogDeleteFiles(void)
{
	int retkey;
	short CopyFlag = 0;
	short x = 10;
	short y = 10;
	long nFiles = 0;
	char srcdir[STR_SIZE];
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	globalNFiles = 0;
	globalFSize	= 0;
	globalActionTimeBegin = clock();

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(!nFiles)
	{
		//ignore dir ".."
		if(!strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,"..")) return 0;
	}
	w.Init("Delete",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
//print labels
	if(nFiles)
	{
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%ld selected items",nFiles);
		retkey = mygetchASCII();
	}
	else
	{
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%s",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
		if(ActivePanel == LEFT) 
			strcpy(srcdir,lDirectory);
		else 
			strcpy(srcdir,rDirectory);
		DeleteLastBackslash(srcdir);
		strcat(srcdir,"\\");
		strcat(srcdir,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
		retkey = i.Input(srcdir,x + 2,y + 3,56,ctInput,cbInput);
	}
	w.RestoreBG();

	
	if(retkey == 13)
	{
//init statistic window
		x = 20;y = 5;
		w.Init("Delete",x,y,40,6,ctDialog,cbDialog,TRUE);
		w.SaveBG();
		w.Show(hC);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+2,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+3,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+4,36);
//delete	
		WaitBegin();
		if(nFiles)
		{
			//delete selected items
			for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
			{
				if((*aPanel)->Items[ii].selected)
				{
					if(IsDir(&(*aPanel)->Items[ii]))
					{
						if(!IS_PT((*aPanel)->pt,PT_FIND))
							if(!DeleteOneDirectory((*aPanel)->Items[ii].file.cFileName,&CopyFlag)) break;
					}
					else
					{
						DeleteOneFile(ii,&CopyFlag);
					}
				}
			}

		}
		else
		{
			//delete one directory
			if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
			{
				DeleteOneDirectory(i.GetText(),&CopyFlag);
			}
			//Delete one file
			else
			{
				DeleteOneFile((*aPanel)->curr,&CopyFlag);
			}
		}
		WaitEnd();
		w.RestoreBG();
	}
	while(kbhit()) mygetch();

	return retkey;	
}

////////////////////////////////////
//DialogSetAttr
//
// 
////////////////////////////////////

void MySetAttr(char *srcfile,DWORD attr,DWORD size,short *AllFlag)
{
	char errlabel[50] = "";
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	BOOL bError;

	//print statistics
	PrintFileStatistic(hC,20,5,srcfile);
	//delete file or directory
	bError = SetFileAttributes(srcfile,attr);
	if(!bError)
	{
		//test error
		DWORD err = GetLastError();
		switch(err)
		{
			case ERROR_ACCESS_DENIED:  strcpy(errlabel,"error : ACCESS DENIED"); break;
			case ERROR_SHARING_VIOLATION:  strcpy(errlabel,"error : SHARING VIOLATION"); break;
			default : sprintf(errlabel,"unhandled error : %d",err); break;
		}
		//if skip all don't overwrite
		if(*AllFlag != SKIP_ALL)
		{
			int x = 20, y = 12;
			KWindow w(hC);
			w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
			w.SaveBG();
			w.Show(hC);
			clprintf(hC,ctError,cbError,x + 2,y + 2,"                Skip  aLl");
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 18,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 25,y + 2,1);
			while(1)
			{
				if(KeyPressed())
				{
					char key = mygetchASCII();
					//skip all
					if('L' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = SKIP_ALL;
						break;
					}
					//skip
					if('S' == toupper(key) || 27 == key)
					{
						w.RestoreBG();
						break;
					}
				}
			}
			w.RestoreBG();
		}//skip all
	}
	else
	{
		globalNFiles++;
		globalFSize += size;
	}
}


BOOL RecurseAttr(char *mask,DWORD attr,short *copyflag)
{
	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;

	if((handle = FindFirstFile(mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }
			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						if(!RecurseAttr(mask,attr,copyflag)) return FALSE;
					}
				}
				else
				{
					MySetAttr(fd.cFileName,attr,fd.nFileSizeLow,copyflag);
				}
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) 
			{
				FindClose( handle );
				SetCurrentDirectory("..");
			}
		}
	}
return TRUE;
}

BOOL AttrOneFile(long n,DWORD attr,short *copyflag)
{
	char stmp[STR_SIZE];
	char spath[STR_SIZE];

	strcpy(stmp,(*aPanel)->Items[n].file.cFileName);
	
	if(IS_PT((*aPanel)->pt,PT_FIND))
	{
		strcpy(spath,(*aPanel)->Items[n].path);
		DeleteLastBackslash(spath);
		sprintf(stmp,"%s\\%s",spath,(*aPanel)->Items[n].file.cFileName);
	}
	else DeleteLastBackslash(stmp);
	MySetAttr(stmp,attr,0,copyflag);
return TRUE;
}

BOOL AttrOneDirectory(char *src,DWORD attr,short *copyflag)
{
	char retval = TRUE;
	
	if(IS_PT((*aPanel)->pt,PT_FIND)) return TRUE;
	if(SetCurrentDirectory(src))
	{
		if(!RecurseAttr("*.*",attr,copyflag)) retval = FALSE;
		return retval;
	}
	else 
	{
		return FALSE;
	}
}


int DialogAttrFiles(void)
{
	DWORD	dwAttributes;
	int		retkey;
	short	CopyFlag = 0;
	short	x = 10;
	short	y = 10;
	long	nFiles = 0;
	char	srcdir[STR_SIZE],s_attr[STR_SIZE];
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput	i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	globalNFiles = 0;
	globalFSize	= 0;

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(!nFiles)
	{
		//ignore dir ".."
		if(!strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,"..")) return 0;
	}
	w.Init("Set attributes",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctDialog,cbDialog,x+10,y+3,"(A)=archive (R)=read only (H)=hidden (S)=system");
//print labels
	if(nFiles)
	{
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%ld selected items",nFiles);
	}
	else
	{
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%s",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
		if(ActivePanel == LEFT) 
			strcpy(srcdir,lDirectory);
		else 
			strcpy(srcdir,rDirectory);
		DeleteLastBackslash(srcdir);
		strcat(srcdir,"\\");
		strcat(srcdir,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	}
	retkey = i.Input("",x + 2,y + 3,6,ctInput,cbInput);
	w.RestoreBG();

	
	if(retkey == 13)
	{
//calcul attr
		dwAttributes = 0;
		strcpy(s_attr,i.GetText());
		strupr(s_attr);
		if(strchr(s_attr,'A')) dwAttributes |= FILE_ATTRIBUTE_ARCHIVE;
		if(strchr(s_attr,'R')) dwAttributes |= FILE_ATTRIBUTE_READONLY;
		if(strchr(s_attr,'H')) dwAttributes |= FILE_ATTRIBUTE_HIDDEN;
		if(strchr(s_attr,'S')) dwAttributes |= FILE_ATTRIBUTE_SYSTEM;
//init statistic window
		x = 20;y = 5;
		w.Init("Set attributes",x,y,40,6,ctDialog,cbDialog,TRUE);
		w.SaveBG();
		w.Show(hC);
		SetAttribute(hC,ctInput,cbInput,x+2,y+2,36);
		SetAttribute(hC,ctInput,cbInput,x+2,y+3,36);
		SetAttribute(hC,ctInput,cbInput,x+2,y+4,36);
//set attr
		WaitBegin();
		if(nFiles)
		{
			//selected items
			for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
			{
				if((*aPanel)->Items[ii].selected)
				{
					if(IsDir(&(*aPanel)->Items[ii]))
					{
						if(!IS_PT((*aPanel)->pt,PT_FIND))
							if(!AttrOneDirectory((*aPanel)->Items[ii].file.cFileName,dwAttributes,&CopyFlag)) break;
					}
					else
					{
						AttrOneFile(ii,dwAttributes,&CopyFlag);
					}
				}
			}

		}
		else
		{
			//one directory
			if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
			{
				AttrOneDirectory((*aPanel)->Items[(*aPanel)->curr].file.cFileName,dwAttributes,&CopyFlag);
			}
			//one file
			else
			{
				AttrOneFile((*aPanel)->curr,dwAttributes,&CopyFlag);
			}
		}
		WaitEnd();
		w.RestoreBG();
	}

	while(kbhit()) mygetch();

	return retkey;	
}


////////////////////////////////////
//DialogRenameFiles
//
// 
////////////////////////////////////

short g_DeleteMoveFlag;

//for W95 shit
//win NT only MoveFileEx 
BOOL FuckMoveFile(char *srcfile,char *destfile,DWORD flag) 
{
	DWORD dw_copy_flag = TRUE;
	DWORD attr;
	char  curdir[501];

	GetCurrentDirectory(STR_SIZE,curdir);
	attr = GetFileAttributes(srcfile);
	//move dir
	if(attr&FILE_ATTRIBUTE_DIRECTORY)
	{
		if(curdir[0] == destfile[0])
		{
			if(!MoveFile(srcfile,destfile)) return FALSE;
		}
		else
		{
			CreateDirectory(destfile,NULL);
			RemoveDirectory(srcfile);
		}
	}
	//move file
	else
	{
		if(flag&MOVEFILE_REPLACE_EXISTING)
		{
			dw_copy_flag = FALSE;
			SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
			MyDeleteFile(destfile,FALSE,0,&g_DeleteMoveFlag);						
		}
		if(curdir[0] == destfile[0])
		{
			if(!MoveFile(srcfile,destfile)) return FALSE;
		}
		else
		{
			if(!KulakCopyFile(srcfile,destfile,dw_copy_flag)) return FALSE;
			MyDeleteFile(srcfile,FALSE,0,&g_DeleteMoveFlag);						
		}
	}
return TRUE;
}


BOOL MyMoveFile(char *srcfile,char *destfile,DWORD size,short *AllFlag)
{
	char errlabel[50];
	DWORD dw_move_flag = MOVEFILE_COPY_ALLOWED;
	short tmpFlag;
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);

	//print statistics
	PrintFileStatistic(hC,20,5,srcfile);
	if( !strcmp(srcfile,destfile) ) {
		InfoMessage(hC,"Error","Cannot move file onto itself  !");
		return FALSE;
	}
	//if overwrite all
	if(*AllFlag == OVERWRITE_ALL || *AllFlag == OVERWRITE) 
	{
		SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
		dw_move_flag |= MOVEFILE_REPLACE_EXISTING;
	}
	//move file
	if(!FuckMoveFile(srcfile,destfile,dw_move_flag))
	{
		//test error
		DWORD err = GetLastError();
		switch(err)
		{
			case ERROR_FILE_EXISTS	:  strcpy(errlabel,"error : FILE EXISTS"); break;
			case ERROR_ACCESS_DENIED:  strcpy(errlabel,"error : ACCESS DENIED"); break;
			case ERROR_DISK_FULL:		strcpy(errlabel,"error : DISK FULL"); break;
			case ERROR_SHARING_VIOLATION:  strcpy(errlabel,"error : SHARING VIOLATION"); break;
			default : sprintf(errlabel,"unhandled error : %d",err); break;
		}
		//if skip all don't overwrite
		if(*AllFlag != SKIP_ALL)
		{
			int x = 20, y = 12;
			KWindow w(hC);
			w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
			w.SaveBG();
			w.Show(hC);
			clprintf(hC,ctError,cbError,x + 2,y + 2,"Overwrite  All  Skip  aLl  Cancel");
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 2,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 13,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 18,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 25,y + 2,1);
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 29,y + 2,1);
			while(1)
			{
				if(KeyPressed())
				{
					char key = mygetchASCII();
					//overwrite
					if('O' == toupper(key) || key == 0xD )
					{
						w.RestoreBG();
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
						MyMoveFile(srcfile,destfile,size,&tmpFlag);						
						break;
					}
					//overwrite all
					if('A' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = OVERWRITE_ALL;
						tmpFlag = OVERWRITE;
						if(err == ERROR_ACCESS_DENIED) SetFileAttributes(destfile,FILE_ATTRIBUTE_NORMAL);
						MyMoveFile(srcfile,destfile,size,&tmpFlag);						
						break;
					}
					//skip all
					if('L' == toupper(key))
					{
						w.RestoreBG();
						*AllFlag = SKIP_ALL;
						break;
					}
					//skip
					if('S' == toupper(key) )
					{
						w.RestoreBG();
						break;
					}
					//cancel
					if('C' == toupper(key) || 27 == key)
					{
						w.RestoreBG();
						return FALSE;
						break;
					}
				}
			}
			w.RestoreBG();
		}//skip all
	}
	else
	{
		globalNFiles++;
		globalFSize += size;
	}
return TRUE;
}


BOOL RecurseMove(char *mask,char *destdir,short *copyflag)
{
	char stmp[STR_SIZE];
	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;

	if((handle = FindFirstFile(mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }
			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						strcpy(stmp,destdir);
						DeleteLastBackslash(destdir);
						strcat(stmp,"\\");
						strcat(stmp,fd.cFileName);
						CreateDirectory(stmp,NULL);
						if(!RecurseMove(mask,stmp,copyflag)) return FALSE;
					}
				}
				else
				{
					strcpy(stmp,destdir);
					DeleteLastBackslash(destdir);
					strcat(stmp,"\\");
					strcat(stmp,fd.cFileName);
					if(!MyMoveFile(fd.cFileName,stmp,fd.nFileSizeLow,copyflag)){
						FindClose( handle );
						return FALSE;
					}
				}
				
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) 
			{
				FindClose( handle );
				GetCurrentDirectory(STR_SIZE,stmp);
				SetCurrentDirectory("..");
				MyDeleteFile(stmp,TRUE,0,copyflag);
			}
		}
	}
return TRUE;
}

BOOL MoveOneFile(char *src,char *dest,long nInPanel,short *copyflag)
{
	char lastdir[STR_SIZE];
	char srcf[STR_SIZE],destf[STR_SIZE],stmp[STR_SIZE];

	DeleteLastBackslash(src);
	//if find panel
	if(IS_PT((*aPanel)->pt,PT_FIND))
	{
		strcpy(destf,(*aPanel)->Items[nInPanel].path);
		DeleteLastBackslash(destf);
		sprintf(srcf,"%s\\%s",destf,(*aPanel)->Items[nInPanel].file.cFileName);
		strcpy(destf,"");
	}
	//else
	else
		sprintf(srcf,"%s\\%s",src,(*aPanel)->Items[nInPanel].file.cFileName);
	strcpy(destf,dest);
	if(TestDir(destf))
	{
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,(*aPanel)->Items[nInPanel].file.cFileName);
	}
	if(IsMaskOrFile(destf))
	{
		
		CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
		strcpy(destf,stmp);				
	}
	if(destf[1] != ':') 
	{
		GetCurrentDirectory(STR_SIZE-1,lastdir);
		strcpy(stmp,destf);
		strcpy(destf,lastdir);
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,stmp);
	}
	MyMoveFile(srcf,destf,(*aPanel)->Items[nInPanel].file.nFileSizeLow,copyflag);
return TRUE;
}

BOOL MoveOneDirectory(char *src,char *dest,long nInPanel,short *copyflag)
{
	char lastdir[STR_SIZE];
	char srcf[STR_SIZE],destf[STR_SIZE],stmp[STR_SIZE];
	char retval = TRUE;

	if(IS_PT((*aPanel)->pt,PT_FIND)) return TRUE;

	DeleteLastBackslash(src);
	sprintf(srcf,"%s\\%s",src,(*aPanel)->Items[nInPanel].file.cFileName);
	strcpy(destf,dest);

	if(TestDir(destf))
	{
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,(*aPanel)->Items[nInPanel].file.cFileName);
	}
	GetCurrentDirectory(STR_SIZE-1,lastdir);
	if(destf[1] != ':')
	{
		strcpy(stmp,destf);
		sprintf(destf,"%s\\%s",lastdir,stmp);		
		if(IsMaskOrFile(destf))
		{
			
			CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
			strcpy(destf,stmp);				
		}
		MyMoveFile(srcf,destf,(*aPanel)->Items[nInPanel].file.nFileSizeLow,copyflag);			
		//switch to another thread		
		KulakSleep(g_KulakSleep);
	}
	else
	{
		if(SetCurrentDirectory(srcf))
		{
			if(IsMaskOrFile(destf))
			{
				
				CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
				strcpy(destf,stmp);				
			}
			CreateDirectory(destf,NULL);
			if(!RecurseMove("*.*",destf,copyflag)) retval = FALSE;
			SetCurrentDirectory(lastdir);
			return retval;
		}
		else 
		{
			return FALSE;
		}
	}
	return TRUE;
}


int DialogMoveFiles( INPUT_RECORD& inputBuffer )
{
	int retkey;
	short CopyFlag = 0;
	short x = 10;
	short y = 10;
	long nFiles = 0;
	char destdir[STR_SIZE],srcdir[STR_SIZE];
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	g_DeleteMoveFlag = 0;
	globalNFiles = 0;
	globalFSize	= 0;
	globalActionTimeBegin = clock();

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(!nFiles)
	{
		//ignore dir ".."
		if(!strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,"..")) return 0;
	}
	w.Init("Move",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
//print labels
	if(nFiles)
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%ld selected items",nFiles);
	else
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%s",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	if(ActivePanel == LEFT) 
	{
		strcpy(destdir,rDirectory);
		strcpy(srcdir,lDirectory);
	}
	else 
	{
		strcpy(destdir,lDirectory);
		strcpy(srcdir,rDirectory);
	}	

	if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED) && !nFiles ) {
		retkey = i.Input((*aPanel)->Items[(*aPanel)->curr].file.cFileName,x + 2,y + 3,56,ctInput,cbInput);
	}
	else 
	{
		retkey = i.Input(destdir,x + 2,y + 3,56,ctInput,cbInput);
	}
	
	w.RestoreBG();

	
	if(retkey == 13)
	{
//init statistic window
		x = 20;y = 5;
		w.Init("Move",x,y,40,6,ctDialog,cbDialog,TRUE);
		w.SaveBG();
		w.Show(hC);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+2,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+3,36);
//		SetAttribute(hC,ctInput,cbInput,x+2,y+4,36);
//copy		
		WaitBegin();
		if(nFiles)
		{
			//copy selected items
			for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
			{
				if((*aPanel)->Items[ii].selected)
				{
					if(IsDir(&(*aPanel)->Items[ii]))
					{
						if(!IS_PT((*aPanel)->pt,PT_FIND))
							if(!MoveOneDirectory(srcdir,i.GetText(),ii,&CopyFlag)) break;
						(*aPanel)->Items[ii].selected = FALSE;
					}
					else
					{
						if(MoveOneFile(srcdir,i.GetText(),ii,&CopyFlag))
							(*aPanel)->Items[ii].selected = FALSE;
					}
				}
			}

		}
		else
		{
			//move one directory
			if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
			{
				MoveOneDirectory(srcdir,i.GetText(),(*aPanel)->curr,&CopyFlag);
			}
			//move one file
			else
			{
				MoveOneFile(srcdir,i.GetText(),(*aPanel)->curr,&CopyFlag);
			}
		}
		WaitEnd();
		w.RestoreBG();
	}

	while(kbhit()) mygetch();

	return retkey;	
}

////////////////////////////////////
//Create Directory
//
// 
////////////////////////////////////
void MyCreateDirectory(char *dir)
{
	char errlabel[50] = "";
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	BOOL bError;

	bError = CreateDirectory(dir,NULL);
	if(!bError)
	{
		//test error
		DWORD err = GetLastError();
		switch(err)
		{
			case ERROR_ALREADY_EXISTS:  strcpy(errlabel,"error : ALREADY EXISTS");
		}
		int x = 20, y = 12;
		KWindow w(hC);
		w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
		w.SaveBG();
		w.Show(hC);
		clprintf(hC,ctError,cbError,x + 2,y + 2,"Cannot create directory");
		mygetch();
		w.RestoreBG();
	}
}

int DialogCreateDirectory(char *dirname)
{
	int retkey;
	short x = 10;
	short y = 10;
	char destdir[STR_SIZE] = "";
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	w.Init("Create directory",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
//print labels
	retkey = i.Input(destdir,x + 2,y + 3,56,ctInput,cbInput);
	w.RestoreBG();
	
	if(retkey == 13)
	{
		MyCreateDirectory(i.GetText());			
		strcpy(dirname,i.GetText());
	}
return retkey;	
}

////////////////////////////////////
//Create NTFS Hard lin
//
// 
////////////////////////////////////

void NtfsHLErr(void)
{
#ifndef _MINGW32_
	char errlabel[50] = "ERROR";
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);

	DWORD err = GetLastError();

	switch(err)
	{
		case ERROR_ALREADY_EXISTS:  strcpy(errlabel,"error : ALREADY EXISTS");
	}
	int x = 20, y = 12;
	KWindow w(hC);
	w.Init(errlabel,x,y,40,5,ctError,cbError,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctError,cbError,x + 2,y + 2,"Cannot create link");
	mygetch();
	w.RestoreBG();
#endif
}



void enableprivs()
{
#ifndef _MINGW32_
	HANDLE hToken;
	byte buf[sizeof TOKEN_PRIVILEGES * 2];
	TOKEN_PRIVILEGES & tkp = *( (TOKEN_PRIVILEGES *) buf );

	if ( ! OpenProcessToken( GetCurrentProcess(),
		TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken ) )
		NtfsHLErr();

	// enable SeBackupPrivilege, SeRestorePrivilege

	if ( !LookupPrivilegeValue( NULL, SE_BACKUP_NAME, &tkp.Privileges[0].Luid ) )
		NtfsHLErr();

	if ( !LookupPrivilegeValue( NULL, SE_RESTORE_NAME, &tkp.Privileges[1].Luid ) )
		NtfsHLErr();

	tkp.PrivilegeCount = 2;
	tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	tkp.Privileges[1].Attributes = SE_PRIVILEGE_ENABLED;

	AdjustTokenPrivileges( hToken, FALSE, &tkp, sizeof tkp,
		NULL, NULL );
#endif
}



int NtfsHardLink(char *src, char *dest )
{
#ifndef _MINGW32_
	HANDLE fh;

	enableprivs(); // in case we aren't admin

	fh = CreateFile( src, GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
		FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_POSIX_SEMANTICS, NULL );
	if ( fh == INVALID_HANDLE_VALUE || fh == NULL )
		NtfsHLErr();

	static char buf1[MAX_PATH];
	static wchar_t buf2[MAX_PATH * 2];
	char *p;
	void *ctx = NULL;
	WIN32_STREAM_ID wsi;
	DWORD numwritten;

	GetFullPathName( dest, MAX_PATH, &buf1[0], &p );

	wsi.dwStreamId = BACKUP_LINK;
	wsi.dwStreamAttributes = 0;
	wsi.dwStreamNameSize = 0;
	wsi.Size.QuadPart = strlen( buf1 ) * 2 + 2;
	MultiByteToWideChar( CP_ACP, 0, buf1, strlen( buf1 ) + 1, buf2, MAX_PATH );

	if ( ! BackupWrite( fh, (byte *) &wsi, 20, &numwritten, FALSE, FALSE, &ctx ) )
		NtfsHLErr();
	if ( numwritten != 20 )
		NtfsHLErr();

	if ( ! BackupWrite( fh, (byte *) buf2, wsi.Size.LowPart, &numwritten, FALSE, FALSE, &ctx ) )
		NtfsHLErr();
	if ( numwritten != wsi.Size.LowPart )
		NtfsHLErr();

	// make NT release the context
	BackupWrite( fh, (byte *) &buf1[0], 0, &numwritten, TRUE, FALSE, &ctx );

	CloseHandle( fh );

	return 0;
#endif
}

//recursive create links

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

BOOL LinkOneFile(char *src,char *dest,long nInPanel)
{
	char srcf[STR_SIZE],destf[STR_SIZE],stmp[STR_SIZE];

	DeleteLastBackslash(src);
	//if find panel
	if(IS_PT((*aPanel)->pt,PT_FIND))
	{
		strcpy(destf,(*aPanel)->Items[nInPanel].path);
		DeleteLastBackslash(destf);
		sprintf(srcf,"%s\\%s",destf,(*aPanel)->Items[nInPanel].file.cFileName);
		strcpy(destf,"");
	}
	//else
	else
		sprintf(srcf,"%s\\%s",src,(*aPanel)->Items[nInPanel].file.cFileName);
	strcpy(destf,dest);
	if(TestDir(destf))
	{
		DeleteLastBackslash(destf);
		strcat(destf,"\\");
		strcat(destf,(*aPanel)->Items[nInPanel].file.cFileName);
	}
	if(IsMaskOrFile(destf))
	{
		
		CreateFileFromMask(destf,srcf,stmp,STR_SIZE);
		strcpy(destf,stmp);				
	}
	NtfsHardLink(srcf,destf);
return TRUE;
}


int DialogCreateNTFSHardLink(void)
{
	int				retkey;
	short			CopyFlag = 0;
	short			x = 10;
	short			y = 10;
	long			nFiles = 0;
	char			destdir[STR_SIZE],srcdir[STR_SIZE];
	HANDLE			hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow			w(hC);
	TInput			i(GetStdHandle(STD_OUTPUT_HANDLE));

	globalNFiles = 0;
	globalFSize	= 0;

	CalculateSelectedFiles((*aPanel),&nFiles);
	if(!nFiles)
	{
		//ignore dir ".."
		if(!strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,"..")) return 0;
	}
	w.Init("Create link",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	//print labels
	if(nFiles)
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%ld selected items",nFiles);
	else
		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"%s",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	if(ActivePanel == LEFT) 
	{
		strcpy(destdir,rDirectory);
		strcpy(srcdir,lDirectory);
	}
	else 
	{
		strcpy(destdir,lDirectory);
		strcpy(srcdir,rDirectory);
	}	
	retkey = i.Input(destdir,x + 2,y + 3,56,ctInput,cbInput);
	w.RestoreBG();

	
	if(retkey == 13)
	{
//copy files
		WaitBegin();
		if(nFiles)
		{
			//copy selected items
			for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
			{
				if((*aPanel)->Items[ii].selected)
				{
					if(IsDir(&(*aPanel)->Items[ii]))
					{
						InfoMessage(hC,"Info","Cannot create link to directory !");
						(*aPanel)->Items[ii].selected = FALSE;
					}
					else
					{
						LinkOneFile(srcdir,i.GetText(),ii);
						(*aPanel)->Items[ii].selected = FALSE;
					}
				}
			}

		}
		else
		{
			//copy one directory
			if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
			{
				InfoMessage(hC,"Info","Cannot create link to directory !");
			}
			//copy one file
			else
			{
				LinkOneFile(srcdir,i.GetText(),(*aPanel)->curr);
			}
		}
		WaitEnd();
	}
	while(kbhit()) mygetch();
return retkey;	
}
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
/*
int DialogCreateNTFSHardLink(char *srcname)
{
	int retkey;
	short x = 10;
	short y = 10;
	char destdir[STR_SIZE] = "";
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	w.Init("Create link",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
//print labels
	retkey = i.Input(destdir,x + 2,y + 3,56,ctInput,cbInput);
	w.RestoreBG();
	
	if(retkey == 13)
	{
		NtfsHardLink(srcname,i.GetText());
		//ret link name for find in panel
		strcpy(srcname,i.GetText());
	}
return retkey;	
}
*/
////////////////////////////////////
//DialogFindFile
//
// 
////////////////////////////////////


BOOL RecurseFind(char *mask,char *searchstr)
{
	char s_mask[STR_SIZE] = "*.*";
	char stmp[STR_SIZE];
	BOOL b_found;

	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;

	if((handle = FindFirstFile(s_mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }

			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				b_found = FALSE;
				if(checkname(fd.cFileName,mask) && !strcmp(searchstr,"")) b_found = TRUE;
				if(checkname(fd.cFileName,mask) && strcmp(searchstr,""))
				{
					if(FindStringInFile(fd.cFileName,searchstr)) b_found = TRUE;
				}
				clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctDialog,cbDialog,10+36,10+2,"%.7ld",g_n_scaned_files++);
				if(b_found)
				{
					TFind **ff;
					if(!ffHead.begin) ff = &ffHead.begin;
					else ff = &ffHead.end->next;
					*ff = new TFind;
					kASSERT(*ff!=NULL);
					(*ff)->file = fd;
					GetCurrentDirectory(STR_SIZE-1,stmp);
					strcpy((*ff)->path,stmp);
					(*ff)->prev = ffHead.end;
					(*ff)->next = NULL;
					ffHead.end = *ff;
					g_find_files++;
					if(g_find_files > g_max_find_files) return FALSE;
					clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctDialog,cbDialog,10+3,10+2,"found %.5ld  max %.5ld  scaned",g_find_files,g_max_find_files);
				}
				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						if(!RecurseFind(mask,searchstr)) return FALSE;
					}
				}
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) SetCurrentDirectory("..");
		}
	}
	FindClose( handle );
return TRUE;
}


int DialogFindFile(void)
{
	int retkey;
	short x = 10;
	short y = 10;
	char s_mask[STR_SIZE] = "*.*",s_path[STR_SIZE],s_tmp[STR_SIZE],s_searchstr[STR_SIZE]="";

	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput i_str(GetStdHandle(STD_OUTPUT_HANDLE));
	
	ffHead.begin = NULL;
	ffHead.end = NULL;
	g_find_files = 0;

	w.Init("Find file",x,y,60,7,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctDialog,cbDialog,x+2,y+4,"string:");
	
	strcpy(s_path,aDirectory);
	DeleteLastBackslash(s_path);
	strcat(s_path,"\\");
	strcat(s_path,sLastFindMask);

	i.Input(s_path,x + 2,y + 2,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_str.Input(findString,x + 10,y + 4,48,ctInput,cbInput,FALSE,TABEND_INIT);
	while(1)
	{
		retkey = i.Input(s_path,x + 2,y + 2,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_str.Input(i_str.GetText(),x + 10,y + 4,48,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
	}
	
	
	w.RestoreBG();
	strcpy(s_path,"");

	if(retkey == 13)
	{
		get_2parts_from_end(i.GetText(),s_tmp,s_searchstr,';');
		strcpy(findString,i_str.GetText());
		
		get_2parts_from_end(s_tmp,s_path,s_mask,'\\');
		if(strcmp(s_mask,""))
		{
			if(strlen(s_path) == 2) strcat(s_path,"\\");
			strcpy(sLastFindMask,s_mask);
			sprintf(s_tmp," Find %s %s",s_mask,findString);
			aWindow->SetLabel(s_tmp);
		
			if(strcmp(s_path,""))
				if(!SetCurrentDirectory(s_path)) return 27;
			
			w.Init("Find file",x,y,60,5,ctDialog,cbDialog,TRUE);
			w.SaveBG();
			w.Show(hC);
			clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctDialog,cbDialog,10+3,10+2,"found %.5ld  max %.5ld  scaned",g_find_files,g_max_find_files);
			g_n_scaned_files = 0;
			WaitBegin();
			RecurseFind(s_mask,findString);
			WaitEnd();
			SetCurrentDirectory(aDirectory);
			TFind *ff = ffHead.begin;
			long l_files = 0;
			if(ff)
			{
				while(1)
				{
					l_files++;
					if(!ff->next) break;
					ff = ff->next;
				}
				LoadFindPanel(&findPanel,l_files);
			}
			else 
			{				
				InfoMessage(hC," Find "," No files found.");
				retkey = 27;
			}
			w.RestoreBG();
		}
		else retkey = 27;
	}
return retkey;	
}

//------------------------------------------
//
//------------------------------------------
int DialogEditFile(char *fname)
{
	int retkey;
	short x = 10;
	short y = 10;
	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	
	w.Init("Edit file",x,y,60,6,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
//print labels
	retkey = i.Input(fname,x + 2,y + 3,56,ctInput,cbInput);
	w.RestoreBG();
	
	if(retkey == 13)
	{
		KcEdit(i.GetText());			
	}
return retkey;	
}

//------------------------------------------
// color config
//------------------------------------------
void ColorConfig(void)
{
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	int x = 2, y = 1;
	KWindow w(hC);
	WORD	*p_color,*p_tcolor,*p_bcolor;
	char	key = 'a';
	BOOL	bBack;

	w.Init("Color config - first choose object (+/-) change color",x,y,76,22,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	p_color = &ctPanel;
	p_tcolor = &ctPanel;
	p_bcolor = &cbPanel;
	bBack = FALSE;

	while(1)
	{
		clprintf(hC,ctDialog,cbDialog,x+3,y+2,"a) panel text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+3,"b) panel background");
		clprintf(hC,ctDialog,cbDialog,x+3,y+4,"c) info panel text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+5,"d) info panel background");
		clprintf(hC,ctDialog,cbDialog,x+3,y+6,"e) find panel text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+7,"f) find panel background");
		clprintf(hC,ctDialog,cbDialog,x+3,y+8,"g) info panel cell text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+9,"h) info panel cell background");
		clprintf(hC,ctDialog,cbDialog,x+3,y+10,"i) panel cursor text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+11,"j) panel cursor background");
		clprintf(hC,ctDialog,cbDialog,x+3,y+12,"k) selected item text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+13,"l) find selected item text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+14,"m) input text");
		clprintf(hC,ctDialog,cbDialog,x+3,y+15,"n) input background");

		clprintf(hC,ctDialog,cbDialog,x+40,y+2,"o) dialog text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+3,"p) dialog background");
		clprintf(hC,ctDialog,cbDialog,x+40,y+4,"q) error text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+5,"r) error background");
		clprintf(hC,ctDialog,cbDialog,x+40,y+6,"s) error word text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+7,"t) error word background");
		clprintf(hC,ctDialog,cbDialog,x+40,y+8,"u) editor selected text text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+9,"v) editor selected text background");
		clprintf(hC,ctDialog,cbDialog,x+40,y+10,"w) small drive menu text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+11,"x) small drive menu background");
		clprintf(hC,ctDialog,cbDialog,x+40,y+12,"y) bar text");
		clprintf(hC,ctDialog,cbDialog,x+40,y+13,"z) bar background");

		clprintf(hC,*p_tcolor,*p_bcolor,x+3,y+18,"                     ");
		clprintf(hC,*p_tcolor,*p_bcolor,x+3,y+19,"     TEST TEXT       ");
		clprintf(hC,*p_tcolor,*p_bcolor,x+3,y+20,"                     ");

		clprintf(hC,ctDialog,cbDialog,x+30,y+18,"T : %d  ",*p_tcolor);
		clprintf(hC,ctDialog,cbDialog,x+30,y+19,"B : %d  ",(*p_bcolor)>>4);

		if(isalpha(key))
			clprintf(hC,ctDialog,cbDialog,x+45,y+18,"current :  %c)",tolower(key));

		
		key = toupper(mygetch());	
	
		if(key == 27) break;
		switch(key)	
		{
			case 'A' :	{p_color = &ctPanel; p_tcolor = &ctPanel; bBack = FALSE; break; }
			case 'B' :	{p_color = &cbPanel; p_bcolor = &cbPanel;  bBack = TRUE; break; }
			case 'C' :	{p_color = &ctInfoPanel; p_tcolor = &ctInfoPanel; bBack = FALSE; break; }
			case 'D' :	{p_color = &cbInfoPanel; p_bcolor = &cbInfoPanel; bBack = TRUE; break; }
			case 'E' :	{p_color = &ctFindPanel; p_tcolor = &ctFindPanel; bBack = FALSE; break; }
			case 'F' :	{p_color = &cbFindPanel; p_bcolor = &cbFindPanel; bBack = TRUE; break; }
			case 'G' :	{p_color = &ctInfoPanelCell; p_tcolor = &ctInfoPanelCell; bBack = FALSE; break; }
			case 'H' :	{p_color = &cbInfoPanelCell; p_bcolor = &cbInfoPanelCell; bBack = TRUE; break; }
			case 'I' :	{p_color = &ctPanelCursor; p_tcolor = &ctPanelCursor; bBack = FALSE; break; }
			case 'J' :	{p_color = &cbPanelCursor; p_bcolor = &cbPanelCursor; bBack = TRUE; break; }
			case 'K' :	{p_color = &ctSelectItem; p_tcolor = &ctSelectItem; bBack = FALSE; break; }
			case 'L' :	{p_color = &ctSelectItemFind; p_tcolor = &ctSelectItemFind; bBack = FALSE; break; }
			case 'M' :	{p_color = &ctInput; p_tcolor = &ctInput; bBack = FALSE; break; }
			case 'N' :	{p_color = &cbInput; p_bcolor = &cbInput; bBack = TRUE; break; }
			case 'O' :	{p_color = &ctDialog; p_tcolor = &ctDialog; bBack = FALSE; break; }
			case 'P' :	{p_color = &cbDialog; p_bcolor = &cbDialog; bBack = TRUE; break; }
			case 'Q' :	{p_color = &ctError; p_tcolor = &ctError; bBack = FALSE; break; }
			case 'R' :	{p_color = &cbError; p_bcolor = &cbError; bBack = TRUE; break; }
			case 'S' :	{p_color = &ctErrorAttr; p_tcolor = &ctErrorAttr; bBack = FALSE; break; }
			case 'T' :	{p_color = &cbErrorAttr; p_bcolor = &cbErrorAttr; bBack = TRUE; break; }
			case 'U' :	{p_color = &ctSelectedBlock; p_tcolor = &ctSelectedBlock; bBack = FALSE; break; }
			case 'V' :	{p_color = &cbSelectedBlock; p_bcolor = &cbSelectedBlock; bBack = TRUE; break; }
			case 'W' :	{p_color = &ctSmallDrive; p_tcolor = &ctSmallDrive; bBack = FALSE; break; }
			case 'X' :	{p_color = &cbSmallDrive; p_bcolor = &cbSmallDrive; bBack = TRUE; break; }
			case 'Y' :	{p_color = &ctBarForeground; p_tcolor = &ctBarForeground; bBack = FALSE; break; }
			case 'Z' :	{p_color = &cbBarForeground; p_bcolor = &cbBarForeground; bBack = TRUE; break; }

			case '+' :	{
							if(bBack)
							{
								if(*p_color < (15<<4))	(*p_color) +=(1<<4);
								else (*p_color) = 0;
							}
							else
							{
								if(*p_color < 15)	(*p_color)++;
								else (*p_color) = 0;
							}
							break;
						}
			case '-' :	{
							if(bBack)
							{
								if(*p_color > 0)	(*p_color) -=(1<<4);
								else (*p_color) = (15<<4);
							}
							else
							{
								if(*p_color > 0)	(*p_color)--;
								else (*p_color) = 15;
							}
							break;
						}
		}
		
	}
	w.RestoreBG();
}


//------------------------------------------
//
//------------------------------------------


int DialogReminderAddTask(void)
{
	int		retkey,ret;
	short	x = 10;
	short	y = 5;
	char	s_tmp[STR_SIZE];
	char	text_buff[10000];
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput	i_time(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_name(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_color(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_email(GetStdHandle(STD_OUTPUT_HANDLE));
	
	w.Init("Reminder NEW task",x,y,60,11,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x+2,y+2,"time: [dX] [hX] [mX] [dd/mm/yy hh:mm] [hh:mm]");
	clprintf(hC,ctDialog,cbDialog,x+2,y+4,"name:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+6,"color: BUGRVYW");
	clprintf(hC,ctDialog,cbDialog,x+2,y+8,"email address:");

	i_time.Input("H2",x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_name.Input("task X",x + 2,y + 5,56,ctError,cbError,FALSE,TABEND_INIT);
	i_color.Input("W",x + 2,y + 7,2,ctInput,cbInput,FALSE,TABEND_INIT);
	i_email.Input("",x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_INIT);
	while(1)
	{
//		KcEditBuffer( text_buff, 10000, x + 2,y + 6, 56, 5, FALSE );
		retkey = i_time.Input(i_time.GetText(),x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_name.Input(i_name.GetText(),x + 2,y + 5,56,ctError,cbError,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_color.Input(i_color.GetText(),x + 2,y + 7,2,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_email.Input(i_email.GetText(),x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
	}
	w.RestoreBG();
	
	if(retkey == 13)
	{
		ret = ReminderAddTask(i_time.GetText(),i_name.GetText(),*(i_color.GetText()),i_email.GetText() );
		if(ret < 0)
		{
			if(ret == -1) InfoMessage(hC,"Error","No free tasks !");
			if(ret == -2) InfoMessage(hC,"Error","Bad time format !");
		}
		else
		{
			ReminderSaveTasks(g_ini_file);
			sprintf(s_tmp,"[%d] %s",ret,ReminderGetTaskTime(ret));
			InfoMessage(hC,"Reminder task added",s_tmp);
		}
	}
return retkey;	
}


int DialogReminderTaskNotifyEdit(int task,BOOL bEdit)
{
	int		retkey,ret;
	short	x = 10;
	short	y = 5;
	char	s_tmp[STR_SIZE];
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput	i_time(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_name(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_color(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_email(GetStdHandle(STD_OUTPUT_HANDLE));
	
	if(!bEdit)	w.Init("Reminder NOTIFY",x,y,60,17,ctDialog,cbDialog,TRUE);
	else w.Init("Reminder EDIT task",x,y,60,11,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x+2,y+2,"time: [dX] [hX] [mX] [dd/mm/yy hh:mm] [hh:mm]");
	clprintf(hC,ctDialog,cbDialog,x+2,y+4,"name:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+6,"color: BUGRVYW");
	clprintf(hC,ctDialog,cbDialog,x+2,y+8,"email address:");
	if(!bEdit)
	{
		clprintf(hC,ctError,cbError,x+11,y+11,"                                       ");
		clprintf(hC,ctError,cbError,x+11,y+12," !!!!!! >>>>>> it's OVER <<<<<< !!!!!! ");
		clprintf(hC,ctError,cbError,x+11,y+13,"                                       ");
		clprintf(hC,ctError,cbError,x+11,y+14,"                                       ");
		clprintf(hC,ctError,cbError,x+11,y+14,"          %s",ReminderGetTaskTime(task));

		if( g_SMTPServer[0] && strcmp(ReminderGetTaskEmail(task),"") ) {
			CSendMail sm;
			char sbody[2000];
			//sm.SendMail("linux.diz","kulak@definity.cz","kulak@definity.cz","test","je to tady");
			sprintf(sbody,"Kulak Commander send you REMINDER\n");
			strcat(sbody, "--------------------------------------------------------\n\n");
			strcat(sbody, ReminderGetTaskName(task) );
			strcat(sbody, "\n\n--------------------------------------------------------\n\n");
			strcat(sbody, g_MyEmailAddress );
			if( sm.SendMail(g_SMTPServer,g_MyEmailAddress,ReminderGetTaskEmail(task),ReminderGetTaskName(task),sbody) ) {
				clprintf(hC,ctError,cbError,x+38,y+16,"[ mail was sent.. ]");
			} else {
				clprintf(hC,ctError,cbError,x+38,y+15,"[ error send mail.. ]");
			}
		}
	}
	i_time.Input(ReminderGetTaskStrTime(task),x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_name.Input(ReminderGetTaskName(task),x + 2,y + 5,56,ctError,cbError,FALSE,TABEND_INIT);
	s_tmp[0] = g_task[task].color; s_tmp[1] = 0;
	i_color.Input(s_tmp,x + 2,y + 7,2,ctInput,cbInput,FALSE,TABEND_INIT);
	i_email.Input(ReminderGetTaskEmail(task),x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_INIT);
	
	if(!bEdit) ReminderUnactivateTask(task);
	if(!bEdit) SpeekerBeep(2);


	while(1)
	{
		retkey = i_time.Input(i_time.GetText(),x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_name.Input(i_name.GetText(),x + 2,y + 5,56,ctError,cbError,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_color.Input(i_color.GetText(),x + 2,y + 7,2,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_email.Input(i_email.GetText(),x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
	}
	w.RestoreBG();
	
	if(retkey == 13)
	{
		if( bEdit ) ReminderUnactivateTask(task);
		ret = ReminderAddTask(i_time.GetText(),i_name.GetText(),*(i_color.GetText()),i_email.GetText() );
		if(ret < 0)
		{
			if(ret == -1) InfoMessage(hC,"Error","No free tasks !");
			if(ret == -2) InfoMessage(hC,"Error","Bad time format !");
		}
		else
		{
			sprintf(s_tmp,"[%d] %s",ret,ReminderGetTaskTime(ret));
			if(!bEdit) InfoMessage(hC,"Reminder task added",s_tmp);
			else InfoMessage(hC,"Reminder task modified",s_tmp);
		}
	}
	ReminderSaveTasks(g_ini_file);
return retkey;	
}

int DialogReminderListTasks(void)
{
	short	x = 10;
	short	y = 5;
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	int		task;
	int		key;
	char	s_tmp[STR_SIZE];

	task = ReminderFindTask(0);
	if(task == -1)
	{
		InfoMessage(hC,"Info","No tasks defined !");		
		DialogReminderAddTask();
		return 0;
	}

	w.Init("Reminder tasks",x,y,60,11,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x + 23,y + 8,"Next Kill Edit New");
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 23,y + 8,1);
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 28,y + 8,1);
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 33,y + 8,1);
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 40,y + 8,1);

	clprintf(hC,ctDialog,cbDialog,x+2,y+2,"task:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+4,"time:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+6,"name:");

	while(1)
	{

		clprintf(hC,ctPanel,cbPanel,x+8,y+2,"%d ",task);
		clprintf(hC,ctPanel,cbPanel,x+8,y+4,"%s ",ReminderGetTaskTime(task));
		CreateSpaceString(s_tmp,ReminderGetTaskName(task),50);
		clprintf(hC,ctPanel,cbPanel,x+8,y+6,"%s",s_tmp);

		key = toupper(mygetch());
		if(key == 27) break;
		if(key == 'K' && task != -1) 
		{
			ReminderUnactivateTask(task);
			ReminderSaveTasks(g_ini_file);
			key = 'N';
		}
		if(key == 'N' || key == 13) 
		{
			task = ReminderFindTask(task+1);
			if(task == -1) task = ReminderFindTask(0);
			if(task == -1)
			{
				InfoMessage(hC,"Info","No tasks defined !");
				break;
			}
		}
		if(key == 'E')
		{
			DialogReminderTaskNotifyEdit(task,TRUE);
		}
		if(key == 'W')
		{
			DialogReminderAddTask();
		}
	}
	w.RestoreBG();
	
return 0;	
}

int DialogReminderDeleteTask(void)
{
	if( YesNoCancelMessage(GetStdHandle(STD_OUTPUT_HANDLE),"reminder","Delete task ?")=='Y' ) {
		ReminderUnactivateTask(taskPanel.Items[taskPanel.curr].dircompsize);
		ReminderSaveTasks(g_ini_file);
		LoadTaskPanel( &taskPanel );
	}
	return 0;
}


//------------------------------------------
//highLighting EDIT
//------------------------------------------
char* Attr2Str(DWORD dwAttr,char *attr)
{
	int		i = 0;

	if(dwAttr & FILE_ATTRIBUTE_ARCHIVE) attr[i++] = 'A';
	if(dwAttr & FILE_ATTRIBUTE_READONLY) attr[i++] = 'R';
	if(dwAttr & FILE_ATTRIBUTE_HIDDEN) attr[i++] = 'H';
	if(dwAttr & FILE_ATTRIBUTE_SYSTEM) attr[i++] = 'S';
	if(dwAttr & FILE_ATTRIBUTE_COMPRESSED) attr[i++] = 'C';
	if(dwAttr & FILE_ATTRIBUTE_TEMPORARY) attr[i++] = 'T';
	if(dwAttr & FILE_ATTRIBUTE_DIRECTORY) attr[i++] = 'D';
	
	attr[i] = 0;
	return attr;
}

DWORD Str2Attr(char *attr)
{
	DWORD dwAttributes = 0;

	strupr(attr);
	if(strchr(attr,'A')) dwAttributes |= FILE_ATTRIBUTE_ARCHIVE;
	if(strchr(attr,'R')) dwAttributes |= FILE_ATTRIBUTE_READONLY;
	if(strchr(attr,'H')) dwAttributes |= FILE_ATTRIBUTE_HIDDEN;
	if(strchr(attr,'S')) dwAttributes |= FILE_ATTRIBUTE_SYSTEM;
	if(strchr(attr,'C')) dwAttributes |= FILE_ATTRIBUTE_COMPRESSED;
	if(strchr(attr,'T')) dwAttributes |= FILE_ATTRIBUTE_TEMPORARY;
	if(strchr(attr,'D')) dwAttributes |= FILE_ATTRIBUTE_DIRECTORY;
return dwAttributes;
}

int DialogHighLight(void)
{
	int		retkey;
	short	x = 5;
	short	y = 5;
	char	s_tmp[STR_SIZE];
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput	i_1(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_2(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_3(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_4(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_5(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_6(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_7(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_8(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_1a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_2a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_3a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_4a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_5a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_6a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_7a(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput	i_8a(GetStdHandle(STD_OUTPUT_HANDLE));
	
	w.Init("Files highlighting",x,y,70,13,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x+6,y+2,"masks");
	clprintf(hC,ctDialog,cbDialog,x+58,y+1,"attrib");
	clprintf(hC,ctDialog,cbDialog,x+58,y+2,"(ARHSCTD)");

	clprintf(hC,g_ExtHighlight[0].color,cbPanel,x+2,y+3," 1 ");
	clprintf(hC,g_ExtHighlight[1].color,cbPanel,x+2,y+4," 2 ");
	clprintf(hC,g_ExtHighlight[2].color,cbPanel,x+2,y+5," 3 ");
	clprintf(hC,g_ExtHighlight[3].color,cbPanel,x+2,y+6," 4 ");
	clprintf(hC,g_ExtHighlight[4].color,cbPanel,x+2,y+7," 5 ");
	clprintf(hC,g_ExtHighlight[5].color,cbPanel,x+2,y+8," 6 ");
	clprintf(hC,g_ExtHighlight[6].color,cbPanel,x+2,y+9," 7 ");
	clprintf(hC,g_ExtHighlight[7].color,cbPanel,x+2,y+10," 8 ");

	i_1.Input(g_ExtHighlight[0].ext,x + 6,y + 3,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_2.Input(g_ExtHighlight[1].ext,x + 6,y + 4,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_3.Input(g_ExtHighlight[2].ext,x + 6,y + 5,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_4.Input(g_ExtHighlight[3].ext,x + 6,y + 6,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_5.Input(g_ExtHighlight[4].ext,x + 6,y + 7,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_6.Input(g_ExtHighlight[5].ext,x + 6,y + 8,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_7.Input(g_ExtHighlight[6].ext,x + 6,y + 9,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_8.Input(g_ExtHighlight[7].ext,x + 6,y + 10,50,ctInput,cbInput,FALSE,TABEND_INIT);
	i_1a.Input(Attr2Str(g_ExtHighlight[0].attr,s_tmp),x + 58,y + 3,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_2a.Input(Attr2Str(g_ExtHighlight[1].attr,s_tmp),x + 58,y + 4,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_3a.Input(Attr2Str(g_ExtHighlight[2].attr,s_tmp),x + 58,y + 5,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_4a.Input(Attr2Str(g_ExtHighlight[3].attr,s_tmp),x + 58,y + 6,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_5a.Input(Attr2Str(g_ExtHighlight[4].attr,s_tmp),x + 58,y + 7,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_6a.Input(Attr2Str(g_ExtHighlight[5].attr,s_tmp),x + 58,y + 8,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_7a.Input(Attr2Str(g_ExtHighlight[6].attr,s_tmp),x + 58,y + 9,8,ctInput,cbInput,FALSE,TABEND_INIT);
	i_8a.Input(Attr2Str(g_ExtHighlight[7].attr,s_tmp),x + 58,y + 10,8,ctInput,cbInput,FALSE,TABEND_INIT);
	while(1)
	{
		retkey = i_1.Input(i_1.GetText(),x + 6,y + 3,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_1a.Input(i_1a.GetText(),x + 58,y + 3,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_2.Input(i_2.GetText(),x + 6,y + 4,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_2a.Input(i_2a.GetText(),x + 58,y + 4,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_3.Input(i_3.GetText(),x + 6,y + 5,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_3a.Input(i_3a.GetText(),x + 58,y + 5,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_4.Input(i_4.GetText(),x + 6,y + 6,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_4a.Input(i_4a.GetText(),x + 58,y + 6,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_5.Input(i_5.GetText(),x + 6,y + 7,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_5a.Input(i_5a.GetText(),x + 58,y + 7,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_6.Input(i_6.GetText(),x + 6,y + 8,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_6a.Input(i_6a.GetText(),x + 58,y + 8,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_7.Input(i_7.GetText(),x + 6,y + 9,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_7a.Input(i_7a.GetText(),x + 58,y + 9,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_8.Input(i_8.GetText(),x + 6,y + 10,50,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_8a.Input(i_8a.GetText(),x + 58,y + 10,8,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
}
	w.RestoreBG();
	
	if(retkey == 13)
	{
		strcpy(g_ExtHighlight[0].ext,i_1.GetText());
		strcpy(g_ExtHighlight[1].ext,i_2.GetText());
		strcpy(g_ExtHighlight[2].ext,i_3.GetText());
		strcpy(g_ExtHighlight[3].ext,i_4.GetText());
		strcpy(g_ExtHighlight[4].ext,i_5.GetText());
		strcpy(g_ExtHighlight[5].ext,i_6.GetText());
		strcpy(g_ExtHighlight[6].ext,i_7.GetText());
		strcpy(g_ExtHighlight[7].ext,i_8.GetText());

		g_ExtHighlight[0].attr = Str2Attr(i_1a.GetText());
		g_ExtHighlight[1].attr = Str2Attr(i_2a.GetText());
		g_ExtHighlight[2].attr = Str2Attr(i_3a.GetText());
		g_ExtHighlight[3].attr = Str2Attr(i_4a.GetText());
		g_ExtHighlight[4].attr = Str2Attr(i_5a.GetText());
		g_ExtHighlight[5].attr = Str2Attr(i_6a.GetText());
		g_ExtHighlight[6].attr = Str2Attr(i_7a.GetText());
		g_ExtHighlight[7].attr = Str2Attr(i_8a.GetText());
	}
return retkey;	
}


//Dialog priority
void DialogPriority(void)
{

	short	x = 20,ax;
	short	y = 5;
	int		key;
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	DWORD	priority = (DWORD)7777;
	DWORD	old_priority = GetPriorityClass(GetCurrentProcess());

	w.Init("KC priority",x,y,40,8,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x + 3,y + 2,"1) IDLE_PRIORITY_CLASS        ");
	clprintf(hC,ctDialog,cbDialog,x + 3,y + 3,"2) NORMAL_PRIORITY_CLASS      ");
	clprintf(hC,ctDialog,cbDialog,x + 3,y + 4,"3) HIGH_PRIORITY_CLASS        ");
	clprintf(hC,ctDialog,cbDialog,x + 3,y + 5,"4) REALTIME_PRIORITY_CLASS    ");

	switch(old_priority)
	{
		case IDLE_PRIORITY_CLASS :		ax = 0; break;
		case NORMAL_PRIORITY_CLASS :	ax = 1; break;
		case HIGH_PRIORITY_CLASS :		ax = 2; break;
		case REALTIME_PRIORITY_CLASS :	ax = 3; break;
	}
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 3,y + 2 + ax,30);

	while(1)
	{
		priority = 7777;
		key = toupper(mygetch());
		if(key == 27) break;
		switch(key)
		{
			case '1' : priority = IDLE_PRIORITY_CLASS; break;
			case '2' : priority = NORMAL_PRIORITY_CLASS; break;
			case '3' : priority = HIGH_PRIORITY_CLASS; break;
			case '4' : priority = REALTIME_PRIORITY_CLASS; break;
		}
		if(priority != 7777)
		{
			//set priority
			if(priority == REALTIME_PRIORITY_CLASS)
			{
				InfoMessage(hC,"Sorry too danger","Not supported");
				priority = old_priority;
			}
			SetPriorityClass(GetCurrentProcess(),priority);
			clprintf(hC,ctDialog,cbDialog,x + 3,y + 2,"1) IDLE_PRIORITY_CLASS        ");
			clprintf(hC,ctDialog,cbDialog,x + 3,y + 3,"2) NORMAL_PRIORITY_CLASS      ");
			clprintf(hC,ctDialog,cbDialog,x + 3,y + 4,"3) HIGH_PRIORITY_CLASS        ");
			clprintf(hC,ctDialog,cbDialog,x + 3,y + 5,"4) REALTIME_PRIORITY_CLASS    ");

			old_priority = GetPriorityClass(GetCurrentProcess());
			switch(old_priority)
			{
				case IDLE_PRIORITY_CLASS :		ax = 0; break;
				case NORMAL_PRIORITY_CLASS :	ax = 1; break;
				case HIGH_PRIORITY_CLASS :		ax = 2; break;
				case REALTIME_PRIORITY_CLASS :	ax = 3; break;
			}
			SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 3,y + 2 + ax,30);
		}
	}
	w.RestoreBG();
	

}
//------------------------------
//Fast Macros Edit
//--------------------------------
int DialogFastMacros(void)
{
	short	x = 10;
	short	y = 5;
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	int		key,macro_number = 1;
	char	s_tmp[STR_SIZE];

	w.Init("Fast macros list",x,y,60,15,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);

	clprintf(hC,ctDialog,cbDialog,x + 23,y + 6,"Next Edit");
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 23,y + 6,1);
	SetAttribute(hC,ctErrorAttr,cbErrorAttr,x + 28,y + 6,1);

	clprintf(hC,ctDialog,cbDialog,x + 2,y + 8 ,"%%I_[ParamName]  - input parameter ex. %%i_ArchiveName");
	clprintf(hC,ctDialog,cbDialog,x + 2,y + 9 ,"%%SELECTED_[ext] - all selected files in panel");
	clprintf(hC,ctDialog,cbDialog,x + 2,y + 10,"                  [ext] appends behind each file name");
	clprintf(hC,ctDialog,cbDialog,x + 2,y + 11 ,"%%CURRNAME       - current file name without extension");

	while(1)
	{

		clprintf(hC,ctDialog,cbDialog,x+2,y+2,"macro CTRL + %d",macro_number);
		memset(s_tmp,' ',57);
		s_tmp[57] = 0;
		if(g_FastMacro[macro_number])
			CreateSpaceString(s_tmp,g_FastMacro[macro_number],56);
		clprintf(hC,ctPanel,cbPanel,x+2,y+4,"%s",s_tmp);

		key = toupper(mygetch());
		if(key == 27) break;
		if(key == 'N' || key == 13) 
		{
			macro_number = macro_number<9?macro_number+1:0;
		}
		if(key == 'E')
		{
			TInput	i(hC);
			strcpy(s_tmp,"");
			if(g_FastMacro[macro_number]) strcpy(s_tmp,g_FastMacro[macro_number]);
			if(i.Input(s_tmp,x + 2,y + 4,56,ctInput,cbInput) == 13)
			{
				strcpy(g_FastMacro[macro_number],i.GetText());
			}
		}
	}
	w.RestoreBG();
	
return 0;	
}


BOOL RecurseFindMP3( char *mask, char *label, FILE *ff, FILE *fdi )
{
	char s_mask[STR_SIZE] = "*.*";
	char tmp[MAX_PATH];
	BOOL b_found;

	WIN32_FIND_DATA	fd;
	HANDLE	handle;
	long done = TRUE;
	bool dir_changed_flag = true;

	if((handle = FindFirstFile(s_mask, &fd)) != INVALID_HANDLE_VALUE)
	{
		while( done == TRUE )
		{
			if(KeyPressed()) { if(mygetch() == 27) return FALSE; }

			if(strcmp(fd.cFileName,".") && strcmp(fd.cFileName,".."))
			{
				b_found = FALSE;
				if(checkname(fd.cFileName,mask)) {
					b_found = TRUE;
				}
				clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctDialog,cbDialog,10+36,10+2,"%.7ld",g_n_scaned_files++);
				if(b_found)
				{
					if ( dir_changed_flag ) {
						GetCurrentDirectory( MAX_PATH, tmp );
						if ( ff ) {
							fprintf ( ff, "--------------------------------------------------------------------------------\n");
							fprintf ( ff, "[%s] %s\n",label,tmp+3);
							fprintf ( ff, "--------------------------------------------------------------------------------\n");
						}
						if ( fdi ) {
							fprintf ( fdi, "[%s] %s\n",label,tmp+3);
						}
						dir_changed_flag = false;
					}
					if ( ff ) fprintf ( ff, "\t[%s] %s\n",label,fd.cFileName);
				}
				if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					if(SetCurrentDirectory(fd.cFileName))
					{
						dir_changed_flag = true;
						if(!RecurseFindMP3(mask,label,ff,fdi)) return FALSE;
					}
				}
			}
			if((done = FindNextFile( handle, &fd )) != TRUE) {
				SetCurrentDirectory("..");
				dir_changed_flag = true;
			}

		}
	}
	FindClose( handle );
return TRUE;
}



int DialogMP3List(void)
{
	int retkey;
	short x = 10;
	short y = 5;
	char s_mask[STR_SIZE] = "*.*",s_path[STR_SIZE],s_tmp[STR_SIZE],s_searchstr[STR_SIZE]="";


	HANDLE hC = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hC);
	TInput i(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput i_label(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput i_file(GetStdHandle(STD_OUTPUT_HANDLE));
	TInput i_dir(GetStdHandle(STD_OUTPUT_HANDLE));
	
	ffHead.begin = NULL;
	ffHead.end = NULL;
	g_find_files = 0;

	w.Init("Make file list - (mp3 :)...",x,y,60,13,ctDialog,cbDialog,TRUE);
	w.SaveBG();
	w.Show(hC);
	clprintf(hC,ctDialog,cbDialog,x+2,y+2,"path:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+4,"label:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+6,"file name for list of files:");
	clprintf(hC,ctDialog,cbDialog,x+2,y+8,"file name for list of directories:");
	
	strcpy(s_path,aDirectory);
	DeleteLastBackslash(s_path);
	strcat(s_path,"\\");
	strcat(s_path,s_mask);

	i.Input(s_path,x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_label.Input(findString,x + 2,y + 5,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_file.Input(findString,x + 2,y + 7,56,ctInput,cbInput,FALSE,TABEND_INIT);
	i_dir.Input(findString,x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_INIT);
	while(1)
	{
		retkey = i.Input(i.GetText(),x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_label.Input(i_label.GetText(),x + 2,y + 5,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_file.Input(i_file.GetText(),x + 2,y + 7,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
		retkey = i_dir.Input(i_dir.GetText(),x + 2,y + 9,56,ctInput,cbInput,FALSE,TABEND_RUN);
		TEST_RETKEY;
	}
	
	
	w.RestoreBG();
	strcpy(s_path,"");

	if(retkey == 13)
	{
		FILE *ff = NULL;
		FILE *fd = NULL;
		if ( strcmp( i_file.GetText(), "" ) ) ff = fopen (i_file.GetText(),"at");
		if ( strcmp( i_dir.GetText(), "" ) ) fd = fopen (i_dir.GetText(),"at");
		if ( ff || fd) {
			get_2parts_from_end(i.GetText(),s_path,s_mask,'\\');
			if(strcmp(s_mask,""))
			{
				if(strlen(s_path) == 2) strcat(s_path,"\\");
				strcpy(sLastFindMask,s_mask);
				sprintf(s_tmp," Find %s %s",s_mask,findString);
				aWindow->SetLabel(s_tmp);
			
				if(strcmp(s_path,""))
					if(!SetCurrentDirectory(s_path)) return 27;
				
				w.Init("Creating list...",x,y,60,10,ctDialog,cbDialog,TRUE);
				w.SaveBG();
				w.Show(hC);
				clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctDialog,cbDialog,10+3,10+2,"scaned" );
				g_n_scaned_files = 0;
				WaitBegin();
				if ( ff ) {					
					fprintf ( ff, "****************************************\n");
					fprintf ( ff, "|  Label [%s]\n", i_label.GetText());
					fprintf ( ff, "****************************************\n");
				}
				if ( fd ) {					
					fprintf ( fd, "****************************************\n");
					fprintf ( fd, "|  Label [%s]\n", i_label.GetText());
					fprintf ( fd, "****************************************\n");
				}
				RecurseFindMP3(s_mask,i_label.GetText(), ff, fd );

				if (ff) fclose ( ff );
				if (fd) fclose ( fd );
				WaitEnd();
				SetCurrentDirectory(aDirectory);
			}
			else retkey = 27;
		} else {
			InfoMessage(hC,"Error","Cannot create file !");
		}

	}
	w.RestoreBG();
return retkey;	
}
