#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include <time.h>
#include "dialog.h"
#include "edit.h"
#include "globals.h"
#include "misc.h"
#include "dialog.h"
#include "KWindow.h"
#include "input.h"

long			n_sh_types;
TSynHighLight  *syn_high;
long			cur_sh;				//current syntax highlight -1 no sh

long	g_max_file_size = 1000000;

BOOL	g_bReadOnly = FALSE;
BOOL	g_bMultiEdit = FALSE;
BOOL	g_bCheckFileChangeExit = FALSE;
BOOL    g_bBufferMode = TRUE;

BOOL	g_bPutTimeMacro;

//maximal row size is MAX_ROW_LENGTH

#define		ROW_BUFFER_SIZE		5500

#define		MAX_ROW_LENGTH		5000

#define		EDIT_ERROR			0xFFFFFFFF
#define		TAB					0x9

char	*eBuffer;				//editor buffer
DWORD	curr;					//curr pos of cursor
DWORD	currScreen;				//curr pos left top coner of screen
DWORD	shift;					//x shift right
HANDLE	hEditScreen;			//console handles
HANDLE	hBackEditScreen;
HANDLE	*phCurrScreen;			//current screen
HANDLE	hEditIn;
DWORD	dw_filesize;			//file size
DWORD	dw_filesize_orig;			//file size
DWORD	dw_buffersize;			//buffer size for file
DWORD	currColumn;				//current column - changes on LEFT RIGHT END HOME
								// used in UP DOWN

BOOL	bUpdateScreen;			//flag starts ShowScreenText
///*
long	Xstart = 0;				//editor window coordinates
long	Ystart = 1;
long	Xsize = 80;
long	Ysize = 23;
//*/

/*
long	Xstart = 10;				//editor window coordinates
long	Ystart = 5;
long	Xsize = 60;
long	Ysize = 10;
*/

long	curx = Xstart,cury = Ystart;	//current x,y
long	tabSize = 8;			//tabelator size
char	fileName[STR_SIZE];			//file name

long	selectedBlockBegin;
long	selectedBlockEnd;
long	fixedSelectPoint;

long	Bookmarks[10];

DWORD	selCurr;				//when starts selecting 
DWORD	selCurrScreen;			//save to these variables
long	selCurx;
long	selCury;
DWORD	selShift;
long	curRowNumber = 1;
long	curScreenRowNumber = 1;


SHORT	ctrlDown;
BOOL	shiftDown;
BOOL	shiftSelect;
char	editBar[] = "1       2Save   3SNext  4Repl   5Goto   6       7Search 8CR/LF  9LF     10Quit";
char	editCtrlBar[] = "1       2SaveAs 3       4ReplSN 5GotoS  6       7Search 8       9       10    ";
char	editBarRO[] = "1       2       3SNext  4       5Goto   6       7Search 8CR/LF  9LF     10Quit";
char	editCtrlBarRO[] = "1       2       3       4       5GotoS  6       7Search 8       9       10    ";

BOOL	bFileChanged;			//true if file changed
char	findString[STR_SIZE];
char	replString[STR_SIZE];
char	sWordStopChars[STR_SIZE];
char	sGotoLine[STR_SIZE];			//remember goto line
//------------------------------------------------

void LoadIniEHL(char *fname);
BOOL BufferToLFStyle(void);
BOOL BufferToCRLFStyle(void);
long SaveFileAs(void);
long SaveFile(char *fname);
void ClearScreen(HANDLE h);
DWORD FindNextRow(DWORD start);
DWORD FindPrevRow(DWORD start);
DWORD CalcRowSize(long start);
void InsertChar(char ch);
void ShowScreenText(HANDLE h);
long ScanStringsComment(char *buff,long pos,long last_state);
void CalculateLastStateFromFileBegin(char *buff,long end, long &state);
void SyntaxHighlightRow(char *row_buff, WORD *attr_buff,long last_state);
void UpdateCurrentColumn(void);
void RightMove(void);
void LeftMove(void);
void EndRowMove(void);
void HomeRowMove(void);
void HomeFileMove(void);
void EndFileMove(void);
void DownMove(void);
void UpMove(void);
void PageDownMove(void);
void PageUpMove(void);
void DeleteMove(void);
void BackspaceMove( const bool undo );
int	 EditKeyboardLoop(void);
void ShiftBlockSelect(void);
BOOL PutMacroToText(char *text);
DWORD CheckMaxRowSize(DWORD start);
BOOL ReplaceString(void);
BOOL ReloadFile(void);


//-------------------------------------------------
//undo
//-------------------------------------------------

#define MAX_UNDO 10000

#define A_DELETE 1
#define A_BACKSPACE 2
#define A_CHAR 3
#define A_BLOCK_INSERT 4

typedef struct _TUndo{
	long curr;
	int action;
	int size;
	char *buffer;
} TUndo;
TUndo UBuffer[MAX_UNDO];
int USP = 0;

bool UndoClear()
{
	int i;
	for( i = 0; i < USP; i++ ) {
		if( UBuffer[i].buffer ) delete [] UBuffer[USP].buffer;
	}
	USP = 0;
	memset( UBuffer, 0, sizeof(UBuffer) );
	return true;
}

bool UndoShrinkBlock( const long size )
{
	long moved_size = dw_filesize - curr - size;
	memmove((PVOID)(&eBuffer[curr]),(PVOID)(&eBuffer[curr + size]),moved_size);
	dw_filesize -= size;
	return true;
}

bool UndoInsertBlock( const long size, const char *data )
{
	long moved_size = dw_filesize - curr;
	memmove((PVOID)(&eBuffer[curr+size]),(PVOID)(&eBuffer[curr]),moved_size);
	memcpy(&eBuffer[curr],data,size); 
	dw_filesize += size;
	return true;
}

bool UPush( int action, char *data, int size, int currPos )
{
	if(USP>=(MAX_UNDO-1)) UndoClear();
	
	UBuffer[USP].curr = currPos;
	UBuffer[USP].action = action;
	UBuffer[USP].size = size;
	UBuffer[USP].buffer = NULL;
	if( data ) {
		UBuffer[USP].buffer = new char [size+1];
		kASSERT(UBuffer[USP].buffer!=NULL);
		memset(UBuffer[USP].buffer,0,size);
		memcpy(UBuffer[USP].buffer,data,size);
	}
	USP++;
	return true;
}

bool Undo()
{
	int i;
	
	if( USP <= 0 ) return false;
	USP--;
	curr = UBuffer[USP].curr;
	switch(UBuffer[USP].action){
		case A_CHAR : {
			for( i = 0; i < UBuffer[USP].size; i++ ) {
				BackspaceMove( false );
			}
			break;
			}
		case A_DELETE : {
			UndoInsertBlock( UBuffer[USP].size, UBuffer[USP].buffer );
			break;
			}
		case A_BACKSPACE : {
			UndoInsertBlock( UBuffer[USP].size, UBuffer[USP].buffer );
			curr+=UBuffer[USP].size;
			break;
			}
		case A_BLOCK_INSERT : {
			UndoShrinkBlock( UBuffer[USP].size );
			break;
			}
	}
	if( UBuffer[USP].buffer ) {
		delete [] UBuffer[USP].buffer;
	}
	return true;
}
//-------------------------------------------------
//load syntax highlight from file
//-------------------------------------------------
void LoadIniEHL(char *fname)
{
	char	s_tmp[5000],key[STR_SIZE];
	int		i,type;

//load some edit configuration
	GetPrivateProfileString("Kc","max_edit_size","2000000",s_tmp,1000,fname);
	g_max_file_size = atol(s_tmp);
	GetPrivateProfileString("Kc","edit_word_stop_chars","(){};,[]",sWordStopChars,1000,fname);
	strcat(sWordStopChars,"\t\r ");
	

//load SH	
	syn_high = new TSynHighLight;
	kASSERT(syn_high!=NULL);

	for( n_sh_types = 0; ;n_sh_types++)
	{
		sprintf(key,"esh%d_type",n_sh_types);
		if(!GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) break;
	}

	syn_high = new TSynHighLight[n_sh_types];
	kASSERT(syn_high!=NULL);

	for( type = 0; type < n_sh_types ;type++)
	{
		sprintf(key,"esh%d_type",type);
		if(!GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) break;
		strlwr(s_tmp);
		syn_high[type].type = strdup(s_tmp);
		
		syn_high[type].comstart = NULL;
		syn_high[type].comend = NULL;
		syn_high[type].comrow= NULL;
		syn_high[type].string.words = NULL;
		syn_high[type].number.words = NULL;
		sprintf(key,"esh%d_comstart",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) 
		{ 
			syn_high[type].comstart= strdup(s_tmp); 
			syn_high[type].comstart_size = strlen(s_tmp); 
		}
		sprintf(key,"esh%d_comend",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) 
		{			
			syn_high[type].comend= strdup(s_tmp);
			syn_high[type].comend_size = strlen(s_tmp); 
		}
		sprintf(key,"esh%d_comrow",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) 
		{
			syn_high[type].comrow= strdup(s_tmp);
			syn_high[type].comrow_size = strlen(s_tmp); 
		}
		sprintf(key,"esh%d_string",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) syn_high[type].string.words = strdup(s_tmp);
		//build all_chars string for fast SH parsing
		sprintf(s_tmp,"%s%s%s%s",syn_high[type].comstart,syn_high[type].comend,syn_high[type].comrow,syn_high[type].string.words);
		syn_high[type].all_chars = strdup(s_tmp);
		sprintf(key,"esh%d_number",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) syn_high[type].number.words = strdup(s_tmp);
		//
		sprintf(key,"esh%d_comcolor",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) syn_high[type].comcolor = atoi(s_tmp);
		sprintf(key,"esh%d_strcolor",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) syn_high[type].string.c = atoi(s_tmp);
		sprintf(key,"esh%d_numbercolor",type);
		if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname)) syn_high[type].number.c = atoi(s_tmp);
		for( i = 0; i < 15; i++ )
		{
			sprintf(key,"esh%d_color%d",type,i);
			if(GetPrivateProfileString("EditorHighLight",key,"",s_tmp,5000,fname))
			{
				strlwr(s_tmp);
				syn_high[type].color[i].words = strdup(s_tmp);
				syn_high[type].color[i].c = i;
			}
			else
			{
				syn_high[type].color[i].words = NULL;
			}
		}
	}
}


//-------------------------------------------------
//put note macro to text
//-------------------------------------------------
void PutNoteTimeMacro(void)
{
	time_t	tnow;
	tm		*tmtime;
	char	s_tmp[STR_SIZE],s_tmp1[STR_SIZE];

	time(&tnow);
	tmtime = localtime(&tnow);
	strftime(s_tmp,99,"%d-%m-%Y %H:%M:%S",tmtime);
	sprintf(s_tmp1,"_______________________________________________________________________________\r\n%s|\r\n~~~~~~~~~~~~~~~~~~~\r\n\r\n",s_tmp);

	PutMacroToText(s_tmp1);
	DownMove();
	curr = CheckMaxRowSize(curr);
	DownMove();
	curr = CheckMaxRowSize(curr);
	DownMove();
	curr = CheckMaxRowSize(curr);
	bUpdateScreen = TRUE;
	bFileChanged = TRUE;
	
}

DWORD reallocate_buffer( char*& buffer, const DWORD old_size, const DWORD new_size )
{
	char	*buff;

	buff = new char[ new_size ];
	kASSERT(buff!=NULL);
	memcpy( buff, buffer, old_size );
	delete [] buffer;
	buffer = buff;
	return new_size;
}

//-------------------------------------------------
//enter == 0xA
//-------------------------------------------------
BOOL BufferToLFStyle(void)
{
	char	*buff;
	DWORD	i,n=0;
	
	buff = new char[dw_buffersize];
	kASSERT(buff!=NULL);
	if(!buff) return FALSE;
	for(i = 0; i < dw_filesize; i++)
	{
		if(eBuffer[i] != 0xD)
		{
			buff[n++] = eBuffer[i];
		}
	}
	dw_filesize = n;
	delete [] eBuffer;
	eBuffer = buff;
	return TRUE;
}

//-------------------------------------------------
//enter == 0xD,0xA
//-------------------------------------------------
BOOL BufferToCRLFStyle(void)
{
	char	*buff;
	DWORD	i,n=0;

	buff = new char[dw_buffersize];
	kASSERT(buff!=NULL);
	for(i = 0; i < dw_filesize; i++)
	{
		if((eBuffer[i] == 0xA && eBuffer[i-1] != 0xD) || (eBuffer[i] == 0xA && i == 0))
		{
			buff[n++] = 0xD;
		}
		buff[n++] = eBuffer[i];
		if( n + 1000 > dw_buffersize ) {
			dw_buffersize = reallocate_buffer( buff, dw_buffersize, dw_buffersize + 100000 );
		}
	}
	dw_filesize = n;
//#ifndef _MINGW32_
	delete [] eBuffer;
	eBuffer = buff;
return TRUE;
}


//-------------------------------------------------
//Save file as
//-------------------------------------------------
long SaveFileAs(void)
{
	int retkey;
	short x = 10;
	short y = 10;
	KWindow w(*phCurrScreen);
	TInput i(*phCurrScreen);

	w.Init("Save file as",x,y,60,6,ctDialog,cbDialog);
	w.SaveBG();
	w.Show(*phCurrScreen);
	
	retkey = i.Input(fileName,x + 2,y + 3,56,ctInput,cbInput);
	w.RestoreBG();
	if(retkey == 13) 
	{
		strcpy(fileName,i.GetText());
		SaveFile(fileName);
		return TRUE;
	}
	return FALSE;
}

//-------------------------------------------------
//Save file
//-------------------------------------------------
long SaveFile(char *fname)
{
	DWORD	dw_written;
	DWORD	attr = GetFileAttributes(fname);
	HANDLE	hFile;					//file
	
	
	if(attr&FILE_ATTRIBUTE_READONLY && attr!=0xFFFFFFFF)
	{
		char ch = YesNoCancelMessage(*phCurrScreen,"Edit","File is read only - save ?");
		switch(ch)
		{
			case 'Y' : {
							SetFileAttributes(fname,FILE_ATTRIBUTE_NORMAL);
							break;							
					   }
			case 'N' : return 1;
			case 27  : return 1;
		}
	}
	hFile = CreateFile(fname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE) return 1;
	if(!WriteFile(hFile,(LPVOID)eBuffer,dw_filesize,&dw_written,NULL)) return 4;
	CloseHandle(hFile);
	if(attr!=0xFFFFFFFF) SetFileAttributes(fname,attr);
	bFileChanged = FALSE;
return 0;
}

//-------------------------------------------------
//Clear screen
//-------------------------------------------------

void ClearScreen(HANDLE hConsole)
{
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;
	int		i;

	dwWriteCoord.X = (short)Xstart;
	dwWriteCoord.Y = (short)Ystart;
	for(i = 0; i < Ysize; i++)
	{
		dwWriteCoord.X = (short)Xstart;
		dwWriteCoord.Y = (short)Ystart + i;
		FillConsoleOutputCharacter(hConsole,' ', Xsize,dwWriteCoord, &cCharsWritten);
		FillConsoleOutputAttribute(hConsole, cbPanel, Xsize,dwWriteCoord, &cCharsWritten);
	}
}

//-------------------------------------------------
//Clear all screen
//-------------------------------------------------
void ClearAllScreen(HANDLE h)
{
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;

	dwWriteCoord.X = 0;
	dwWriteCoord.Y = 0;
	FillConsoleOutputAttribute(h,T_WHITE_D|B_BLACK_D,80*25,dwWriteCoord, &cCharsWritten);
	dwWriteCoord.X = 0;
	dwWriteCoord.Y = 0;
	FillConsoleOutputCharacter(h,' ',80*25,dwWriteCoord, &cCharsWritten);
}

//-------------------------------------------------
// returns	:	current row
//-------------------------------------------------
long GetCurrentRowNumber(void)
{
	long	i;
	
	curRowNumber = 1;
	curScreenRowNumber = 1;
	
	for( i = 0; i < (long)(curr) && i < (long)dw_filesize-1; i++)
	{
		if(eBuffer[i] == 0xD && eBuffer[i+1] == 0xA) 
		{
			curRowNumber++;
			if( i < (long)currScreen ) curScreenRowNumber++;
		}
	}
return curRowNumber;
}

//-------------------------------------------------
// input	:	where to start
// returns	:	start of next row in file
//-------------------------------------------------
DWORD FindNextRow(DWORD start)
{
	for(DWORD i = start; ; i++ )	
	{
		if(i >= dw_filesize) break;
		if(eBuffer[i] == 0xA && eBuffer[i-1] == 0xD) return (DWORD)(i+1);
	}
	return (EDIT_ERROR);
}

//-------------------------------------------------
// input	:	where to start
// returns	:	start of previous row in file
//-------------------------------------------------
DWORD FindPrevRow(DWORD start)
{
	if(eBuffer[start] == 0xA) start--;
	for(long i = start; ; i-- )	
	{
		if(i <= 0) break;
		if(eBuffer[i] == 0xA && eBuffer[i-1] == 0xD) return (DWORD)(i+1);
	}
	return (EDIT_ERROR);
}

//-------------------------------------------------
// input	:	where to start
// returns	:	size from start of row to start (TAB * tabSize)
//-------------------------------------------------
DWORD CalcRowSize(long start)
{
	long i,size = 0;
	if(start < 0 ) return 0;
	for(i = start; ; i-- )	
	{
		if(eBuffer[i] == 0xA && eBuffer[i-1] == 0xD) break;
		if(i < 0) break; 
	}
	size = 0;
	i++;
	for(;i <= start; i++ )	
	{
		if(eBuffer[i] == TAB) 
		{
			size += (tabSize - ((size)%tabSize));
		}
		else size++;
	}
	return (size);
}

//-------------------------------------------------
// input	:	where to start,size in columns
// returns	:	size in curr
//-------------------------------------------------
DWORD GetNCharsForSize(long start,DWORD maxSize)
{
	long size = 0;
	for(long i = start; ; i++ )	
	{
		if(i >= (long)dw_filesize) break;
		if(eBuffer[i] == 0xA && eBuffer[i-1] == 0xD) break;
		if(eBuffer[i] == TAB) size += (tabSize - ((size)%tabSize));
		else size++;
		if(size >= (long)maxSize) break;
	}
	return (i - start);
}

//-------------------------------------------------
// input	:	where to start
// returns	:	pos
//-------------------------------------------------
DWORD CheckMaxRowSize(DWORD start)
{
	DWORD prev = FindPrevRow(start);
	DWORD size;

	if(prev == EDIT_ERROR) prev = 0;
	size = CalcRowSize(start);

	if(size > MAX_ROW_LENGTH)
	{
		return (DWORD)(prev + GetNCharsForSize(prev,MAX_ROW_LENGTH));
	}
return (DWORD)start;
}

//-------------------------------------------------
// input	:	character
// inserts char to eBuffer to curr position
//-------------------------------------------------
void InsertChar(char ch)
{
	DWORD row_pos;
	DWORD moved_size = dw_filesize - curr;

	if(dw_filesize >= (DWORD)dw_buffersize) return;

	
	switch(ch)
	{
//ENTER
		case 0xD  :	{
					//get how many chars i've to insert
						DWORD start,dw_tmp = FindPrevRow(curr);
						if(dw_tmp == EDIT_ERROR) dw_tmp = 0;
						for	( start = dw_tmp; (eBuffer[start]=='\t' || eBuffer[start]==' ') && eBuffer[start]!=0xD && start < dw_filesize && start < curr; start++);
					//move
						memmove((PVOID)(&eBuffer[curr + 2]),(PVOID)(&eBuffer[curr]),moved_size);
						eBuffer[curr] = 0xD;
						eBuffer[curr+1] = 0xA;
						curr += 2;
						dw_filesize += 2;
					//insert spaces 
						memmove((PVOID)(&eBuffer[curr + (start - dw_tmp)]),(PVOID)(&eBuffer[curr]),(dw_filesize - curr));
						memcpy(&eBuffer[curr],&eBuffer[dw_tmp],start - dw_tmp);
						curr += start - dw_tmp;
						dw_filesize += start - dw_tmp;
						UPush( A_CHAR, NULL,  start - dw_tmp + 1, curr);
					//set flags
						bUpdateScreen = TRUE;
						UpdateCurrentColumn();
						shiftSelect = FALSE;
						ShiftBlockSelect();
						bFileChanged = TRUE;
						break;
					}
	//another char
		default : {
					if(isprint(ch) || ch == TAB)
					{
						UPush( A_CHAR, NULL, 1, curr+1 );
						if(selectedBlockBegin != -1 && selectedBlockEnd != -1 && selectedBlockBegin != selectedBlockEnd) DeleteMove();
						memmove((PVOID)(&eBuffer[curr + 1]),(PVOID)(&eBuffer[curr]),moved_size);
						eBuffer[curr] = ch;
						curr++;
						row_pos = CalcRowSize(curr);
						dw_filesize ++;
						bUpdateScreen = TRUE;
						UpdateCurrentColumn();
						shiftSelect = FALSE;
						ShiftBlockSelect();
						bFileChanged = TRUE;
					}
					break;
				  }
	}//switch
	
}

//-------------------------------------------------
//  shows bookmarks
//-------------------------------------------------

void ShowBookmarks(HANDLE h)
{
	WORD	attr[STR_SIZE];
	int		i,j;
	for (i = 0; i < 10; i++)
	{
//		if
		if((Bookmarks[i] >= curScreenRowNumber)  && (Bookmarks[i] < (long)(curScreenRowNumber + Ysize)) )
		{
			ReadAttribute(h,attr,(short)Xstart+Xsize-4,(short)(Bookmarks[i]-curScreenRowNumber+Ystart),4);
			for ( j = 0 ; j < 4; j++) attr[j] = attr[j]&0xF|cbPanelCursor;
			WriteAttribute(h,attr,(short)Xstart+Xsize-4,(short)(Bookmarks[i]-curScreenRowNumber+Ystart),4);
		}
	}
}

//-------------------------------------------------
//  shows sreen from currScreen position
//-------------------------------------------------

//pokud to bucha tak sem pravdepodobne prelejza nekde
//row_buff
//je potreba po vsech akcich volat
//curr = CheckMaxRowSize(curr);

void ShowScreenText(HANDLE h)
{
	DWORD	curtmp = currScreen;	
	long	x;
	long   y = Ystart;
	long	i;
	DWORD	j,jjj;
	char	ch,ch1,ch2;
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;
	char	row_buff[ROW_BUFFER_SIZE];
	WORD	row_buff_attr[ROW_BUFFER_SIZE];
	long	row_buff_size;

	//for syntax highlightingn
	long	state = 0;
	long	last_state = 0;
	if (cur_sh != -1) CalculateLastStateFromFileBegin(eBuffer,currScreen,state);

	ClearScreen(h);
	for(i = 0; i < Ysize; i++)
	{
		last_state = state;
		x = 0;
		memset(row_buff,0,ROW_BUFFER_SIZE);
		memset(row_buff_attr,0,ROW_BUFFER_SIZE*sizeof(WORD));
		for(j = 0; ;j++)
		{
			if(curtmp >= dw_filesize) break;
			ch = eBuffer[curtmp];
			ch1 = eBuffer[curtmp - 1];
			ch2 = eBuffer[curtmp + 1];
			if(x < (long)(Xsize+shift)) 
			{
				if(ch == TAB) 
				{
					jjj = tabSize - ((x)%tabSize);
//					jjj = tabSize;
					memset(&row_buff[x],' ',jjj);
					if(curtmp >= (DWORD)selectedBlockBegin && curtmp <= (DWORD)selectedBlockEnd && selectedBlockEnd != -1 && selectedBlockBegin != -1)
					{
						for(DWORD attr = x; attr < (DWORD)(x+jjj); attr++) row_buff_attr[attr] = (WORD)ctSelectedBlock|cbSelectedBlock;
					}
					else
					{
						for(DWORD attr = x; attr < (DWORD)(x+jjj); attr++) row_buff_attr[attr] = ctPanel|cbPanel;
					}
					x += jjj;
				}
				else 
				{
//ch1 ch2 !!!! may be error
					if((ch != 0xA && ch1 != 0xD) && (ch != 0xD && ch2 != 0xA))
					{
						if(isprint(ch)) row_buff[x] = ch;
						else row_buff[x] = ' ';
						row_buff[x] = ch;
						if(curtmp >= (DWORD)selectedBlockBegin && curtmp <= (DWORD)selectedBlockEnd && selectedBlockEnd != -1 && selectedBlockBegin != -1)
							row_buff_attr[x] = ctSelectedBlock|cbSelectedBlock;
						else
							row_buff_attr[x] = ctPanel|cbPanel;
						x++;
					}
				}	
			}
			//for syntax highlighting
			if (cur_sh != -1) state = ScanStringsComment(eBuffer,curtmp,state);
			curtmp++;
			if(curtmp >= dw_filesize) break;
			if(ch == 0xA && ch1 == 0xD) break;
		}
		row_buff_size = x - shift;
		if(row_buff_size < 0) row_buff_size = 0;
		if(row_buff_size > Xsize) row_buff_size = (DWORD)Xsize;
		dwWriteCoord.X = (short)Xstart;
		dwWriteCoord.Y = (short)y;

		SyntaxHighlightRow(row_buff, row_buff_attr,last_state);
		WriteConsoleOutputAttribute(h,row_buff_attr+shift,row_buff_size,dwWriteCoord, &cCharsWritten);
		WriteConsoleOutputCharacter(h,row_buff+shift,row_buff_size,dwWriteCoord, &cCharsWritten);
		if(curtmp >= dw_filesize) return;
		y++;
	}
}
//-------------------------------------------------
//  syntax highlighting
//-------------------------------------------------
#define		IN_START_FLAG	0
#define		IN_CODE			1
#define		IN_STRING		2
#define		IN_COMMENT		3
#define		IN_ROW_COMMENT	4
#define		IN_NUMBER		5

long ScanStringsComment(char *buff,long pos,long last_state)
{
	//on the end of line cancel row comment and string
	if ( (buff[pos] == 0xD && buff[pos+1] == 0xA) || buff[pos] == 0) 
	{
		if ( last_state == IN_ROW_COMMENT 
			|| last_state == IN_STRING
			|| last_state == IN_NUMBER ) return IN_CODE;
		return last_state;
	}
	//start comment
	if( syn_high[cur_sh].comstart && !memcmp(&buff[pos],syn_high[cur_sh].comstart,syn_high[cur_sh].comstart_size) )
	{
		switch (last_state)
		{
			case IN_ROW_COMMENT :
			case IN_COMMENT : { return IN_COMMENT; break;}
			case IN_STRING : { return IN_STRING; break;}
			case IN_START_FLAG :
			case IN_NUMBER :
			case IN_CODE : { return IN_COMMENT; break;}
		}
	}
	//end comment
	if ( pos - syn_high[cur_sh].comend_size + 1>= 0)
	{
		if( syn_high[cur_sh].comend && !memcmp(&buff[pos-syn_high[cur_sh].comend_size+1],syn_high[cur_sh].comend,syn_high[cur_sh].comend_size)  )
		{
			switch (last_state)
			{
				case IN_COMMENT : { return IN_CODE; break;}
				case IN_STRING : { return IN_COMMENT; break;}
				case IN_START_FLAG :
				case IN_NUMBER :
				case IN_CODE : { return IN_CODE; break;}
			}
		}
	}
	//row comment
	if( syn_high[cur_sh].comrow && !memcmp(&buff[pos],syn_high[cur_sh].comrow,syn_high[cur_sh].comrow_size) )
	{
			switch (last_state)
			{
				case IN_COMMENT : { return IN_COMMENT; break;}
				case IN_STRING : { return IN_STRING; break;}
				case IN_START_FLAG :
				case IN_NUMBER :
				case IN_CODE : { return IN_ROW_COMMENT; break;}
			}
	}
	//string
	if ( syn_high[cur_sh].string.words && buff[pos] == *syn_high[cur_sh].string.words)
	{
		if (syn_high[cur_sh].string.words[1] == 0 || pos == 0 ||  (buff[pos-1] != syn_high[cur_sh].string.words[1]) )
		switch (last_state)
		{
			case IN_COMMENT : { return IN_COMMENT; break;}
			case IN_STRING : { return IN_CODE; break;}
			case IN_START_FLAG :
			case IN_NUMBER :
			case IN_CODE : { return IN_STRING; break;}
		}
	}
	//number
	if ( syn_high[cur_sh].number.words && strchr(syn_high[cur_sh].number.words,(int)buff[pos]) )
	{
		switch (last_state)
		{
			case IN_COMMENT : { return IN_COMMENT; break;}
			case IN_STRING : { return IN_STRING; break;}
			case IN_START_FLAG :
			case IN_CODE : { 
							if ( pos != 0 && !iscsym(buff[pos-1]) && isdigit(buff[pos]) ) return IN_NUMBER;
							else return IN_CODE; 
							break;
						   }
			case IN_NUMBER : { return IN_NUMBER; break;}
		}
	}
	
	if (last_state == IN_NUMBER) last_state = IN_CODE;

return last_state;
}

void ScanLineCommentString(char *rowbuff, WORD *attrbuff,long st)
{
	long state = st;
	long last_state = state;
	WORD	color;	
	for(long i = 0; ; i++ )
	{
		last_state = state;
		state = ScanStringsComment(rowbuff,i,last_state);
		color = attrbuff[i];
		switch(state)
		{
			case IN_COMMENT : 
			case IN_ROW_COMMENT : 	color = syn_high[cur_sh].comcolor; break;
			case IN_STRING : color = syn_high[cur_sh].string.c; break;
			case IN_NUMBER : color = syn_high[cur_sh].number.c; break;
			case IN_CODE : 
			{
				if ( last_state == IN_COMMENT ) color = syn_high[cur_sh].comcolor;
				if ( last_state == IN_STRING ) color = syn_high[cur_sh].string.c;
				break;
			}
		}
//if no selected set color		
		if ( (attrbuff[i] & 0xF) != ctSelectedBlock)
		{
			attrbuff[i] &= 0xFFF0;
			attrbuff[i] |= color;
		}
		
		if ( (rowbuff[i] == 0xA && rowbuff[i+1] == 0xD) || rowbuff[i] == 0) break;
	}
}

//-------------------------------------------------
//calculate last state for sh
//for current screen fom file begin
//-------------------------------------------------
void CalculateLastStateFromFileBegin(char *buff,long end, long &state)
{
	char	*p = buff;
	register long pos;
	while(1)
	{
		p = strpbrk(p,syn_high[cur_sh].all_chars);
		pos = p - buff;
		if ( !p || pos >= end ) break;
		state = ScanStringsComment(buff,pos,state);
		p++;
	}
	if(state == IN_ROW_COMMENT) state = IN_CODE;
}

void ScanLine(char *word,WORD color,char *rowbuff,WORD *attrbuf)
{
	char			*p = rowbuff;
	long			word_size;
	register int	i;
	int				end;
	int				row_size = strlen(rowbuff);
	while(1)
	{
		word_size = strlen(word);
//test digits
//		if (word_size == 1 && isdigit(word[0]))
//		{
//		}
//test words		
		if (word[0] == ' ')
		{
			if ( (p = strstr(p,word+1)) == NULL || (p - rowbuff) >= row_size ) break;
			else
			{
				int ia = isalpha(*(p-1));
				if(p != rowbuff && isalpha(*(p-1)) ) {p++; continue; }
				word_size--;
				if(isalpha(*(p+word_size)) ) {p++; continue; }
			}
		}
		else
		{
			if ( (p = strstr(p,word)) == NULL || (p - rowbuff) >= row_size ) break;
		}
//select text hl
		for ( i = (p - rowbuff),end = ((p - rowbuff) + word_size) ; i < end ; i++ )
		{
			if ( (attrbuf[i] & 0xF) != ctSelectedBlock)
			{
				attrbuf[i] &= 0xFFF0;
				attrbuf[i] |= color;
			}
		}
		p++;
	}
}

void SyntaxHighlightRow(char *row_buff, WORD *attr_buff,long last_state)
{
	char	char_set[] = ",";
	char	s_tmp[5000];
	char	s_tmprow[5000];
	char	*pw,*pw_last;

	if(cur_sh == -1) return;

	for(int i = 0; i < 15; i++)
	{
		if(syn_high[cur_sh].color[i].words)
		{
			strcpy(s_tmp,syn_high[cur_sh].color[i].words);
			memcpy(s_tmprow,row_buff,4999); s_tmprow[4999] = 0;
			strlwr(s_tmprow);
			pw = s_tmp;
			pw_last = s_tmp;
			while(1)
			{	
				pw = strpbrk(pw_last,char_set);
				if(pw) *pw=0;
				else break;
				ScanLine(pw_last,syn_high[cur_sh].color[i].c,s_tmprow,attr_buff);
				pw_last = pw + 1;
			}
		}
	}
	ScanLineCommentString(row_buff, attr_buff,last_state);
}

//-------------------------------------------------
// Refresh bar
//-------------------------------------------------
void InitTopBar(HANDLE h)
{
	DWORD	cCharsWritten;
	COORD	coord;

	if( !g_bBufferMode ) {
		coord.X = 0;
		coord.Y = 0;
		FillConsoleOutputAttribute(h,T_BLACK_D|B_WHITE_D,80,coord, &cCharsWritten);
		coord.X = 0;
		coord.Y = 0;
		FillConsoleOutputCharacter(h,' ',80,coord, &cCharsWritten);
	}
}

void RefreshTopBar(HANDLE h)
{
	DWORD col;

	if( !g_bBufferMode ) {
		col = CalcRowSize(curr);

		clprintf(h,T_BLACK_D,B_WHITE_D,0,0,"Edit: %s    ",fileName);
	//	clprintf(h,T_BLACK_D,B_WHITE_D,28,0,"%c",eBuffer[curr]);
		clprintf(h,T_BLACK_D,B_WHITE_D,35,0,"Line: %5ld  Col: %4lu",curRowNumber,col);
	//	clprintf(h,T_BLACK_D,B_WHITE_D,45,0,"%3lu%%",p);
	//	clprintf(h,T_BLACK_D,B_WHITE_D,50,0,"POS: %.7lu",curr);
		clprintf(h,T_BLACK_D,B_WHITE_D,65,0,"Size: %7lu",dw_filesize);
	}
}

void DrawEditBar(HANDLE h,char *bar)
{
	COORD dwWriteCoord;
	DWORD cCharsWritten;

	if( !g_bBufferMode ) {
		dwWriteCoord.X = 0;
		dwWriteCoord.Y = 24;
		WriteConsoleOutputCharacter(h,bar,strlen(bar),dwWriteCoord, &cCharsWritten);

		dwWriteCoord.X = 0;
		dwWriteCoord.Y = 24;
		FillConsoleOutputAttribute(h,ctBarBackground|cbBarBackground, 80,dwWriteCoord, &cCharsWritten);
		for( int i = 0 ; i < 80 ; i+=8 )
		{
			if(i<70) dwWriteCoord.X = i+1;
			else dwWriteCoord.X = i+2;
			FillConsoleOutputAttribute(h,ctBarForeground|cbBarForeground, 6,dwWriteCoord, &cCharsWritten);
		}
	}
}


//-------------------------------------------------
// udates currColumn
//-------------------------------------------------
void UpdateCurrentColumn(void)
{
	DWORD dw;
		

	dw = FindPrevRow(curr);
	if(dw == EDIT_ERROR) dw = 0;
	currColumn = curr - dw;
}

//-------------------------------------------------
//  when you press VK_RIGHT
//-------------------------------------------------
void RightMove(void)
{
	if(curr >= dw_filesize) return;
	curr++;
	//jump to next row
	if(eBuffer[curr] == 0xA && eBuffer[curr-1] == 0xD)	
	{
		if(eBuffer[curr+1] != 0xA) curr++;
	}
}

//-------------------------------------------------
//  when you press CTRL + VK_RIGHT
//-------------------------------------------------
void RightMoveWord(void)
{
	DWORD i;

	if(eBuffer[curr] == ' ')
	{
		for(i = curr; i < dw_filesize && eBuffer[i] == ' '; i++);
	}
	else
	{
		for(i = curr; i < dw_filesize && !strchr(sWordStopChars,eBuffer[i]); i++);
		if(i == curr)
			for(i = curr + 1; i < dw_filesize && !strchr(sWordStopChars,eBuffer[i]); i++);
		
	}
	if(i > dw_filesize) curr = dw_filesize;
	else curr = i;
}


//-------------------------------------------------
//  when you press VK_LEFT
//-------------------------------------------------
void LeftMove(void)
{
	if(curr == 0 || curr > 0x80000000) return;
	curr--;
	
	if(eBuffer[curr] == 0xA) curr--;
}

//-------------------------------------------------
//  when you press CTRL + VK_LEFT
//-------------------------------------------------
void LeftMoveWord(void)
{
	DWORD i;

	if(curr == 0 || curr > 0x80000000) return;

	if((eBuffer[curr] == ' ' && eBuffer[curr-1] == ' ') || (eBuffer[curr] != ' ' && eBuffer[curr-1] == ' '))
	{
		if(eBuffer[curr] != ' ' && eBuffer[curr-1] == ' ') i = curr - 1;
		else i = curr;
		for(; i > 0 && eBuffer[i] == ' '; i--);
		i++;
	}
	else
	{
		for(i = curr; i > 0 && !strchr(sWordStopChars,eBuffer[i]); i--);
		if(i == curr)
		{
			for(i = curr - 1; i > 0 && !strchr(sWordStopChars,eBuffer[i]); i--);
		}
//		if(eBuffer[i] != 0xD && i != 0) i++;
	}	
	
	if(i == 0 || i > 0x80000000) curr = 0;
	else curr = i;
}

//-------------------------------------------------
//  when you press VK_END
//-------------------------------------------------
void EndRowMove(void)
{
	DWORD next = FindNextRow(curr);

	if(next == EDIT_ERROR) next = dw_filesize;
	else next -= 2;
	curr = next;

}

//-------------------------------------------------
//  when you press VK_HOME
//-------------------------------------------------
void HomeRowMove(void)
{
	DWORD prev = FindPrevRow(curr);
	if(prev == EDIT_ERROR) prev = 0;
	curr = prev;
}

//-------------------------------------------------
//  when you press CTRL + VK_HOME
//-------------------------------------------------
void HomeFileMove(void)
{
	curr = 0;
}

//-------------------------------------------------
//  when you press CTRL + VK_END
//-------------------------------------------------
void EndFileMove(void)
{
	curr = dw_filesize;
}

//-------------------------------------------------
//  when you press VK_DOWN
//-------------------------------------------------
void DownMove(void)
{
	DWORD xpos_new;
	DWORD new_row_size;
	
	xpos_new = FindNextRow(curr);
	if(xpos_new != EDIT_ERROR)
	{
		if(xpos_new > dw_filesize) xpos_new = dw_filesize;
		new_row_size = FindNextRow(xpos_new);
		if(new_row_size == EDIT_ERROR)
			new_row_size = dw_filesize - xpos_new;
		else new_row_size -= xpos_new;
		if(new_row_size >= 2) new_row_size -= 2;

		if(currColumn > new_row_size) curr = xpos_new + new_row_size;
		else  curr = xpos_new + currColumn;
	}//if(xpos_new != EDIT_ERROR)
}

//-------------------------------------------------
//  when you press VK_UP
//-------------------------------------------------
void UpMove(void)
{
	DWORD xpos_new;
	DWORD new_row_size = FindPrevRow(curr);

	if(new_row_size != EDIT_ERROR)
	{
		xpos_new = FindPrevRow(new_row_size - 1);
		if(xpos_new == EDIT_ERROR)
			xpos_new = 0;
		else new_row_size -= xpos_new;
		if(new_row_size >= 2) new_row_size -= 2;
		//set curr
		if(currColumn > new_row_size) curr = xpos_new + new_row_size;
		else  curr = xpos_new + currColumn;
	}//if(xpos_new != EDIT_ERROR)
}

//-------------------------------------------------
//  when you press VK_NEXT (PAGE DOWN)
//-------------------------------------------------
void PageDownMove(void)
{
	long i;

	//are you on the end
	if(cury >= (long)(Ysize + Ystart - 1))
	{
		for( i = 0; i < Ysize - 1; i++)
		{
			curr = FindNextRow(curr);
			//if error goto end of file
			if(curr == EDIT_ERROR) 
			{
				curr = dw_filesize;
				return;
			}
		}
	}
	else
	{
	//go down		
		for( i = 0; i < Ysize - 1; i++)
		{
			curr = FindNextRow(curr);
			if(curr == EDIT_ERROR) 
			{
				curr = dw_filesize;
				return;
			}
		}
		
	}
}

//-------------------------------------------------
//  when you press VK_PRIOR (PAGE UP)
//-------------------------------------------------
void PageUpMove(void)
{
	long i;
	
	if(curr == 0 || curr > 0x80000000) 
	{
		curr = 0;
		return;
	}
	//are you on the top of page
	if(cury <= Ystart)
	{
		for( i = 0; i < Ysize - 1; i++)
		{
			//if error goto end of file
			if(curr == EDIT_ERROR || curr <= 0) 
			{
				curr = 0;
				return;
			}
			curr = FindPrevRow(curr-1);
			if(curr == EDIT_ERROR || curr <= 0) 
			{
				curr = 0;
				return;
			}
		}
		currScreen = curr;
		bUpdateScreen = TRUE;
	}
	else
	{
	//go up		
		curr = currScreen;
	}
}

//-------------------------------------------------
//  when you press VK_DELETE
//-------------------------------------------------
void DeleteMove(void)
{
	long moved_size = dw_filesize - curr;

	if(g_bReadOnly) return;

	if(selectedBlockBegin != -1 && selectedBlockEnd != -1)
	{
		UPush( A_DELETE, &eBuffer[selectedBlockBegin], selectedBlockEnd - selectedBlockBegin + 1, selectedBlockBegin );
		moved_size = dw_filesize - selectedBlockEnd;
		if(moved_size < 0) moved_size = 0;
		memmove((PVOID)(&eBuffer[selectedBlockBegin]),(PVOID)(&eBuffer[selectedBlockEnd+1]),moved_size);
		dw_filesize -= (selectedBlockEnd - selectedBlockBegin ) + 1;

		//when you are on the end of the block
		//move pointer to begin
		if(curr == (DWORD)selectedBlockEnd || curr == (DWORD)selectedBlockEnd+1)	
		{
			curr = selCurr;
			currScreen = selCurrScreen;
			curx = selCurx;
			cury = selCury;
			shift = selShift;
		}
		if(curr >= dw_filesize) 
		{
			EndFileMove();
			bUpdateScreen = TRUE;
		}
		selectedBlockBegin = -1;
		selectedBlockEnd = -1;
		bUpdateScreen = TRUE;
	}
	else
	{
		if(curr < dw_filesize)
		{
			if(eBuffer[curr + 1] == 0xA && eBuffer[curr] == 0xD)
			{								
				UPush( A_DELETE, &eBuffer[curr], 2, curr );
				memmove((PVOID)(&eBuffer[curr]),(PVOID)(&eBuffer[curr + 2]),moved_size);
				dw_filesize -= 2;
			}
			else 
			{
				UPush( A_DELETE, &eBuffer[curr], 1, curr );
				memmove((PVOID)(&eBuffer[curr]),(PVOID)(&eBuffer[curr + 1]),moved_size);
				dw_filesize--;
			}
			bUpdateScreen = TRUE;
		}
	}
}

//-------------------------------------------------
//  when you press VK_BACKSPACE
//-------------------------------------------------
void BackspaceMove( const bool undo = true )
{
	DWORD	moved_size = dw_filesize - curr;

	if(curr > 0)
	{
		LeftMove();
		if(eBuffer[curr + 1] == 0xA && eBuffer[curr] == 0xD)
		{								
			if( undo ) UPush( A_BACKSPACE, &eBuffer[curr], 2, curr );
			memmove((PVOID)(&eBuffer[curr]),(PVOID)(&eBuffer[curr + 2]),moved_size);
			dw_filesize -= 2;
		}
		else 
		{
			if( undo ) UPush( A_BACKSPACE, &eBuffer[curr], 1, curr);
			memmove((PVOID)(&eBuffer[curr]),(PVOID)(&eBuffer[curr + 1]),moved_size);
			dw_filesize--;
		}
		bUpdateScreen = TRUE;
	}
}

//-------------------------------------------------
//  put block to clipboard
//-------------------------------------------------
BOOL PutBlockToClipboard(void)
{
	HGLOBAL hglbCopy; 
    LPTSTR  lptstrCopy; 

	if(selectedBlockBegin != -1 && selectedBlockEnd != -1)
	{
		if(!OpenClipboard(NULL)) return FALSE;
		EmptyClipboard();
		hglbCopy = GlobalAlloc(GMEM_DDESHARE, (selectedBlockEnd - selectedBlockBegin + 2) * sizeof(char)); 
		if(!hglbCopy) 
		{
			CloseClipboard(); return FALSE;
		}
		lptstrCopy = (LPTSTR)GlobalLock((HGLOBAL)hglbCopy); 
		memcpy(lptstrCopy, &eBuffer[selectedBlockBegin], (selectedBlockEnd - selectedBlockBegin + 1) * sizeof(TCHAR)); 
		GlobalUnlock(hglbCopy); 
		
		SetClipboardData(CF_TEXT, hglbCopy); 
		CloseClipboard(); 
	}
return TRUE;
}

//-------------------------------------------------
//  get block from clipboard
//-------------------------------------------------
BOOL GetBlockFromClipboard(void)
{
    HGLOBAL	hglbCopy; 
    LPTSTR  lptstrCopy; 
	UINT	format = 0;
	DWORD	size;
	DWORD	moved_size = dw_filesize - curr;

//if read only go out
	if(g_bReadOnly) return FALSE;

	if(!OpenClipboard(NULL)) return FALSE;
	format = EnumClipboardFormats(CF_TEXT);
	if(!format)
	{
		CloseClipboard(); return FALSE;
	}
	hglbCopy = (HGLOBAL)GetClipboardData(CF_TEXT); 
	lptstrCopy = (LPTSTR)GlobalLock((HGLOBAL)hglbCopy); 
	size = strlen(lptstrCopy);
	if(dw_buffersize > (DWORD)(size+dw_filesize))
	{
		memmove((PVOID)(&eBuffer[curr+size]),(PVOID)(&eBuffer[curr]),moved_size);
		memcpy(&eBuffer[curr],lptstrCopy,size); 
		dw_filesize += size;
	}
	UPush( A_BLOCK_INSERT, NULL, size, curr );
	GlobalUnlock(hglbCopy); 

	
	CloseClipboard(); 
return TRUE;
}


//-------------------------------------------------
//  Put Macro to text
//-------------------------------------------------
BOOL PutMacroToText(char *text)
{
	DWORD	size;
	DWORD	moved_size = dw_filesize - curr;

//if read only go out
	if(g_bReadOnly) return FALSE;

	size = strlen(text);
	if(dw_buffersize > (DWORD)(size+dw_filesize))
	{
		memmove((PVOID)(&eBuffer[curr+size]),(PVOID)(&eBuffer[curr]),moved_size);
		memcpy(&eBuffer[curr],text,size); 
		dw_filesize += size;
	}
return TRUE;
}


//-------------------------------------------------
//  shift + move = select
//-------------------------------------------------
void ShiftBlockSelect(void)
{
	if(shiftDown && shiftSelect)
	{
		//select
		if(fixedSelectPoint < (long)curr)
		{
			LeftMove();
			curr = CheckMaxRowSize(curr);
			
			selectedBlockBegin = fixedSelectPoint;
			selectedBlockEnd = curr;
			if(selectedBlockEnd >= (long)dw_filesize) selectedBlockEnd = dw_filesize - 1;

			RightMove();
			curr = CheckMaxRowSize(curr);
		}
		else
		{
			selectedBlockBegin = curr;
			selectedBlockEnd = fixedSelectPoint;
			if(selectedBlockEnd >= (long)dw_filesize) selectedBlockEnd = dw_filesize - 1;
		}
		if(eBuffer[selectedBlockEnd] == 0xD && eBuffer[selectedBlockEnd+1] == 0xA && selectedBlockEnd<(long)dw_filesize) selectedBlockEnd++;
		bUpdateScreen = TRUE;
	}
	else 
	{
		shiftSelect = FALSE;
		if(selectedBlockBegin != - 1 || selectedBlockEnd != -1)
		{
			selectedBlockBegin = - 1;
			selectedBlockEnd = - 1;
			bUpdateScreen = TRUE;
		}
	}
}

//-------------------------------------------------
//  recalculates cursor coords
//	in	:	currScreen,curr,curx,cury,shift
//	out :	curx,cury,shift
//-------------------------------------------------
void RecalculateCurXY(void)
{
	long	tmp;
	long	x,y;
	long	i;

	//calculate y
	tmp = currScreen;
	y = Ystart;
	//if curr pos is behind currScreen	
	if(curr < currScreen)
	{
		while(1)
		{
			if(tmp <= (long)curr && tmp > 0) break;
			if(tmp == EDIT_ERROR) {tmp = 0; break;}
			tmp = FindPrevRow(tmp-1);
		}
		currScreen = tmp;
		bUpdateScreen = TRUE;
	}
	else
	{
		while(1)
		{
			if(tmp > (long)curr) break;
			tmp = FindNextRow(tmp);
			if(tmp > (long)curr || tmp == EDIT_ERROR) break;
			y++;
		}
	}
	//calculate y & currScreen
	if(y > Ysize + Ystart - 1 )
	{
		tmp = currScreen;
		for( i = 0; i < (y - (Ysize + Ystart - 1) ); i++) tmp = FindNextRow(tmp);
		currScreen = tmp;
		y -= (y - Ysize - Ystart + 1 );
		bUpdateScreen = TRUE;
	}
	//calculate x
	if(eBuffer[curr] == TAB) tmp = CalcRowSize(curr - 1);
	else 
	{
		tmp = CalcRowSize(curr);
		if(tmp > 0) tmp--; 
	}
	x = (long)tmp + Xstart;
	if(x == 0)
	{
		shift = 0;
		bUpdateScreen = TRUE;
	}
	if(tmp < (long)shift)
	{
		shift = tmp;
		x = Xstart;
		bUpdateScreen = TRUE;
	}
	else
	{
		if(Xsize <= (long)(tmp - shift))
		{
			//recalculate shift
			shift = tmp - ( Xsize - 1);	
			x = (long)(tmp - shift + Xstart);
			bUpdateScreen = TRUE;
		}
		else
		{
			if(shift) x = (long)(tmp - shift + Xstart);
		}
	}
	curx = x;
	cury = y;
}

//-------------------------------------------------
//  goto line
//-------------------------------------------------
void SetCurrentRow(long line)
{
	long	ii,row = 1;
	
	if(line < 1) line = 1;
	for( ii = 0; ii < (long)dw_filesize; ii++)
	{
		if(eBuffer[ii] == 0xD && eBuffer[ii+1] == 0xA) row++;
		if(row == line) break;
	}
	curr = ii;
	if(curr < (dw_filesize-1)) curr+=2;
	bUpdateScreen = TRUE;

}

//-------------------------------------------------
//  goto line
//-------------------------------------------------
BOOL GotoLine(void)
{
	int retkey;
	short x = 30;
	short y = 10;
	KWindow w(*phCurrScreen);
	TInput i(*phCurrScreen);

	w.Init("Goto line",x,y,20,3,ctDialog,cbDialog);
	w.SaveBG();
	w.Show(*phCurrScreen);
	
	retkey = i.Input(sGotoLine,x + 2,y + 1,16,ctInput,cbInput);
	w.RestoreBG();
	if(retkey == 13) 
	{
		strcpy(sGotoLine,i.GetText());
		long	line = atol(i.GetText());
		SetCurrentRow(line);
	}
return FALSE;
}

//-------------------------------------------------
//  get find string
//-------------------------------------------------
BOOL FindInputString(void)
{
	int retkey;
	short x = 10;
	short y = 10;
	KWindow w(*phCurrScreen);
	TInput i(*phCurrScreen);
	TInput i_repl(*phCurrScreen);

	w.Init("Find",x,y,60,8,ctDialog,cbDialog);
	w.SaveBG();
	w.Show(*phCurrScreen);
	
	clprintf(*phCurrScreen,ctDialog,cbDialog,x+2,y+2,"find string :");
	if(!g_bReadOnly) clprintf(*phCurrScreen,ctDialog,cbDialog,x+2,y+4,"replace string :");
	i.Input(findString,x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_INIT);
	if(!g_bReadOnly) i_repl.Input(replString,x + 2,y + 5,56,ctInput,cbInput,FALSE,TABEND_INIT);
	while(1)
	{
		retkey = i.Input(i.GetText(),x + 2,y + 3,56,ctInput,cbInput,FALSE,TABEND_RUN);
		if(retkey == 13 || retkey == 27) break;
		if(!g_bReadOnly) retkey = i_repl.Input(i_repl.GetText(),x + 2,y + 5,56,ctInput,cbInput,FALSE,TABEND_RUN);
		if(!g_bReadOnly) if(retkey == 13 || retkey == 27) break;
	}
	w.RestoreBG();
	if(retkey == 13) 
	{
		strcpy(findString,i.GetText());
		if(!g_bReadOnly) strcpy(replString,i_repl.GetText());
		return TRUE;
	}
return FALSE;
}

//-------------------------------------------------
//  find next string
//-------------------------------------------------
BOOL FindNextString(void)
{
	DWORD strsize = strlen(findString);
	
	for(DWORD i = curr + 1; i < dw_filesize - strsize; i++)
	{
		if(!strnicmp(findString,&eBuffer[i],strsize))
		{
			curr = i;
			bUpdateScreen = TRUE;
			selectedBlockBegin = curr;
			selectedBlockEnd = curr + strlen(findString) - 1;
			fixedSelectPoint = curr;
			//store variables
			selCurr = curr;
			selCurrScreen = currScreen;
			selCurx = curx;
			selCury = cury;
			selShift = shift;
			return TRUE;
		}
	}
	if(!g_bMultiEdit) InfoMessage(*phCurrScreen,"Find","String not found.");
return FALSE;
}

//-------------------------------------------------
//  replace string
//-------------------------------------------------
BOOL ReplaceString(void)
{
		if(g_bReadOnly) return FALSE;
		if (selectedBlockBegin != -1)
		{
			DeleteMove();
			//insert	
			long size = strlen(replString);
			memmove((PVOID)(&eBuffer[curr+size]),(PVOID)(&eBuffer[curr]),(dw_filesize - curr));
			memcpy(&eBuffer[curr],replString,size); 
			dw_filesize += size;
			curr = CheckMaxRowSize(curr);
			UpdateCurrentColumn();
			UPush( A_BLOCK_INSERT, NULL, size, curr );
			bFileChanged = TRUE;
		}
return TRUE;
}


//-------------------------------------------------
//  refresh screen
//-------------------------------------------------
void RefreshScreen(void)
{
	COORD	coord;

	RecalculateCurXY();
	if(bUpdateScreen) 
	{
		if(*phCurrScreen == hEditScreen) phCurrScreen = &hBackEditScreen;
		else phCurrScreen = &hEditScreen;

		ShowScreenText(*phCurrScreen);
		GetCurrentRowNumber();
		ShowBookmarks(*phCurrScreen);
		SetStdHandle(STD_OUTPUT_HANDLE,*phCurrScreen);
		SetConsoleActiveScreenBuffer(*phCurrScreen);
	}
	bUpdateScreen = FALSE;
	
	RefreshTopBar(*phCurrScreen);
	coord.X = (short)curx;
	coord.Y = (short)cury;
	SetConsoleCursorPosition(*phCurrScreen,coord);
}

//-------------------------------------------------
//  main loop function
//-------------------------------------------------
int EditKeyboardLoop(void)
{
	INPUT_RECORD	inputBuffer;
	DWORD	dwInputEvents; 

	while(1)
	{

//refresh down bar
	SHORT s_ctrl = GetAsyncKeyState(VK_CONTROL) & 0x8000;
	if(s_ctrl  && !ctrlDown) 
	{
		if(!g_bReadOnly)
		{
			DrawEditBar(hBackEditScreen,editCtrlBar);
			DrawEditBar(hEditScreen,editCtrlBar);
		}
		else
		{
			DrawEditBar(hBackEditScreen,editCtrlBarRO);
			DrawEditBar(hEditScreen,editCtrlBarRO);
		}
		ctrlDown = TRUE;
	}
	if(!s_ctrl && ctrlDown) 
	{
		if(!g_bReadOnly)
		{
			DrawEditBar(hBackEditScreen,editBar);
			DrawEditBar(hEditScreen,editBar);
		}
		else
		{
			DrawEditBar(hBackEditScreen,editBarRO);
			DrawEditBar(hEditScreen,editBarRO);
		}

		ctrlDown = FALSE;
	}
	

	ReadConsoleInput(hEditIn, &inputBuffer, 1, &dwInputEvents);
	Sleep(20);
	if(dwInputEvents > 0 
		&& inputBuffer.Event.KeyEvent.bKeyDown
		&& inputBuffer.EventType == KEY_EVENT)
	{
//ALT downown		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_ALT_PRESSED|RIGHT_ALT_PRESSED)) )
		{
			switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
			{
//goto bookmarks 0 - 9
				case 0x30:
				case 0x31:
				case 0x32:
				case 0x33:
				case 0x34:
				case 0x35:
				case 0x36:
				case 0x37:
				case 0x38:
				case 0x39: {
								int	bnum = inputBuffer.Event.KeyEvent.wVirtualKeyCode - 0x30;
								SetCurrentRow(Bookmarks[bnum]);
								ShowBookmarks(*phCurrScreen);
								break;
						   }
			}
			goto labelAlt;
		}
//SHIFT down		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
		{
			shiftDown = TRUE;
			//start select
			if(!shiftSelect)
			{
				fixedSelectPoint = curr;	
				selectedBlockBegin = curr;
				selectedBlockEnd = curr;
				shiftSelect = TRUE;
				//store variables
				selCurr = curr;
				selCurrScreen = currScreen;
				selCurx = curx;
				selCury = cury;
				selShift = shift;
			}
			if(inputBuffer.Event.KeyEvent.wVirtualKeyCode == VK_INSERT)
			{
				if(selectedBlockBegin != -1 && selectedBlockEnd != -1 && selectedBlockBegin != selectedBlockEnd) DeleteMove();
				GetBlockFromClipboard();
				bUpdateScreen = TRUE;
				bFileChanged = TRUE;
				//reset select
				selectedBlockBegin = - 1;
				selectedBlockEnd = - 1;
				shiftSelect = FALSE;
			}
			if(inputBuffer.Event.KeyEvent.wVirtualKeyCode == VK_DELETE)
			{
					if(selectedBlockBegin != -1 && selectedBlockEnd != -1)
					{
						PutBlockToClipboard();
						DeleteMove();
						bFileChanged = TRUE;
					}
			}
		}
		else
		{
			shiftDown = FALSE;
			shiftSelect = FALSE;
		}
//CTRL down		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) ))
		{
			switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
			{
//set bookmarks 0 - 9
				case 0x30:
				case 0x31:
				case 0x32:
				case 0x33:
				case 0x34:
				case 0x35:
				case 0x36:
				case 0x37:
				case 0x38:
				case 0x39: {
								int	bnum = inputBuffer.Event.KeyEvent.wVirtualKeyCode - 0x30;
								Bookmarks[bnum] = GetCurrentRowNumber();
								ShowBookmarks(*phCurrScreen);
								break;
						   }
//RIGHT WORD
			case VK_RIGHT : {
								RightMoveWord();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//LEFT WORD
			case VK_LEFT : {
								LeftMoveWord();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//F2 - save file as
				case VK_F2 : {
								if(g_bReadOnly) break;
								if( g_bBufferMode ) break;
								SaveFileAs();
							break;
						  }
//F4 replace string and find next
			case VK_F4 : {
							if(g_bReadOnly) break;
							if (selectedBlockBegin != -1)
							{	
								ReplaceString();
								curr += strlen(replString);
								FindNextString();
								curr = CheckMaxRowSize(curr);
								UpdateCurrentColumn();
								bFileChanged = TRUE;
							}
							break;
						 }
//F5 save cur line number
			case VK_F5 : {
							sprintf(sGotoLine,"%ld",GetCurrentRowNumber());
							break;
						 }
//F7 - find next 
				case VK_F7 : {
								if(FindNextString() == FALSE && g_bMultiEdit) return 7;
								curr = CheckMaxRowSize(curr);
								UpdateCurrentColumn();
							break;
						  }
//CTRL + F find 
				case 0x46 : {
						if(FindInputString()) 
						{
							if(FindNextString() == FALSE && g_bMultiEdit) return 7;
							curr = CheckMaxRowSize(curr);
							UpdateCurrentColumn();
						}
						break;
					 }
//VK_INSERT put block to clipboard ctrl+c
				case 0x43 :
				case VK_INSERT : {
								KcLog(__FILE__,"EditKeyboardLoop",0);
								PutBlockToClipboard();
								break;
							 }
//ctrl + v = SHIFT insert
				case 0x56 :  {
								if(selectedBlockBegin != -1 && selectedBlockEnd != -1) DeleteMove();
								GetBlockFromClipboard();
								bUpdateScreen = TRUE;
								bFileChanged = TRUE;
								//reset select
								selectedBlockBegin = - 1;
								selectedBlockEnd = - 1;
								shiftSelect = FALSE;
								break;
							 }
//ctrl + x
				case 0x58 :  {
								if(selectedBlockBegin != -1 && selectedBlockEnd != -1)
								{
									PutBlockToClipboard();
									DeleteMove();
									bFileChanged = TRUE;
								}
								break;
							 }
//ctrl + r
				case 0x52 :  {
								ReloadFile();
								break;
							 }
//CTRL+HOME
				case VK_PRIOR : 
				case VK_HOME : {
							HomeFileMove();
							curr = CheckMaxRowSize(curr);
							ShiftBlockSelect();
							UpdateCurrentColumn();
							break;
						  }
//CTRL+END
				case VK_NEXT : 
				case VK_END : {
							EndFileMove();
							curr = CheckMaxRowSize(curr);
							ShiftBlockSelect();
							UpdateCurrentColumn();
							break;
						  }
//CTRL+W - select current word
				case 0x57: {
							DWORD start,end;
							int curr_old = curr;
							//(isdigit(eBuffer[start]) || isalpha(eBuffer[start]) )
							for	( start = curr; iscsym(eBuffer[start]) && !isspace(eBuffer[start]) &&  eBuffer[start]!=0xA && start > 0; start--);
							for	( end = curr; iscsym(eBuffer[end]) && !isspace(eBuffer[end]) && eBuffer[end]!=0xD && end < dw_filesize; end++);
							
							curr = start+1;
							selectedBlockBegin = start+1;
							selectedBlockEnd = end-1;
							fixedSelectPoint = start+1;
							if( selectedBlockBegin > selectedBlockEnd ) {
								fixedSelectPoint = selectedBlockBegin = selectedBlockEnd;
								curr = curr_old;
							} else bUpdateScreen = TRUE;
							break;
						  }
//CTRL+A - select all
				case 0x41: {
							curr = dw_filesize;
							selectedBlockBegin = 0;
							selectedBlockEnd = dw_filesize-1;
							fixedSelectPoint = 0;
							bUpdateScreen = TRUE;
							break;
						  }
//ctrl + T
				case 0x54 :  {
								PutNoteTimeMacro();
								break;
							 }
//ctrl + Z undo
				case 0x5a :  {
								Undo();
								bUpdateScreen = TRUE;
								break;
							 }
//ctrl + ENTER 
				case 0x9:	{
								if( g_bBufferMode ) return 0;
								break;
							 }
			}
		}
//KEYS
		else
		{
		switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
		{
//ENTER
			case VK_RETURN:	{
								break;
							}
//ESC
			case VK_F10 :
			case VK_ESCAPE :{
								if(bFileChanged && !g_bReadOnly)
								{
									//notes saves in all cases
									if(g_bPutTimeMacro) { SaveFile(fileName); return 0; }
									//save mormal file
									char ch = YesNoCancelMessage(*phCurrScreen,"Edit","File changed - save ?");
									switch(ch)
									{
										case 'Y' : {
														SaveFile(fileName); return 0;
														
												   }
										case 'N' : return 0;
										case 27  : break;
									}
								}
								else 
								{
									if(inputBuffer.Event.KeyEvent.wVirtualKeyCode == VK_F10) return 0;
									else return 7;
								}
								break;
							}
//LEFT
			case VK_LEFT :	{
								LeftMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//RIGHT
			case VK_RIGHT : {
								RightMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//UP
			case VK_UP	 :	{
								UpMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								break;
							}
//DOWN
			case VK_DOWN:	{
								DownMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								break;
							}
//PAGEUP
			case VK_PRIOR:	{
								PageUpMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//PAGEDOWN
			case VK_NEXT:	{
								PageDownMove();
								curr = CheckMaxRowSize(curr);
								ShiftBlockSelect();
								UpdateCurrentColumn();
								break;
							}
//BACKSPACE
			case 8 : {
						if(g_bReadOnly) break;
						BackspaceMove();
						curr = CheckMaxRowSize(curr);
						UpdateCurrentColumn();
						shiftSelect = FALSE;
						ShiftBlockSelect();
						bFileChanged = TRUE;
						break;
					  }
//DELETE
			case 46 : {
						DeleteMove();
						UpdateCurrentColumn();
						bFileChanged = TRUE;
						break;
					  }
//INSERT
			case 45 : {
						break;
					  }
//HOME
			case 36 : {
						HomeRowMove();
						ShiftBlockSelect();
						UpdateCurrentColumn();
						break;
					  }
//END
			case 35 : {
						EndRowMove();
						curr = CheckMaxRowSize(curr);
						ShiftBlockSelect();
						UpdateCurrentColumn();
						break;
					  }
//F2
			case VK_F2 : {
						if(g_bReadOnly) break;
						if( g_bBufferMode ) break;
						SaveFile(fileName);
						break;
					  }
//F3 find next
			case VK_F3 : {
							if(FindNextString() == FALSE && g_bMultiEdit) return 7;
							curr = CheckMaxRowSize(curr);
							UpdateCurrentColumn();
							break;
						 }
//F4 replace string
			case VK_F4 : {
							ReplaceString();
							break;
						 }
//F5
			case VK_F5 : {
						GotoLine();
						break;
					  }
//F7 - find (CTRL + F)
			case VK_F7 : {
						if(FindInputString()) 
						{
							if(FindNextString() == FALSE && g_bMultiEdit) return 7;
							curr = CheckMaxRowSize(curr);
							UpdateCurrentColumn();
						}
						break;
					  }
//F8 - CR/LF
			case VK_F8 : {
							BufferToCRLFStyle();
							HomeFileMove();
							UpdateCurrentColumn();
						break;
					  }
//F9- LF
			case VK_F9 : {
							BufferToLFStyle();
							HomeFileMove();
							UpdateCurrentColumn();
						break;
					  }
		}//switch
		}//else
//		char ch = inputBuffer.Event.KeyEvent.uChar.AsciiChar;
		
		if(!g_bReadOnly) InsertChar(inputBuffer.Event.KeyEvent.uChar.AsciiChar);
labelAlt:
		RefreshScreen();
	}// end if
	}//end while
}

int ReadFile(char * fileName){
	FILE	*f;
	size_t	copysize,readsize;
	f=fopen(fileName,"rb");
	if(f) 
	{
		fseek(f,0L,SEEK_END);
		dw_filesize = ftell(f);
		dw_filesize_orig = dw_filesize;
		fseek(f,0L,SEEK_SET);
		copysize = 0;
		dw_buffersize = dw_filesize + 100000;
		if(eBuffer) delete [] eBuffer;
		eBuffer = new char [dw_buffersize];
		kASSERT(eBuffer!=NULL);
		memset(eBuffer,0,dw_buffersize);
		while(1)
		{
			readsize = fread((char*)(eBuffer+copysize),1,60000,f);
			if(readsize < 60000) break;
			copysize += readsize;
		}
		fclose(f);
	}
	else{
//		DWORD err = GetLastError();
//		if(err != ERROR_FILE_NOT_FOUND) 
//		{
//			ErrorMesage();
//			return 1;
//		}
		dw_filesize = 0;
		dw_buffersize = 100000;
		if(eBuffer) delete [] eBuffer;
		eBuffer = new char [dw_buffersize];
		kASSERT(eBuffer!=NULL);
		memset(eBuffer,0,dw_buffersize);
	}
return 0;
}

BOOL ReloadFile(void){
	WIN32_FIND_DATA	fd;
	HANDLE h;
	BOOL ret = FALSE;

	h=FindFirstFile(fileName, &fd);
	if(h != INVALID_HANDLE_VALUE){
		if(fd.nFileSizeLow!=dw_filesize_orig){
			
			ReadFile(fileName);
			curr = 0;
			currScreen = 0;
			shift = 0;
			selectedBlockBegin = -1;
			selectedBlockEnd = -1;
			fixedSelectPoint = -1;
			shiftDown = FALSE;
			shiftSelect = FALSE;
			curx = Xstart;
			cury = Ystart;
			currColumn = 0;
			bFileChanged = FALSE;
			RefreshScreen();
			ret = TRUE;
		}
		FindClose(h);
	}
return ret;
}

void CheckFileChange(){
	
	if(g_bReadOnly){
		while(1){
			if(ReloadFile()){
				EndFileMove();
				curr = CheckMaxRowSize(curr);
				ShiftBlockSelect();
				UpdateCurrentColumn();
				RefreshScreen();
			}
			Sleep(1000);
			if(g_bCheckFileChangeExit) break;
		}
	}
}

long KcEditBuffer(char *edit_data, const int max_size, long x, long y, long sx, long sy, BOOL bReadOnly )
{
	COORD	coord;
	HANDLE	hOldOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	int	ret;

	g_bBufferMode = TRUE;
	Xstart = x;				//editor window coordinates
	Ystart = y;
	Xsize = sx;
	Ysize = sy;

	UndoClear();
	eBuffer = NULL;

	g_bReadOnly = bReadOnly;
// allocate buffer
	dw_buffersize = strlen( edit_data );
	dw_buffersize = dw_filesize + 10000;
	if(eBuffer) delete [] eBuffer;
	eBuffer = new char [dw_buffersize];
	kASSERT(eBuffer!=NULL);
	memset(eBuffer,0,dw_buffersize);
	memcpy(eBuffer, edit_data, strlen( edit_data ));

	hBackEditScreen = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
	if(hBackEditScreen == INVALID_HANDLE_VALUE) return 5;
	hEditScreen = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
	hEditIn = GetStdHandle(STD_INPUT_HANDLE);
	//copy kc to edit 	
	CopyConsoleScreen( hBackEditScreen, GetStdHandle(STD_OUTPUT_HANDLE) );
	CopyConsoleScreen( hEditScreen, GetStdHandle(STD_OUTPUT_HANDLE) );

	phCurrScreen = &hEditScreen;
	curr = 0;
	currScreen = 0;
	shift = 0;
	selectedBlockBegin = -1;
	selectedBlockEnd = -1;
	fixedSelectPoint = -1;
	shiftDown = FALSE;
	shiftSelect = FALSE;
	curx = Xstart;
	cury = Ystart;
	currColumn = 0;
	bFileChanged = FALSE;

	ShowScreenText(*phCurrScreen);
	SetStdHandle(STD_OUTPUT_HANDLE,*phCurrScreen);
	SetConsoleActiveScreenBuffer(*phCurrScreen);

	SetCursor(hEditScreen,TRUE,15);
	SetCursor(hBackEditScreen,TRUE,15);

	coord.X = (short)curx;
	coord.Y = (short)cury;
	SetConsoleCursorPosition(*phCurrScreen,coord);
	
	ret = EditKeyboardLoop();
	memcpy( edit_data, eBuffer, max_size );

	CloseHandle(hBackEditScreen);
	SetStdHandle(STD_OUTPUT_HANDLE,hOldOutput);
	SetConsoleActiveScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE));
	SetCursor(hEditScreen,TRUE,CURSOR_DEFAULT);
	UndoClear();
	delete [] eBuffer;
	eBuffer = NULL;
	return ret;
}



long KcEdit(char *fname,BOOL bReadOnly,BOOL bPutTimeMacro,BOOL bMultiEdit)
{
	//DWORD	dw_read;
	COORD	coord;
	HANDLE	hOldOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	char	s_tmp[STR_SIZE],*p;
	int	ret;
	DWORD	id;


	g_bBufferMode = FALSE;
	UndoClear();
	eBuffer = NULL;

//multi search flag	
	g_bMultiEdit = bMultiEdit;
	
	cur_sh = -1;
//choose syntax highlight
	p = strrchr(fname,'.');
	if(p)
	{
		strcpy(s_tmp,++p);
		strlwr(s_tmp);
		for ( int i = 0 ; i < n_sh_types; i++ )
		{
			if ( strstr(syn_high[i].type,s_tmp) ) 
			{
				cur_sh = i;
				break;
			}
		}
	}
///////
	g_bReadOnly = bReadOnly;
	strcpy(fileName,fname);
//>- read file
	ret=ReadFile(fileName);
	if(ret!=0) return ret;

	hBackEditScreen = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
	if(hBackEditScreen == INVALID_HANDLE_VALUE) return 5;
	hEditScreen = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
	hEditIn = GetStdHandle(STD_INPUT_HANDLE);
	//copy kc to edit 	
	CopyConsoleScreen( hBackEditScreen, GetStdHandle(STD_OUTPUT_HANDLE) );
	CopyConsoleScreen( hEditScreen, GetStdHandle(STD_OUTPUT_HANDLE) );

	phCurrScreen = &hEditScreen;
	curr = 0;
	currScreen = 0;
	shift = 0;
	selectedBlockBegin = -1;
	selectedBlockEnd = -1;
	fixedSelectPoint = -1;
	shiftDown = FALSE;
	shiftSelect = FALSE;
	curx = Xstart;
	cury = Ystart;
	currColumn = 0;
	bFileChanged = FALSE;

	ShowScreenText(*phCurrScreen);
	SetStdHandle(STD_OUTPUT_HANDLE,*phCurrScreen);
	SetConsoleActiveScreenBuffer(*phCurrScreen);
	if(!g_bReadOnly)
	{
		DrawEditBar(hBackEditScreen,editBar);
		DrawEditBar(hEditScreen,editBar);
	}
	else
	{
		DrawEditBar(hBackEditScreen,editBarRO);
		DrawEditBar(hEditScreen,editBarRO);
	}
	InitTopBar(hBackEditScreen);
	InitTopBar(hEditScreen);
	GetCurrentRowNumber();
	ShowBookmarks(*phCurrScreen);
	RefreshTopBar(hBackEditScreen);
	RefreshTopBar(hEditScreen);
	SetCursor(hEditScreen,TRUE,15);
	SetCursor(hBackEditScreen,TRUE,15);

	coord.X = (short)curx;
	coord.Y = (short)cury;
	SetConsoleCursorPosition(*phCurrScreen,coord);
	
	g_bPutTimeMacro = bPutTimeMacro;
	if(bPutTimeMacro) 
	{
		PutNoteTimeMacro();
		bFileChanged = FALSE;
		RefreshScreen();
	}
//viewer reloader
	HANDLE th;
	if(g_bReadOnly){
		g_bCheckFileChangeExit=FALSE;
		th=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)CheckFileChange,NULL,0,&id);
		
	}
	
	ret = EditKeyboardLoop();
	if(g_bReadOnly){
		g_bCheckFileChangeExit=TRUE;
//		TerminateThread(th,0);
	}

	CloseHandle(hBackEditScreen);
	SetStdHandle(STD_OUTPUT_HANDLE,hOldOutput);
	SetConsoleActiveScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE));
	SetCursor(hEditScreen,TRUE,CURSOR_DEFAULT);
	UndoClear();
	delete [] eBuffer;
	eBuffer = NULL;
	return ret;
}
