#ifndef FILE__H
#define FILE__H

#include <io.h>
#include "KWindow.h"
#include "globals.h"

#define		LEFT	1
#define		RIGHT	2


#define		RUN_FILE_NOT_FOUND		0
#define		RUN_FILE_EXE_DOS		1
#define		RUN_FILE_EXE16			2
#define		RUN_FILE_EXE32			3
#define		RUN_FILE_UNKNOWN		4


typedef struct _Item
{
	BOOL selected;
	DWORD dirsize;
	DWORD dircompsize;
	WIN32_FIND_DATA file;
	char *path;					//used for find file
	LPNETRESOURCE netrs;
} TItem;

#define PT_NORMAL	1
#define PT_FIND		2
#define PT_NET		3
#define PT_TASK		4

#define IS_PT(panel_type,pt) (panel_type==pt)
#define SET_PT(panel_type,pt) (panel_type = pt)

typedef struct _TPanel
{
	DWORD	sortMethod;
	DWORD	showMethod;
	int		pt;						//panel type
	long	nFiles;
	long	nAllocItems;
	long	curr;
	DWORD	panel_size;				//sum of size of all files in panel
	TItem	*Items;
//keys
	bool f1;
	bool f2;
	bool f3;
	bool f4;
	bool f5;
	bool f6;
	bool f7;
	bool f8;
	bool f9;
	bool f10;
	bool f11;
	bool f12;
	bool ctrl_f1;
	bool ctrl_f2;
	bool ctrl_f3;
	bool ctrl_f4;
	bool ctrl_f5;
	bool ctrl_f6;
	bool ctrl_f7;
	bool ctrl_f8;
	bool ctrl_f9;
	bool ctrl_f10;
	bool ctrl_f11;
	bool ctrl_f12;
	bool alt_f1;
	bool alt_f2;
	bool alt_f3;
	bool alt_f4;
	bool alt_f5;
	bool alt_f6;
	bool alt_f7;
	bool alt_f8;
	bool alt_f9;
	bool alt_f10;
	bool alt_f11;
	bool alt_f12;

	bool vk_insert;
	bool vk_plus;
	bool vk_minus;
	bool vk_asterisk;
} TPanel;

typedef struct _TFind
{
	_TFind *prev;
	_TFind *next;
	WIN32_FIND_DATA file;
	char path[STR_SIZE];
} TFind;

typedef struct _TFindHead
{
	_TFind *begin;
	_TFind *end;
	_TFind *current;
} TFindHead;

//extentions table
typedef struct _t_ext{
	char ext[50];
	char program[100];
} t_ext;

typedef struct _TExtHighlight
{
	char	ext[STR_SIZE];
	DWORD	attr;
	WORD	color;

} TExtHighlight;

extern long g_kc_debug;

extern int g_n_fext_run;
extern t_ext g_fext_run[];
extern int g_n_fext_edit;
extern t_ext g_fext_edit[];
extern int g_n_fext_view;
extern t_ext g_fext_view[];
extern char g_ini_file[];

extern char	g_start_path[];
extern char about[];


extern TPanel filePanel1;
extern TPanel filePanel2;
extern TPanel findPanel;			//find panel
extern TPanel netPanel;				//net panel
extern TPanel taskPanel;			//task panel
extern TPanel *pLeftPanel;
extern TPanel *pRightPanel;

extern char lDirectory[];
extern char rDirectory[];
extern char *aDirectory;

extern int ActivePanel;			//active panel flag
extern TPanel **aPanel;			//active panel pointer
extern KWindow *aWindow;		//active window
extern TFindHead ffHead;
extern char g_ext_first[];

bool InitPanels();
void KcLog(char *file,char *msg,long l,...);
void FreePanel(TPanel *p);
BOOL TestPanelChange(TPanel *p,char *path);
void LoadPanel(TPanel *p,char *path=NULL);
void LoadFindPanel(TPanel *p,long nFiles);
BOOL LoadNetPanel(TPanel *p, LPNETRESOURCE nrs = NULL);
void LoadTaskPanel( TPanel *p );
void SavePanelSelectedNames(TPanel *p);
void SelectFilesAfterRefresh(TPanel *p);

unsigned IsDir(TItem *fd);
int compareSize(const void *elem1,const void *elem2 );
int compareTime(const void *elem1,const void *elem2 );
int compareName(const void *elem1,const void *elem2 );
int compareNameDirFirst(const void *elem1,const void *elem2 );
int compareExtDirFirst(const void *elem1,const void *elem2 );
int compareExtDirFirstSpecial(const void *elem1,const void *elem2 );
int compareExtDirFirstMask(const void *elem1,const void *elem2 );

void SortByName(TItem*& find_data,int nFiles);
BOOL checkname(char *name,char *mask);
BOOL IsMaskOrFile(char *fname);
void CreateFileFromMask(char *mask,char *fname,char *out,int outSize);

void FormatFileSize(double size,char *str);
BOOL GetDriveSpace(char *drive,char *free,char *total);
DWORD GetDriveFreeSpace(char *drive);
void GetDriveTypeMy(char *drive,char *type,char *fstype);
void FormatTime(FILETIME *time ,char *stime);
void FormatDate(FILETIME *time ,char *stime);
void CalculateSelectedFiles(TPanel *p,long *n,DWORD *size = NULL,BOOL bSelect = TRUE);
BOOL RunProcess(char *command_line,DWORD priority);
void UnselectItems(void);
char *GetDrivesInString(char *drives);
BOOL FindStringInFile(LPTSTR fname,LPTSTR searchedstring);

BOOL FindExt(char *name,char *ret,t_ext *fext,int nfext);

long TestFile(char *fname);

#endif