#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "input.h"
#include "misc.h"
#include "globals.h"
#include "file.h"
#include "kc.h"

TInput::TInput(HANDLE h)
{
	hCon = h;
	bInsert = TRUE;
}

TInput::~TInput(void)
{
}

char * TInput::GetText(void)
{
	 return buffer;
}

void TInput::SetText(char *text)
{
	char stmp[STR_SIZE];
	
	strcpy(buffer,text);
	
	if(size < strlen(buffer))
	{
		x = screenx + size - 1;
		startscreen = strlen(buffer) - size + 1;
	}
	else x = screenx + strlen(buffer);
	bufpos = strlen(buffer);
	ShiftBlockSelect();

//refresh screen
	for(int i = 0; i < (int)size; i++)
	{
		if((startscreen + i) < (int)strlen(buffer))	stmp[i] = buffer[startscreen + i];
		else stmp[i] = ' ';
	}
	stmp[i] = 0;
	clprintf(hCon,textcolor,bckcolor,screenx,y,"%s",stmp);
}

void TInput::SetCursor(DWORD size)
{
	CONSOLE_CURSOR_INFO cci;
	cci.dwSize = size;
	cci.bVisible = TRUE;
	SetConsoleCursorInfo(hCon,&cci);
}

void TInput::MoveBuffer(int start,int direct)
{
	char	tmp[INPUT_BUFF_SIZE];
	
	memcpy(tmp,buffer,INPUT_BUFF_SIZE);
	memcpy(buffer + start + direct,tmp + start,INPUT_BUFF_SIZE - start - 1);
}

void TInput::gotoxy(int x,int y)
{
	COORD coord;

	coord.X = x;
	coord.Y = y;
	SetConsoleCursorPosition(hCon,coord);
}



//  shift + move = select
void TInput::ShiftBlockSelect(void)
{
	if(shiftDown && shiftSelect)
	{
		//select
		if(fixedSelectPoint < (long)bufpos)
		{
//			LeftMove();
			if(bufpos > 0) selectedBlockEnd = bufpos - 1;
			else selectedBlockEnd = bufpos;
			selectedBlockBegin = fixedSelectPoint;
			if(selectedBlockEnd >= (long)strlen(buffer)) selectedBlockEnd = strlen(buffer) - 1;

//			RightMove();
		}
		else
		{
			selectedBlockBegin = bufpos;
			selectedBlockEnd = fixedSelectPoint;
			if(selectedBlockEnd >= (long)strlen(buffer)) selectedBlockEnd = strlen(buffer) - 1;
		}
	}
	else 
	{
		shiftSelect = FALSE;
		if(selectedBlockBegin != - 1 || selectedBlockEnd != -1)
		{
			selectedBlockBegin = - 1;
			selectedBlockEnd = - 1;
		}
	}
}

void TInput::PutToClipboard(void)
{
	if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
		PutBlockToClipboard(&buffer[selectedBlockBegin],selectedBlockEnd-selectedBlockBegin+1);
}

void TInput::GetFromClipboard(void)
{
	char	*clipbuffer = NULL;
	long	clipsize,movesize;

	if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
	{
		DeleteSelected();
	}
	clipsize = GetBlockFromClipboard(clipbuffer);
	if(clipsize > 0)
	{
		if(clipsize < (long)(INPUT_BUFF_SIZE - strlen(buffer)))
		{
			movesize = strlen(buffer) - bufpos + 1;
			memmove((PVOID)(&buffer[bufpos+clipsize]),(PVOID)(&buffer[bufpos]),movesize);
			memcpy(&buffer[bufpos],clipbuffer,clipsize);
		}
		HeapFree(GetProcessHeap(),0,clipbuffer);
	}
	selectedBlockBegin = - 1;
	selectedBlockEnd = - 1;
}

void TInput::DeleteSelected(void)
{
	long	old_size = strlen(buffer);
	long	movesize;

	if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
	{
		movesize = strlen(buffer) - (selectedBlockEnd-selectedBlockBegin);
		memmove((PVOID)(&buffer[selectedBlockBegin]),(PVOID)(&buffer[selectedBlockEnd+1]),movesize);
		buffer[old_size - (selectedBlockEnd-selectedBlockBegin)] = 0;
	}
	bufpos = selectedBlockBegin;
	selectedBlockBegin = - 1;
	selectedBlockEnd = - 1;

	if(bufpos > size) 
	{
		x = screenx + size - 1;
		startscreen = bufpos - size + 1;
	}
	else
	{
		x = screenx + bufpos;
	}

}

//if LastKey = TRUE WriteConsoleInput
/*
int TInput::Input(char *text,int sx,int sy,unsigned psize,WORD ct,WORD cb,BOOL bLastKey,DWORD dwTabEnd)
{
	CONSOLE_CURSOR_INFO cci;
	BOOL	b_first_key = TRUE;				//when first key == TRUE & isprint(ch) reset buffer
	char	stmp[STR_SIZE];
	COORD coord;
	DWORD cCharsWritten;
	INPUT_RECORD inputBuffer;
	DWORD dwInputEvents; 
	unsigned i;
	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);
	
	
	size = psize;
	selectedBlockBegin = -1;
	selectedBlockEnd = -1;
	x = sx;
	y = sy;
	startscreen = 0;
	screenx = sx;
	textcolor = ct;
	bckcolor = cb;

//	mutex
	if(bLastKey) 
	{
		WaitForSingleObject(hMutex,INFINITE);
		bActive = TRUE;
	}
	strcpy(buffer,text);
	bufpos = 0;


//refresh screen
	for(i = 0; i < size; i++)
	{
		if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
		else stmp[i] = ' ';
	}
	stmp[i] = 0;
	clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
	
	
	coord.X = sx;
	coord.Y = sy;
	
	FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
	gotoxy(x,y);
	
	GetConsoleCursorInfo(hCon,&cci);
	SetCursor(10);
	bGotoNextItem = FALSE;
//only init input row (for input groups)	
	if(dwTabEnd & TABEND_INIT)
	{
		bActive = FALSE;
		SetConsoleCursorInfo(hCon,&cci);
		return 777;
	}
	while(1)
	{
// read keys
///////////////////////////////////////////////////
	ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
	Sleep(20);
	if(dwInputEvents > 0 
		&& inputBuffer.Event.KeyEvent.bKeyDown
		&& inputBuffer.EventType == KEY_EVENT )
	{
		if(bLastKey) WaitForSingleObject(hMutex,INFINITE);
//SHIFT		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
		{
			shiftDown = TRUE;
			//start select
			if(!shiftSelect)
			{
				fixedSelectPoint = bufpos;	
				selectedBlockBegin = bufpos;
				selectedBlockEnd = bufpos;
				shiftSelect = TRUE;
			}
		}
		else
		{
			shiftDown = FALSE;
			shiftSelect = FALSE;
		}
//end SHIFT
		switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
		{
//ENTER
			case 13 : {
						if( bLastKey && (inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) ))
						{
							bGotoNextItem = TRUE;
							ReleaseMutex(hMutex);
							continue;
						}
						else
						{
							bActive = FALSE;
							if(bLastKey) WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
							if(bLastKey) ReleaseMutex(hMutex);
							SetConsoleCursorInfo(hCon,&cci);
							return 13;
						}
						break;
					  }
//ESC
			case 27 : {
						bActive = FALSE;
						SetConsoleCursorInfo(hCon,&cci);
						if(bLastKey) ReleaseMutex(hMutex);
						return 27;
						break;
					  }
//TAB
			case 9 :  {
						if(dwTabEnd & TABEND_RUN)
						{
							bActive = FALSE;
							SetConsoleCursorInfo(hCon,&cci);
							if(bLastKey) ReleaseMutex(hMutex);
							return 9;
						}
						break;
					  }
//LEFT
			case 37 : {
						b_first_key = FALSE;
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos>0) 
							{
								char *p = buffer;
								for(int i = bufpos; p[i] != ' ' && i != 0; i--);
								if(i)
								{
									//goto next word
									int diff = bufpos - i + 1;;
									if((x-diff) < sx) startscreen -= diff;
									else x -= diff;
									bufpos -= diff;
								}
								else
								{
									//goto begin
									x = sx;
									bufpos = 0;
									startscreen = 0;
								}
			
							}
						}
						else
						{
							if(bufpos>0) 
							{
								if(startscreen >0 && x == sx) startscreen--;
								else x--;
								bufpos--;
							}
						}
						ShiftBlockSelect();
						break;
					  }
//RIGHT
			case 39 : {
						b_first_key = FALSE;
						//ctrl
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos<strlen(buffer)) 
							{
								char *p = strchr(buffer+bufpos,' ');
								if(p)
								{
									//goto next word
									short diff = p - buffer - bufpos + 1;
									if((x+diff) > (int)(sx+size-1)) startscreen += diff;
									else x += diff;
									bufpos += diff;
								}
								else
								{
									//goto end				
									if(size < strlen(buffer))
									{
										x = sx + size - 1;
										startscreen = strlen(buffer) - size + 1;
									}
									else x = sx + strlen(buffer);
									bufpos = strlen(buffer);
								}
							}							
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								if(x == (int)(sx+size-1)) startscreen++;
								else x++;
								bufpos++;
								
							}
						}
						ShiftBlockSelect();
						break;
					  }
//BACKSPACE
			case 8 : {
						b_first_key = FALSE;
						if(bufpos>0) 
						{
							if(startscreen >0 && x == sx)
							{
								startscreen--;
							}
							else x--;
							MoveBuffer(bufpos,-1);
							buffer[strlen(buffer)] = 0;
							bufpos--;
							
						}
						shiftSelect = FALSE;
						ShiftBlockSelect();
						break;
					  }
//DELETE
			case 46 : {
						b_first_key = FALSE;
						if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
						{
							DeleteSelected();
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								MoveBuffer(bufpos+1,-1);
								buffer[strlen(buffer)] = 0;
							}
						}
						break;
					  }
//INSERT
			case 45 : {
						//put to clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							PutToClipboard();
						}
						else
						//SHIFT + INSERT get data from clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
						{
							GetFromClipboard();
						}
						//change insert mode
						else
						{
							bInsert ^= 1;
							if(bInsert) SetCursor(CURSOR_DEFAULT);
							else SetCursor(99);
						}
						break;
					  }
//HOME
			case 36 : {
						b_first_key = FALSE;
						x = sx;
						bufpos = 0;
						startscreen = 0;
						ShiftBlockSelect();
						break;
					  }
//END
			case 35 : {
						b_first_key = FALSE;
						if(size < strlen(buffer))
						{
							x = sx + size - 1;
							startscreen = strlen(buffer) - size + 1;
						}
						else x = sx + strlen(buffer);
						bufpos = strlen(buffer);
						ShiftBlockSelect();
						break;
					  }
//ctrl + v = SHIFT insert
			case 0x56 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								GetFromClipboard();
							break;
						 }
//ctrl + c 
			case 0x43 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								PutToClipboard();
							break;
						 }
//ctrl + x
			case 0x58 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
							{
								PutToClipboard();
								DeleteSelected();
							}
							break;
						 }
		}//switch
		if(isprint(inputBuffer.Event.KeyEvent.uChar.AsciiChar))
		{
			if(selectedBlockBegin != -1 && selectedBlockEnd != -1 && selectedBlockBegin != selectedBlockEnd) DeleteSelected();
			shiftSelect = FALSE;
			ShiftBlockSelect();
			if(bufpos<INPUT_BUFF_SIZE)
			{
				if(b_first_key)
				{
					b_first_key = FALSE;
					strcpy(buffer,"");
					bufpos = 0;
					x = sx;
				}
				if(!bInsert)
				{
					if((x-sx) >= (int)size-1) startscreen++;
					else x++;
					if(bufpos == strlen(buffer)) buffer[bufpos+1] = 0;
					buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
					bufpos++;
				}
				else
				{
					if(strlen(buffer) < INPUT_BUFF_SIZE)
					{
						if((x-sx) >= (int)size-1) startscreen++;
						else x++;
						MoveBuffer(bufpos,1);
						buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
						bufpos++;
					}
				}
			}
		}
		else
		{
			if(bLastKey 
				&& inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_SHIFT
				&& inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_BACK 
				&& inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_CONTROL) 
			{
				bActive = FALSE;
				WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
				SetConsoleCursorInfo(hCon,&cci);
				break;
			}
		}

//refresh screen
		for(i = 0; i < size; i++)
		{
			if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
			else stmp[i] = ' ';
		}
		stmp[i] = 0;
		clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
		gotoxy(x,y);

		//select block
		if((selectedBlockBegin != - 1 && selectedBlockEnd != -1)
			&& fixedSelectPoint != (long)bufpos)
		{
			for(i = 0; i < size; i++)
			{
				coord.X = sx + i;
				coord.Y = sy;
				if( ((long)(startscreen + i) < selectedBlockBegin) ||  ( (long)(startscreen+i) > selectedBlockEnd) )
					FillConsoleOutputAttribute(hCon,ct|cb,1,coord, &cCharsWritten);
				else
					FillConsoleOutputAttribute(hCon,ctSelectedBlock|cbSelectedBlock,1,coord, &cCharsWritten);
			}
		}	
		else
		{
			coord.X = sx;
			coord.Y = sy;
			FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
		}
	}
	if(bLastKey) ReleaseMutex(hMutex);
///////////////////////////////////////////////////
	}
	if(bLastKey) 
	{
		WaitForSingleObject(hMutex,INFINITE);
		ReleaseMutex(hMutex);
		CloseHandle(hMutex);
	}
	bActive = FALSE;
return 0;	

}
*/


int TInput::Input(char *text,int sx,int sy,unsigned psize,WORD ct,WORD cb,BOOL bUnused,DWORD dwTabEnd)
{
	CONSOLE_CURSOR_INFO cci;
	BOOL	b_first_key = TRUE;				//when first key == TRUE & isprint(ch) reset buffer
	char	stmp[STR_SIZE];
	COORD coord;
	DWORD cCharsWritten;
	INPUT_RECORD inputBuffer;
	DWORD dwInputEvents; 
	unsigned i;
	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);
	
	
	size = psize;
	selectedBlockBegin = -1;
	selectedBlockEnd = -1;
	x = sx;
	y = sy;
	startscreen = 0;
	screenx = sx;
	textcolor = ct;
	bckcolor = cb;

	strcpy(buffer,text);
	bufpos = 0;


//refresh screen
	for(i = 0; i < size; i++)
	{
		if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
		else stmp[i] = ' ';
	}
	stmp[i] = 0;
	clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
	
	
	coord.X = sx;
	coord.Y = sy;
	
	FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
	gotoxy(x,y);
	
	GetConsoleCursorInfo(hCon,&cci);
	SetCursor(10);
	bGotoNextItem = FALSE;
//only init input row (for input groups)	
	if(dwTabEnd & TABEND_INIT)
	{
		SetConsoleCursorInfo(hCon,&cci);
		return 777;
	}
	while(1)
	{
// read keys
///////////////////////////////////////////////////
	ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
	Sleep(20);
	if(dwInputEvents > 0 
		&& inputBuffer.Event.KeyEvent.bKeyDown
		&& inputBuffer.EventType == KEY_EVENT )
	{
//SHIFT		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
		{
			shiftDown = TRUE;
			//start select
			if(!shiftSelect)
			{
				fixedSelectPoint = bufpos;	
				selectedBlockBegin = bufpos;
				selectedBlockEnd = bufpos;
				shiftSelect = TRUE;
			}
		}
		else
		{
			shiftDown = FALSE;
			shiftSelect = FALSE;
		}
//end SHIFT
		switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
		{
//ENTER
			case 13 : {
						SetConsoleCursorInfo(hCon,&cci);
						return 13;
						break;
					  }
//ESC
			case 27 : {
						SetConsoleCursorInfo(hCon,&cci);
						return 27;
						break;
					  }
//TAB
			case 9 :  {
						if(dwTabEnd & TABEND_RUN)
						{
							SetConsoleCursorInfo(hCon,&cci);
							return 9;
						}
						break;
					  }
//LEFT
			case 37 : {
						b_first_key = FALSE;
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos>0) 
							{
								char *p = buffer;
								for(int i = bufpos; p[i] != ' ' && i != 0; i--);
								if(i)
								{
									//goto next word
									int diff = bufpos - i + 1;;
									if((x-diff) < sx) startscreen -= diff;
									else x -= diff;
									bufpos -= diff;
								}
								else
								{
									//goto begin
									x = sx;
									bufpos = 0;
									startscreen = 0;
								}
			
							}
						}
						else
						{
							if(bufpos>0) 
							{
								if(startscreen >0 && x == sx) startscreen--;
								else x--;
								bufpos--;
							}
						}
						ShiftBlockSelect();
						break;
					  }
//RIGHT
			case 39 : {
						b_first_key = FALSE;
						//ctrl
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos<strlen(buffer)) 
							{
								char *p = strchr(buffer+bufpos,' ');
								if(p)
								{
									//goto next word
									short diff = p - buffer - bufpos + 1;
									if((x+diff) > (int)(sx+size-1)) startscreen += diff;
									else x += diff;
									bufpos += diff;
								}
								else
								{
									//goto end				
									if(size < strlen(buffer))
									{
										x = sx + size - 1;
										startscreen = strlen(buffer) - size + 1;
									}
									else x = sx + strlen(buffer);
									bufpos = strlen(buffer);
								}
							}							
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								if(x == (int)(sx+size-1)) startscreen++;
								else x++;
								bufpos++;
								
							}
						}
						ShiftBlockSelect();
						break;
					  }
//BACKSPACE
			case 8 : {
						b_first_key = FALSE;
						if(bufpos>0) 
						{
							if(startscreen >0 && x == sx)
							{
								startscreen--;
							}
							else x--;
							MoveBuffer(bufpos,-1);
							buffer[strlen(buffer)] = 0;
							bufpos--;
							
						}
						shiftSelect = FALSE;
						ShiftBlockSelect();
						break;
					  }
//DELETE
			case 46 : {
						b_first_key = FALSE;
						if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
						{
							DeleteSelected();
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								MoveBuffer(bufpos+1,-1);
								buffer[strlen(buffer)] = 0;
							}
						}
						break;
					  }
//INSERT
			case 45 : {
						//put to clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							PutToClipboard();
						}
						else
						//SHIFT + INSERT get data from clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
						{
							GetFromClipboard();
						}
						//change insert mode
						else
						{
							bInsert ^= 1;
							if(bInsert) SetCursor(CURSOR_DEFAULT);
							else SetCursor(99);
						}
						break;
					  }
//HOME
			case 36 : {
						b_first_key = FALSE;
						x = sx;
						bufpos = 0;
						startscreen = 0;
						ShiftBlockSelect();
						break;
					  }
//END
			case 35 : {
						b_first_key = FALSE;
						if(size < strlen(buffer))
						{
							x = sx + size - 1;
							startscreen = strlen(buffer) - size + 1;
						}
						else x = sx + strlen(buffer);
						bufpos = strlen(buffer);
						ShiftBlockSelect();
						break;
					  }
//ctrl + v = SHIFT insert
			case 0x56 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								GetFromClipboard();
							break;
						 }
//ctrl + c 
			case 0x43 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								PutToClipboard();
							break;
						 }
//ctrl + x
			case 0x58 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
							{
								PutToClipboard();
								DeleteSelected();
							}
							break;
						 }
		}//switch
		if(isprint(inputBuffer.Event.KeyEvent.uChar.AsciiChar))
		{
			if(selectedBlockBegin != -1 && selectedBlockEnd != -1 && selectedBlockBegin != selectedBlockEnd) DeleteSelected();
			shiftSelect = FALSE;
			ShiftBlockSelect();
			if(bufpos<INPUT_BUFF_SIZE)
			{
				if(b_first_key)
				{
					b_first_key = FALSE;
					strcpy(buffer,"");
					bufpos = 0;
					x = sx;
				}
				if(!bInsert)
				{
					if((x-sx) >= (int)size-1) startscreen++;
					else x++;
					if(bufpos == strlen(buffer)) buffer[bufpos+1] = 0;
					buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
					bufpos++;
				}
				else
				{
					if(strlen(buffer) < INPUT_BUFF_SIZE)
					{
						if((x-sx) >= (int)size-1) startscreen++;
						else x++;
						MoveBuffer(bufpos,1);
						buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
						bufpos++;
					}
				}
			}
		}

//refresh screen
		for(i = 0; i < size; i++)
		{
			if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
			else stmp[i] = ' ';
		}
		stmp[i] = 0;
		clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
		gotoxy(x,y);

		//select block
		if((selectedBlockBegin != - 1 && selectedBlockEnd != -1)
			&& fixedSelectPoint != (long)bufpos)
		{
			for(i = 0; i < size; i++)
			{
				coord.X = sx + i;
				coord.Y = sy;
				if( ((long)(startscreen + i) < selectedBlockBegin) ||  ( (long)(startscreen+i) > selectedBlockEnd) )
					FillConsoleOutputAttribute(hCon,ct|cb,1,coord, &cCharsWritten);
				else
					FillConsoleOutputAttribute(hCon,ctSelectedBlock|cbSelectedBlock,1,coord, &cCharsWritten);
			}
		}	
		else
		{
			coord.X = sx;
			coord.Y = sy;
			FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
		}
	}
///////////////////////////////////////////////////
	}
return 0;	

}


//if LastKey = TRUE WriteConsoleInput
int TInput::InputFindInPanel(char *text,int sx,int sy,unsigned psize,WORD ct,WORD cb,DWORD dwTabEnd)
{
	CONSOLE_CURSOR_INFO cci;
	BOOL	b_first_key = TRUE;				//when first key == TRUE & isprint(ch) reset buffer
	char	stmp[STR_SIZE];
	COORD coord;
	DWORD cCharsWritten;
	INPUT_RECORD inputBuffer;
	DWORD dwInputEvents; 
	unsigned i;
	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);
	BOOL bSearchFile = FALSE;	
	char lastname[STR_SIZE] = "";
	char lastname_old[STR_SIZE] = "";
	
	size = psize;
	selectedBlockBegin = -1;
	selectedBlockEnd = -1;
	x = sx;
	y = sy;
	startscreen = 0;
	screenx = sx;
	textcolor = ct;
	bckcolor = cb;

	strcpy(buffer,text);
	bufpos = 0;


//refresh screen
	for(i = 0; i < size; i++)
	{
		if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
		else stmp[i] = ' ';
	}
	stmp[i] = 0;
	clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
	
	
	coord.X = sx;
	coord.Y = sy;
	
	FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
	gotoxy(x,y);
	
	GetConsoleCursorInfo(hCon,&cci);
	SetCursor(10);
	bGotoNextItem = FALSE;
//only init input row (for input groups)	
	if(dwTabEnd & TABEND_INIT)
	{
		SetConsoleCursorInfo(hCon,&cci);
		return 777;
	}
	while(1)
	{
// read keys
///////////////////////////////////////////////////
	ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
	Sleep(20);
	if(dwInputEvents > 0 
		&& inputBuffer.Event.KeyEvent.bKeyDown
		&& inputBuffer.EventType == KEY_EVENT )
	{
//SHIFT		
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
		{
			shiftDown = TRUE;
			//start select
			if(!shiftSelect)
			{
				fixedSelectPoint = bufpos;	
				selectedBlockBegin = bufpos;
				selectedBlockEnd = bufpos;
				shiftSelect = TRUE;
			}
		}
		else
		{
			shiftDown = FALSE;
			shiftSelect = FALSE;
		}
//end SHIFT
		switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
		{
//ENTER
			case 13 : {
						if( inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) ) {
									bGotoNextItem = TRUE;
									break;
						}
						WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
						SetConsoleCursorInfo(hCon,&cci);
						return 13;
						break;
					  }
//ESC
			case 27 : {
						SetConsoleCursorInfo(hCon,&cci);
						return 27;
						break;
					  }
//TAB
			case 9 :  {
						if(dwTabEnd & TABEND_RUN)
						{
							SetConsoleCursorInfo(hCon,&cci);
							return 9;
						}
						break;
					  }
//LEFT
			case 37 : {
						b_first_key = FALSE;
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos>0) 
							{
								char *p = buffer;
								for(int i = bufpos; p[i] != ' ' && i != 0; i--);
								if(i)
								{
									//goto next word
									int diff = bufpos - i + 1;;
									if((x-diff) < sx) startscreen -= diff;
									else x -= diff;
									bufpos -= diff;
								}
								else
								{
									//goto begin
									x = sx;
									bufpos = 0;
									startscreen = 0;
								}
			
							}
						}
						else
						{
							if(bufpos>0) 
							{
								if(startscreen >0 && x == sx) startscreen--;
								else x--;
								bufpos--;
							}
						}
						ShiftBlockSelect();
						break;
					  }
//RIGHT
			case 39 : {
						b_first_key = FALSE;
						//ctrl
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(bufpos<strlen(buffer)) 
							{
								char *p = strchr(buffer+bufpos,' ');
								if(p)
								{
									//goto next word
									short diff = p - buffer - bufpos + 1;
									if((x+diff) > (int)(sx+size-1)) startscreen += diff;
									else x += diff;
									bufpos += diff;
								}
								else
								{
									//goto end				
									if(size < strlen(buffer))
									{
										x = sx + size - 1;
										startscreen = strlen(buffer) - size + 1;
									}
									else x = sx + strlen(buffer);
									bufpos = strlen(buffer);
								}
							}							
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								if(x == (int)(sx+size-1)) startscreen++;
								else x++;
								bufpos++;
								
							}
						}
						ShiftBlockSelect();
						break;
					  }
//BACKSPACE
			case 8 : {
						b_first_key = FALSE;
						if(bufpos>0) 
						{
							if(startscreen >0 && x == sx)
							{
								startscreen--;
							}
							else x--;
							MoveBuffer(bufpos,-1);
							buffer[strlen(buffer)] = 0;
							bufpos--;
							
						}
						shiftSelect = FALSE;
						ShiftBlockSelect();
						bSearchFile = TRUE;;
						break;
					  }
//DELETE
			case 46 : {
						b_first_key = FALSE;
						if(selectedBlockBegin != - 1 && selectedBlockEnd != -1)
						{
							DeleteSelected();
						}
						else
						{
							if(bufpos<strlen(buffer)) 
							{
								MoveBuffer(bufpos+1,-1);
								buffer[strlen(buffer)] = 0;
							}
						}
						bSearchFile = TRUE;;
						break;
					  }
//INSERT
			case 45 : {
						//put to clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							PutToClipboard();
						}
						else
						//SHIFT + INSERT get data from clipboard
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED ))
						{
							GetFromClipboard();
						}
						//change insert mode
						else
						{
							bInsert ^= 1;
							if(bInsert) SetCursor(CURSOR_DEFAULT);
							else SetCursor(99);
						}
						break;
					  }
//HOME
			case 36 : {
						b_first_key = FALSE;
						x = sx;
						bufpos = 0;
						startscreen = 0;
						ShiftBlockSelect();
						break;
					  }
//END
			case 35 : {
						b_first_key = FALSE;
						if(size < strlen(buffer))
						{
							x = sx + size - 1;
							startscreen = strlen(buffer) - size + 1;
						}
						else x = sx + strlen(buffer);
						bufpos = strlen(buffer);
						ShiftBlockSelect();
						break;
					  }
//ctrl + v = SHIFT insert
			case 0x56 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								GetFromClipboard();
							break;
						 }
//ctrl + c 
			case 0x43 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
								PutToClipboard();
							break;
						 }
//ctrl + x
			case 0x58 :  {
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
							{
								PutToClipboard();
								DeleteSelected();
							}
							break;
						 }
		}//switch
		if(isprint(inputBuffer.Event.KeyEvent.uChar.AsciiChar))
		{
			if(selectedBlockBegin != -1 && selectedBlockEnd != -1 && selectedBlockBegin != selectedBlockEnd) DeleteSelected();
			shiftSelect = FALSE;
			ShiftBlockSelect();
			if(bufpos<INPUT_BUFF_SIZE)
			{
				if(b_first_key)
				{
					b_first_key = FALSE;
					strcpy(buffer,"");
					bufpos = 0;
					x = sx;
				}
				if(!bInsert)
				{
					if((x-sx) >= (int)size-1) startscreen++;
					else x++;
					if(bufpos == strlen(buffer)) buffer[bufpos+1] = 0;
					buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
					bufpos++;
				}
				else
				{
					if(strlen(buffer) < INPUT_BUFF_SIZE)
					{
						if((x-sx) >= (int)size-1) startscreen++;
						else x++;
						MoveBuffer(bufpos,1);
						buffer[bufpos] = (char)inputBuffer.Event.KeyEvent.uChar.AsciiChar;
						bufpos++;
					}
				}
			}
			bSearchFile = TRUE;;
		}
		else //process Fx .... to input buffer
		{
			if( inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_SHIFT
				&& inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_BACK 
				&& inputBuffer.Event.KeyEvent.wVirtualKeyCode != VK_CONTROL
				&& bGotoNextItem == FALSE ) 
			{
				WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
				SetConsoleCursorInfo(hCon,&cci);
				break;
			}
		}

		//search in file panel
		if( bSearchFile ) {
			if(strcmp(lastname,GetText()) || bGotoNextItem)
			{
				if(bGotoNextItem) 
				{
					if((*aPanel)->curr < (*aPanel)->nFiles) (*aPanel)->curr++;
					else (*aPanel)->curr = 0;
				}
				bGotoNextItem = FALSE;
				strcpy(lastname_old,lastname);
				strcpy(lastname,GetText());
				if(!strcmp(lastname,"")) FindItem(lastname,0);
				if(!FindItem(lastname,(*aPanel)->curr))
				{
					if(!FindItem(lastname,0)) {
						SetText(lastname_old);
						strcpy(lastname,lastname_old);
					}
				}
			}
		}
//refresh screen
		for(i = 0; i < size; i++)
		{
			if((startscreen + i) < strlen(buffer))	stmp[i] = buffer[startscreen + i];
			else stmp[i] = ' ';
		}
		stmp[i] = 0;
		clprintf(hCon,ct,cb,sx,sy,"%s",stmp);
		gotoxy(x,y);

		//select block
		if((selectedBlockBegin != - 1 && selectedBlockEnd != -1)
			&& fixedSelectPoint != (long)bufpos)
		{
			for(i = 0; i < size; i++)
			{
				coord.X = sx + i;
				coord.Y = sy;
				if( ((long)(startscreen + i) < selectedBlockBegin) ||  ( (long)(startscreen+i) > selectedBlockEnd) )
					FillConsoleOutputAttribute(hCon,ct|cb,1,coord, &cCharsWritten);
				else
					FillConsoleOutputAttribute(hCon,ctSelectedBlock|cbSelectedBlock,1,coord, &cCharsWritten);
			}
		}	
		else
		{
			coord.X = sx;
			coord.Y = sy;
			FillConsoleOutputAttribute(hCon,ct|cb,size,coord, &cCharsWritten);
		}
	}
///////////////////////////////////////////////////
	}
return 0;	

}