/*
	CTRL + Q		quit
	CTRL + R		refresh panel
	CTRL + D		run dos
	CTRL + E		history up
	CTRL + M		color config
	CTRL + UP		history up
	CTRL + DOWN		history down
	CTRL + C,V,X	clipboard actions in EDITOR

	CTRL + F1		sort by name
	CTRL + F2		sort by name dir first
	CTRL + F3		sort by extension dir first
	CTRL + F4		sort by extension dir first Mask
	CTRL + F5		sort by time
	CTRL + F6		sort by size
	CTRL + unsorted
	CTRL + F10		change attributes

	LALT + (LEFT or RIGHT)	change drive
	RALT + (A,B,C,D...)		change drive
	
	SHIFT + ENTER	run process on new console

*/

#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <windows.h>
#include <time.h>
//#include <objbase.h>
#include <shlobj.h>
#include "KWindow.h"
#include "File.h"
#include "Input.h"
#include "Misc.h"
#include "Dialog.h"
#include "Globals.h"
#include "Edit.h"
#include "Utils.h"
#include "Build.h"
#include "Reminder.h"
#include "CommLine.h"
#include "MacrosF.h"

//TPanel.showMethod
#define		PANEL_SHOW_TYPE_NAME		0
#define		PANEL_SHOW_TYPE_SIZE		1
#define		PANEL_SHOW_TYPE_SIZE_KB		2
#define		PANEL_SHOW_TYPE_DATE		3
#define		PANEL_SHOW_TYPE_DATETIME	4
#define		PANEL_SHOW_TYPE_ATTR		5

clock_t g_lastKeyPressTime;

NETRESOURCE *pnrs=NULL;

char sOldTitle[201];

#ifdef _MINGW32_
char barDefault[] = "1Help   2       3View   4Edit   5Copy   6RenMov 7Mkdir  8Delete 9Attr   10Quit";
char barAlt[] = "1Left   2Right  3MView  4       5Remind 6Size   7Find   8FindLa 9Macro  10    ";
char barCtrl[] =  "1Name   2NameDi 3Ext    4ExtSp  5Time   6Size   7Unsort 8       9       10SCfg";
char barUtil[] = "1Help   2       3       4       5       6       7       8       9       10Quit";
char barTask[] = "1Help   2New    3       4Edit   5       6       7       8Delete 9       10Quit";
#else
char barDefault[] = "1Help   2MkLink 3View   4Edit   5Copy   6RenMov 7Mkdir  8Delete 9Attr   10Quit";
char barAlt[] = "1Left   2Right  3MView  4       5Remind 6Size   7Find   8FindLa 9Macro  10Net ";
char barCtrl[] =  "1Name   2NameDi 3Ext    4ExtSp  5Time   6Size   7Unsort 8       9       10SCfg";
char barUtil[] = "1Help   2       3       4       5       6       7       8       9       10Quit";
char barTask[] = "1Help   2New    3       4Edit   5       6       7       8Delete 9       10Quit";
#endif
char *bar = barDefault;

HWND	g_KC_hwnd = NULL;

//prefixis
char	dir_prefix[5] = "\\";
char	file_prefix[5] = " ";
//is panels hide
BOOL	fHide = FALSE;
BOOL	g_bInfoHide = FALSE;
BOOL	g_bWaiting = FALSE;					//flag if kc is waiting for a key
BOOL	g_bInfoHideForce = FALSE;			//when panels are too big
BOOL	bIsInAltSearch = FALSE;
BOOL	bUtilActive = FALSE;				//if bUtilActive disable some functions
BOOL	bCtrlDown,bAltDown,bShiftDown;		//last statuses

HANDLE		hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
HANDLE		hBackOut,hTmpOut;
HANDLE		hStdIn = GetStdHandle(STD_INPUT_HANDLE);
INPUT_RECORD inputBuffer;
DWORD		dwInputEvents; /* number of events actually read */
KWindow		wl(hStdOut);	//left window
KWindow		wr(hStdOut);	//right window
KWindow		wi(hStdOut);	//info window	
KWindow		wb(hStdOut);	//bar window	
TCommandLine CommandLine;	//command line struct

//panel sizes
short g_lp_posx		= 0;
short g_lp_posy		= 0;
short g_lp_sizex	= 40;
short g_lp_sizey	= 19;
short g_rp_posx		= 40;
short g_rp_posy		= 0;
short g_rp_sizex	= 40;
short g_rp_sizey	= 19;
short g_ip_posx		= 0;
short g_ip_posy		= 19;
short g_ip_sizex	= 80;
short g_ip_sizey	= 4;

char	SelectMask[20] = "*.*";

char	g_PushDir[12][STR_SIZE];

long	g_max_history = 500;//max history commands
long	g_n_history = 0;	//n history commands
long	g_curr_history = 0;	//current history commands
char	**History;			//field for history

SHORT	lastKeyStatus,keyStatus;		//for CTRL ALT SHIFT

char	g_kc_help[STR_SIZE];

#define		SORT_BY_NAME			1
#define		SORT_BY_NAME_DIR		2
#define		SORT_BY_EXT				3
#define		SORT_BY_EXT_SPECIAL		4
#define		SORT_BY_TIME			5
#define		SORT_BY_SIZE			6
#define		SORT_UNSORTED			7

char		reminder_mutex_name[100];

DWORD		g_KcPriority;

#define		SEL_ROW(p,i)	p->Items[p->curr+i<p->nFiles?p->curr+i:p->nFiles].selected


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int SelectPanelCursor(KWindow *w, TPanel *p,int add,int row,HANDLE h = 0);
void DrawBar(char *bar,int y = 24);
void FillPanel(TPanel *p,KWindow *w,int startFile,BOOL bFind,char *name);
void MySetCurrentDirectory(char *dir);
BOOL ChangeDrive(char drive,TPanel *p,KWindow *w);
BOOL FindItem(char *name,long start,TPanel *p=*aPanel,KWindow *w=aWindow);
void GotoItem(long nItem,TPanel *p=*aPanel,KWindow *w=aWindow);
void AddHistory(char *command);
void SaveIniFile(char *fname);
void LoadAllIniColors(char *fname);
void DrawScrollBars(HANDLE hCon);
void PrintSortType(HANDLE hCon,TPanel *p,KWindow *w);
void RestoreConsoleBackground(HANDLE h = 0);
void RestoreKC(void);
void RefreshActivePanel(void);
void RefreshPanel(TPanel *p,KWindow *w,int startFile,BOOL bSelRow = FALSE);
void DrawInfoPanel(void);
void ChangeDirectory(char *dir);
short GetHighlightColor(WIN32_FIND_DATA *fd, TPanel *p);
BOOL CtrlHandler(DWORD fdwCtrlType);
void InitConsoleMode();


// ************************************************************************
// FUNCTION : EnumProcessListFunc( HWND, LPARAM )
// PURPOSE  : Callback function for EnumWindows
// COMMENTS : Inserts found window title strings into the listbox.
//            Return !NULL to continue enumeration.
// ************************************************************************
BOOL CALLBACK EnumProcessListFunc( HWND hWnd, LPARAM lParam )
{
  static DWORD dwCurrentProcessId;
  static BOOL  fFirstTime = TRUE;
  static LONG  MaxStrLen  = 0;
  static TCHAR TextBuffer[256];

  if( fFirstTime ) {
    fFirstTime = FALSE;
    dwCurrentProcessId = GetCurrentProcessId();
  }

  if( hWnd ) {
    GetWindowText( hWnd, (LPTSTR) &TextBuffer, sizeof(TextBuffer) );
    if( *TextBuffer ) 
	{
		if(!strcmp(TextBuffer,about))
		{
			g_KC_hwnd = hWnd;
		}
    }
  }
  return( TRUE );
}

//waiting thread for size 
void WaitWorkingSize(void)
{
	char	ch = '-';
	DWORD	dwSize = 0;
	long	nFiles = 0;
	HANDLE	hC = GetStdHandle(STD_OUTPUT_HANDLE); 
	HANDLE h_mutex = OpenMutex(MUTEX_ALL_ACCESS,FALSE,work_mutex_name);

	while(1)
	{
		Sleep(500);
		WaitForSingleObject(h_mutex,INFINITE);
		RefreshPanel((*aPanel),aWindow,(*aPanel)->curr - aWindow->curSelRow);
		SelectPanelCursor(aWindow,(*aPanel), 0 , aWindow->curSelRow);		
		switch(ch)
		{
			case '-' : ch = '\\'; break;
			case '\\' : ch = '|'; break;
			case '|' : ch = '/'; break;
			case '/' : ch = '-'; break;
		}
		clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctPanel,cbPanel,76,0,"(%c)",ch);
		ReleaseMutex(h_mutex);
	}
}


//--------------------------------------------------------
//		draw actions
//--------------------------------------------------------

int SelectPanelCursor(KWindow *w, TPanel *p,int add,int row,HANDLE h)
{
	HANDLE		handle;
	
	if(row < 0) return -1;
	if(row > w->sizeY - 3) return 1;

	if ( h == 0 ) handle = hStdOut;
	else handle = h;

	if(SEL_ROW(p,add)) return w->RowAttributeCon(handle,row,ctSelectItemX,cbPanelCursor);
	else 
	{
		short row_color = GetHighlightColor(&p->Items[p->curr+add].file, p);
		if (row_color == -1) return aWindow->RowAttributeCon(handle,row,ctPanelCursor,cbPanelCursor);
		else 
		{
			if ((row_color<<4) == cbPanelCursor) 
			{
				row_color = cbPanel>>4;
			}
			return aWindow->RowAttributeCon(handle,row,row_color,cbPanelCursor);
		}
	}
}

void ChangePanelsSizes(void)
{
		if(g_lp_sizey < 5) g_lp_sizey = 5;
		if(g_rp_sizey < 5) g_rp_sizey = 5;
		if(g_lp_sizey > 19 && g_rp_sizey > 19 && !g_bInfoHide && !g_bInfoHideForce) 
		{
			g_bInfoHideForce = TRUE;
			wi.Hide();
		}
		else
		{
			g_ip_posy = g_lp_sizey;
		}
		if(g_lp_sizey <= 19 && g_rp_sizey <= 19 && g_bInfoHideForce) 
		{
			g_bInfoHideForce = FALSE;
			DrawInfoPanel();
		}
		if(g_lp_sizey > 23) g_lp_sizey = 23;
		if(g_rp_sizey > 23) g_rp_sizey = 23;

		if(g_lp_sizex < 10) g_lp_sizex = 10;
		if(g_rp_sizex < 10) g_rp_sizex = 10;
		if(g_lp_sizex > 70) g_lp_sizex = 70;
		if(g_rp_sizex > 70) g_rp_sizex = 70;
		
		if(g_rp_posx < 10) g_rp_posx = 10;
		if(g_rp_posx > 70) g_rp_posx = 70;
		
		wl.SetSize(g_lp_sizex,g_lp_sizey);
		wr.SetSize(g_rp_sizex,g_rp_sizey);
		wl.SetPos(g_lp_posx,g_lp_posy);
		wr.SetPos(g_rp_posx,g_rp_posy);
		wi.SetPos(g_ip_posx,g_ip_posy);
		

		CopyConsoleScreen(hTmpOut,hStdOut);
		SetConsoleActiveScreenBuffer(hTmpOut);
		RestoreConsoleBackground();	
		RestoreKC();
		SetConsoleActiveScreenBuffer(hStdOut);
}

void SortPanel(TItem*& find_data,int nFiles)
{
	switch((*aPanel)->sortMethod)
	{
	case	SORT_BY_TIME	:		qsort(find_data,nFiles,sizeof(TItem),compareTime); break;
	case	SORT_BY_SIZE	:		qsort(find_data,nFiles,sizeof(TItem),compareSize); break;
	case	SORT_BY_NAME	:		qsort(find_data,nFiles,sizeof(TItem),compareName); break;
	case	SORT_BY_NAME_DIR :		qsort(find_data,nFiles,sizeof(TItem),compareNameDirFirst); break;
	case	SORT_BY_EXT		:		qsort(find_data,nFiles,sizeof(TItem),compareExtDirFirst); break;
	case	SORT_BY_EXT_SPECIAL :	qsort(find_data,nFiles,sizeof(TItem),compareExtDirFirstMask); break;
	case	SORT_UNSORTED:	break;
	}
}


/////////////////////////////////////////////
//DrawBar
//
//
/////////////////////////////////////////////
void DrawBar(char *bar,int y)
{
	COORD dwWriteCoord;
	DWORD cCharsWritten;
	static char tmp_bar[82];

	strncpy( tmp_bar, bar, 80 );
	if( bar == barCtrl ) {
		if(!(*aPanel)->ctrl_f1) memset( tmp_bar+1,' ',7);
		if(!(*aPanel)->ctrl_f2) memset( tmp_bar+9,' ',7);
		if(!(*aPanel)->ctrl_f3) memset( tmp_bar+17,' ',7);
		if(!(*aPanel)->ctrl_f4) memset( tmp_bar+25,' ',7);
		if(!(*aPanel)->ctrl_f5) memset( tmp_bar+33,' ',7);
		if(!(*aPanel)->ctrl_f6) memset( tmp_bar+41,' ',7);
		if(!(*aPanel)->ctrl_f7) memset( tmp_bar+49,' ',7);
		if(!(*aPanel)->ctrl_f8) memset( tmp_bar+57,' ',7);
		if(!(*aPanel)->ctrl_f9) memset( tmp_bar+65,' ',7);
		if(!(*aPanel)->ctrl_f10) memset( tmp_bar+74,' ',4);
	} else if( bar == barAlt ) {
		if(!(*aPanel)->alt_f1) memset( tmp_bar+1,' ',7);
		if(!(*aPanel)->alt_f2) memset( tmp_bar+9,' ',7);
		if(!(*aPanel)->alt_f3) memset( tmp_bar+17,' ',7);
		if(!(*aPanel)->alt_f4) memset( tmp_bar+25,' ',7);
		if(!(*aPanel)->alt_f5) memset( tmp_bar+33,' ',7);
		if(!(*aPanel)->alt_f6) memset( tmp_bar+41,' ',7);
		if(!(*aPanel)->alt_f7) memset( tmp_bar+49,' ',7);
		if(!(*aPanel)->alt_f8) memset( tmp_bar+57,' ',7);
		if(!(*aPanel)->alt_f9) memset( tmp_bar+65,' ',7);
		if(!(*aPanel)->alt_f10) memset( tmp_bar+74,' ',4);
	} else {
		if(!(*aPanel)->f1) memset( tmp_bar+1,' ',7);
		if(!(*aPanel)->f2) memset( tmp_bar+9,' ',7);
		if(!(*aPanel)->f3) memset( tmp_bar+17,' ',7);
		if(!(*aPanel)->f4) memset( tmp_bar+25,' ',7);
		if(!(*aPanel)->f5) memset( tmp_bar+33,' ',7);
		if(!(*aPanel)->f6) memset( tmp_bar+41,' ',7);
		if(!(*aPanel)->f7) memset( tmp_bar+49,' ',7);
		if(!(*aPanel)->f8) memset( tmp_bar+57,' ',7);
		if(!(*aPanel)->f9) memset( tmp_bar+65,' ',7);
		if(!(*aPanel)->f10) memset( tmp_bar+74,' ',4);
	}

	wb.gotoxy(0,y);
	printf("%s",tmp_bar);

	dwWriteCoord.X = 0;
	dwWriteCoord.Y = y;
	FillConsoleOutputAttribute(hStdOut,ctBarBackground|cbBarBackground, 80,dwWriteCoord, &cCharsWritten);
	for( int i = 0 ; i < 80 ; i+=8 )
	{
		if(i<70) dwWriteCoord.X = i+1;
		else dwWriteCoord.X = i+2;
		FillConsoleOutputAttribute(hStdOut,ctBarForeground|cbBarForeground, 6,dwWriteCoord, &cCharsWritten);
	}
}

/////////////////////////////////////////////
//PrintNSelectedFiles
//
// if some selected files print it
/////////////////////////////////////////////

void PrintNSelectedFiles(HANDLE hConsole,TPanel *p,KWindow *w)
{
	char stmp[50];
	char selsize[30],nsel[30];
	long nSelectedFiles;
	DWORD selFilesSize;

	if(w->GetSizeX() < 35) return;

	memset(stmp,0,40);
	memset(stmp,g_FrameChar[1],25);
	CalculateSelectedFiles(p,&nSelectedFiles,&selFilesSize);
	if(nSelectedFiles) 
	{
		FormatFileSize(selFilesSize,selsize);
		sprintf(nsel,"%ld",nSelectedFiles);
		FormatStringRight(5,nsel);
		FormatStringRight(15,selsize);
		clprintf(hConsole,ctSelectItemX,cbSelectItemX,w->posX + 8,w->posY + aWindow->sizeY - 1," %s / %s ",nsel,selsize);
	}
	else
	{
		clprintf(hConsole,ctPanel,cbSelectItemX,w->posX + 8,w->posY + aWindow->sizeY - 1,"%s",stmp);
	}

}

//prints row [name size] or [name date] ......
////////////////////////////////
char* PrintRowType(char *name,int size,TItem *item,DWORD showMethod)
{
	char	s_tmp[STR_SIZE];
	char	s_tmp1[STR_SIZE];
	char	s_tmp2[STR_SIZE];
	char	attr[STR_SIZE];
	DWORD	dwAttr;

//name
	if(item->file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )	
	{
		sprintf(name,"%s%s",dir_prefix,item->file.cFileName);
	}
	else
	{
		sprintf(name,"%s%s",file_prefix,item->file.cFileName);
	}
//types
	switch(showMethod)
	{
		case PANEL_SHOW_TYPE_SIZE :
		{
			if(item->file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )	
			{
				if(item->dirsize != -1) FormatFileSize(item->dirsize,s_tmp);
				else FormatFileSize(0,s_tmp);
				StringLeftOrRight(name,s_tmp,size);
			}
			else
			{
				FormatFileSize(item->file.nFileSizeLow,s_tmp);
				StringLeftOrRight(name,s_tmp,size);
			}
			break;
		}
		case PANEL_SHOW_TYPE_SIZE_KB :
		{
			if(item->file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )	
			{
				if(item->dirsize != -1) FormatFileSize(item->dirsize/1024,s_tmp);
				else FormatFileSize(0,s_tmp);
				sprintf(s_tmp1,"%sK",s_tmp);
				StringLeftOrRight(name,s_tmp1,size);
			}
			else
			{
				FormatFileSize(item->file.nFileSizeLow/1024,s_tmp);
				sprintf(s_tmp1,"%sK",s_tmp);
				StringLeftOrRight(name,s_tmp1,size);
			}
			break;
		}
		case PANEL_SHOW_TYPE_DATE :
		{
			FormatDate(&item->file.ftLastWriteTime,s_tmp);			
			StringLeftOrRight(name,s_tmp,size);
			break;
		}
		case PANEL_SHOW_TYPE_DATETIME :
		{
			FormatDate(&item->file.ftLastWriteTime,s_tmp);			
			FormatTime(&item->file.ftLastWriteTime,s_tmp1);
			sprintf(s_tmp2,"%s-%s",s_tmp,s_tmp1);
			StringLeftOrRight(name,s_tmp2,size);
			break;
		}

		case PANEL_SHOW_TYPE_ATTR :
		{
			strcpy(attr,"______");
			dwAttr = item->file.dwFileAttributes;
			if(dwAttr != 0xFFFFFFFF)
			{
				if(dwAttr & FILE_ATTRIBUTE_ARCHIVE) attr[0] = 'A';
				if(dwAttr & FILE_ATTRIBUTE_READONLY) attr[1] = 'R';
				if(dwAttr & FILE_ATTRIBUTE_HIDDEN) attr[2] = 'H';
				if(dwAttr & FILE_ATTRIBUTE_SYSTEM) attr[3] = 'S';
				if(dwAttr & FILE_ATTRIBUTE_COMPRESSED) attr[5] = 'C';
				if(dwAttr & FILE_ATTRIBUTE_TEMPORARY) attr[6] = 'T';
				attr[7] = 0;
			}
			else strcpy(attr,"error");
			StringLeftOrRight(name,attr,size);
			break;
		}	
	
	
	}
return name;
}

short GetHighlightColor(WIN32_FIND_DATA *fd, TPanel *p )
{
	long	i;
	char	s_tmp[STR_SIZE];
	char	*pend,*pstart;
	short	color = -1;

	if(!g_bHighlight_on) return color;

	if( IS_PT(p->pt,PT_TASK) ) {
		char ch = toupper((char)fd->nFileSizeHigh);
		switch( ch ) {
		case 'B' : color = T_BLACK_L; break;
		case 'U' : color = T_BLUE_L; break;
		case 'G' : color = T_GREEN_L; break;
		case 'R' : color = T_RED_L; break;
		case 'V' : color = T_VIOLET_L; break;
		case 'Y' : color = T_YELLOW_L; break;
		case 'W' : color = T_WHITE_L; break;
		default  : color = ctFindPanel; 
		}
	} else {
		if(!fd->cFileName) return color;
		for( i = 0; i < g_nExtHighlight; i++ ) 	{
			//test attributes
			if((fd->dwFileAttributes & g_ExtHighlight[i].attr)) {
				color = g_ExtHighlight[i].color;
				break;
			}
			//test mask		
			strcpy(s_tmp,g_ExtHighlight[i].ext);
			pstart = s_tmp;
			pend = pstart;
			while(1) {
				pend = strchr(pstart,';');
				if(!pend) break;
				else {
					*pend = 0;
					if(checkname(fd->cFileName,pstart)) {
						color = g_ExtHighlight[i].color;
						break;
					}
					pstart = pend + 1;
					if((s_tmp+STR_SIZE) <= pend) break;
				}
			}
			if (color != -1) break;
		}
	}
return color;
}

//refresh panel
////////////////////////////////////////////
void RefreshPanel(TPanel *p,KWindow *w,int startFile,BOOL bSelRow)
{
	char	name[STR_SIZE];

	HideCursor(hStdOut,TRUE);
	if(startFile >= p->nFiles)	 startFile = p->nFiles - 1;
//show
//	CopyConsoleScreen(hBackOut,hStdOut);
	if(IS_PT(p->pt,PT_FIND) || IS_PT(p->pt,PT_NET) || IS_PT(p->pt,PT_TASK) ) {
		w->SetTC(ctFindPanel);
		w->SetBC(cbFindPanel);
		cbSelectItemX = cbFindPanel;
		ctSelectItemX = ctSelectItemFind;
	} else	if(bTaskMgrActive && p == pLeftPanel) {
				w->SetTC(ctFindPanel);
				w->SetBC(cbFindPanel);
				cbSelectItemX = cbFindPanel;
				ctSelectItemX = ctSelectItemFind;
	} else {
				w->SetTC(ctPanel);
				w->SetBC(cbPanel);
				cbSelectItemX = cbPanel;
				ctSelectItemX = ctSelectItem;
	}
	w->Show(hBackOut);
	if( startFile >= 0) {
		for ( int i = 0; i < w->sizeY - 2 && (i + startFile) < p->nFiles; i++ ) {
			PrintRowType(name,w->sizeX-2,&p->Items[i+startFile],p->showMethod);
			
			if(!p->Items[i+startFile].selected) {
				w->WriteRow(hBackOut,i,name,GetHighlightColor(&p->Items[i+startFile].file, p) );
			} else {
				w->WriteRow(hBackOut,i,name,ctSelectItemX,cbSelectItemX);
			}
		}
	}
	PrintNSelectedFiles(hBackOut,p,w);
	PrintSortType(hBackOut,p,w);
	DrawScrollBars(hBackOut);
	if(bSelRow)	SelectPanelCursor(w, p, 0,w->curSelRow,hBackOut);
	CopyConsoleWindow(hStdOut,hBackOut,w->posX,w->posY,w->sizeX,w->sizeY);
	HideCursor(hStdOut,FALSE);

}

//refresh panel + Resort panel
//
////////////////////////////////////////////
void ReSortPanel(TPanel *p,KWindow *w,int startFile)
{
	char s_tmp[STR_SIZE];
	
	if( p->nFiles ) {
		strcpy(s_tmp,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
		SortPanel((*aPanel)->Items,(*aPanel)->nFiles);
		RefreshPanel(p,w,startFile);
		FindItem(s_tmp,0);
	} else {
		RefreshPanel(p,w,0);
	}
}

////////////////////////////////////////////
//fill panel on direct change
// p			) panel
// w			- window
// startFile	- start file
// bFind		- if bFind find name
////////////////////////////////////////////
void FillPanel(TPanel *p,KWindow *w,int startFile,BOOL bFind=FALSE,char *name=NULL)
{
	BOOL bFindItem = FALSE;

	if(fHide) return;
	GetCurrentDirectory(STR_SIZE-1,aDirectory);
	w->SetLabel(aDirectory);
	LoadPanel(p);
	p->curr = 0;
	SortPanel(p->Items,p->nFiles);
	if(bFind)
	{
		bFindItem = FindItem(name,0);
	}
	if(!bFind || !bFindItem)
	{
		w->curSelRow = 0;
		p->curr = 0;
		RefreshPanel(p,w,startFile,TRUE);
	}
	DrawBar(bar);
}

//used for thread 
void FillPanelDirThread(TPanel *p,KWindow *w,char *directory,int startFile,BOOL bFind=FALSE,char *name=NULL)
{
	BOOL bFindItem = FALSE;

	if(fHide) return;
	w->SetLabel(directory);
	SavePanelSelectedNames(p);
	LoadPanel(p,directory);
	SelectFilesAfterRefresh(p);
	p->curr = 0;
	SortPanel(p->Items,p->nFiles);
	w->curSelRow = 0;
	p->curr = 0;
	//RefreshPanel(p,w,startFile,TRUE);
	if(!FindItem(name,0,p,w)) RefreshPanel(p,w,startFile,TRUE);
}


//////////////////////////////////////////
//Draw scroll bars
//
//
//////////////////////////////////////////
void DrawScrollBars(HANDLE hCon)
{
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;
	float	scroll_pos;
	int		i;

//left panel
		dwWriteCoord.X = wl.posX;
		dwWriteCoord.Y = wl.posY;
		for(i = 2; i < wl.sizeY - 2; i++)
		{
			dwWriteCoord.X = wl.posX + wl.sizeX - 1;
			dwWriteCoord.Y = wl.posY + i;
			FillConsoleOutputCharacter(hCon,g_FrameChar[10], 1,dwWriteCoord, &cCharsWritten);
		}
		scroll_pos = (float)((float)(wl.sizeY-4) / (float)pLeftPanel->nFiles);
		scroll_pos *= (float)pLeftPanel->curr;
		dwWriteCoord.Y = wl.posY + 2 + (short)scroll_pos;
		FillConsoleOutputCharacter(hCon,g_FrameChar[11], 1,dwWriteCoord, &cCharsWritten);
		dwWriteCoord.Y = wl.posY + 1;
		FillConsoleOutputCharacter(hCon,g_FrameChar[8], 1,dwWriteCoord, &cCharsWritten);
		dwWriteCoord.Y = wl.posY + wl.sizeY - 2;
		FillConsoleOutputCharacter(hCon,g_FrameChar[9], 1,dwWriteCoord, &cCharsWritten);
//right panel
		dwWriteCoord.X = wr.posX;
		dwWriteCoord.Y = wr.posY;
		for(i = 2; i < wr.sizeY - 2; i++)
		{
			dwWriteCoord.X = wr.posX + wr.sizeX - 1;
			dwWriteCoord.Y = wr.posY + i;
			FillConsoleOutputCharacter(hCon,g_FrameChar[10], 1,dwWriteCoord, &cCharsWritten);
		}
		scroll_pos = (float)((float)(wr.sizeY-4) / (float)pRightPanel->nFiles);
		scroll_pos *= (float)pRightPanel->curr;
		dwWriteCoord.Y = wr.posY + 2 + (short)scroll_pos;
		FillConsoleOutputCharacter(hCon,g_FrameChar[11], 1,dwWriteCoord, &cCharsWritten);
		dwWriteCoord.Y = wr.posY + 1;
		FillConsoleOutputCharacter(hCon,g_FrameChar[8], 1,dwWriteCoord, &cCharsWritten);
		dwWriteCoord.Y = wr.posY + wl.sizeY - 2;
		FillConsoleOutputCharacter(hCon,g_FrameChar[9], 1,dwWriteCoord, &cCharsWritten);
}
//////////////////////////////////////////
//Draw scroll bars
//
//
//////////////////////////////////////////
void PrintSortType(HANDLE hCon,TPanel *p,KWindow *w)
{
	char s_tmp[STR_SIZE];

//left panel
		switch(p->sortMethod)
		{
		case SORT_BY_NAME			: strcpy(s_tmp,"Na"); break;
			case SORT_BY_NAME_DIR	: strcpy(s_tmp,"ND"); break;
			case SORT_BY_EXT		: strcpy(s_tmp,"Ex"); break;
			case SORT_BY_EXT_SPECIAL: strcpy(s_tmp,"Es"); break;
			case SORT_BY_TIME		: strcpy(s_tmp,"Ti"); break;
			case SORT_BY_SIZE		: strcpy(s_tmp,"Si"); break;
			case SORT_UNSORTED		: strcpy(s_tmp,"Un"); break;
		}
		clprintf(hCon,ctSelectItemX,cbSelectItemX,w->posX+2,w->posY+w->sizeY-1,"%s",s_tmp);
}


//////////////////////////////////////////
//Refresh active panel
//
//CTRL + R 
//////////////////////////////////////////
void RefreshActivePanel(void)
{
	char tmp[STR_SIZE];
	
	if(IS_PT((*aPanel)->pt,PT_TASK)) {
		LoadTaskPanel( &taskPanel );
		(*aPanel)->sortMethod = SORT_BY_SIZE;
		ReSortPanel((*aPanel),aWindow,0);
	} else {
		strcpy(tmp,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
		FillPanel((*aPanel),aWindow,0,TRUE,tmp);
	}
}


//////////////////////////////////////////
//RefreshInfoPanel
//
// refresh values in infopanel
//////////////////////////////////////////
void RefreshInfoPanel(void)
{
	DWORD	dwAttr,dwSizeHigh;
	char	drvFree[30],drvTotal[30];
	char	date[22]="error     ",time[22]="error   ",size[30]="error",compsize[30]="no compression";
	char	drives[50];
	char	attr[10] = "    -  ";
	char	drv_type[STR_SIZE] = "";
	char	drv_fstype[STR_SIZE] = "";
	char	stmp[STR_SIZE],stmp1[STR_SIZE];

	if(g_bInfoHide || g_bInfoHideForce) return;

	
//get space	
	if(!GetDriveSpace(aDirectory,drvFree,drvTotal))
	{
		ChangeDrive('C',(*aPanel),aWindow);
		GetDriveSpace(aDirectory,drvFree,drvTotal);
	}
	FormatStringRight(15,drvFree);
	FormatStringRight(15,drvTotal);

	GetDriveTypeMy(aDirectory,drv_type,drv_fstype);

	if((*aPanel)->curr < (*aPanel)->nFiles)
	{
//		if((*aPanel)->Items[(*aPanel)->curr].file.time_write != -1) 
//		{	
			FormatDate(&(*aPanel)->Items[(*aPanel)->curr].file.ftLastWriteTime,date);
			FormatTime(&(*aPanel)->Items[(*aPanel)->curr].file.ftLastWriteTime,time);
//		}
		FormatFileSize((*aPanel)->Items[(*aPanel)->curr].file.nFileSizeLow,size);
	}
//if size of dir is scanned show dirsize
	if(IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
	{
		if((*aPanel)->Items[(*aPanel)->curr].dirsize == (DWORD)-1)
		{
			strcpy(size,"<DIR>");
			strcpy(compsize,"<DIR>");
		}
		else 
		{
			FormatFileSize((*aPanel)->Items[(*aPanel)->curr].dirsize,size);
			FormatFileSize((*aPanel)->Items[(*aPanel)->curr].dircompsize,compsize);
		}
	}
	dwAttr = (*aPanel)->Items[(*aPanel)->curr].file.dwFileAttributes;
//get attr
	if(dwAttr != 0xFFFFFFFF)
	{
		if(dwAttr & FILE_ATTRIBUTE_ARCHIVE) attr[0] = 'A';
		if(dwAttr & FILE_ATTRIBUTE_READONLY) attr[1] = 'R';
		if(dwAttr & FILE_ATTRIBUTE_HIDDEN) attr[2] = 'H';
		if(dwAttr & FILE_ATTRIBUTE_SYSTEM) attr[3] = 'S';
		if(dwAttr & FILE_ATTRIBUTE_COMPRESSED) attr[5] = 'C';
		if(dwAttr & FILE_ATTRIBUTE_TEMPORARY) attr[6] = 'T';
	}
	else strcpy(attr,"error");
	FormatStringRight(15,size);

	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,2+5,g_ip_posy+1,"%s",size);
	if((dwAttr & FILE_ATTRIBUTE_COMPRESSED) && !IsDir(&(*aPanel)->Items[(*aPanel)->curr]))
	{
		FormatFileSize(GetCompressedFileSize((*aPanel)->Items[(*aPanel)->curr].file.cFileName,&dwSizeHigh),compsize);
	}
	FormatStringRight(15,compsize);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,2+5,g_ip_posy+2,"%s",compsize);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,23+5,g_ip_posy+1,"%s",attr);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,40+5,g_ip_posy+1,"%s",date);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,40+5,g_ip_posy+2,"%s  ",time);
	
	sprintf(stmp,"%s/%s",drv_type,drv_fstype);
	CreateSpaceString(stmp1,stmp,15);
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,57+6,g_ip_posy,"%s",stmp1);
	CreateSpaceString(stmp,drv_type,15);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,57+6,g_ip_posy+1,"%s",drvFree);
	clprintf(hBackOut,ctInfoPanelCell,cbInfoPanelCell,57+6,g_ip_posy+2,"%s",drvTotal);

	GetDrivesInString(drives);
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,3,g_ip_posy+3," %s ",drives);
	char *p = strchr(drives,toupper(aDirectory[0]));
	if(p)
	{
		short i = p - drives;
		SetAttribute(hBackOut,ctSmallDrive,cbSmallDrive,(short)(3+1+i),g_ip_posy+3,1);
	}

	DrawScrollBars(hBackOut);
}


/////////////////////////////////////////
//DrawInfoPanel
//
//draw complete info panel
/////////////////////////////////////////
void DrawInfoPanel(void)
{
	COORD dwWriteCoord;
	DWORD cCharsWritten;

	if(g_bInfoHide || g_bInfoHideForce || IS_PT((*aPanel)->pt,PT_NET) ) return;
	
	HideCursor(hStdOut,TRUE);
	wi.SetTC(ctInfoPanel);
	wi.SetBC(cbInfoPanel);
	wi.SetLabel("File                                                  Drive");	
	wi.Show(hBackOut);		

	dwWriteCoord.X = 8;
	dwWriteCoord.Y = g_ip_posy;
	FillConsoleOutputCharacter(hBackOut,(char)g_FrameChar[1], 48,dwWriteCoord, &cCharsWritten);

	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,2,g_ip_posy+1,"size:");
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,2,g_ip_posy+2,"cize:");
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,23,g_ip_posy+1,"attr:");
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,40,g_ip_posy+1,"date:");
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,40,g_ip_posy+2,"time:");
	
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,57,g_ip_posy+1,"free :");
	clprintf(hBackOut,ctInfoPanel,cbInfoPanel,57,g_ip_posy+2,"total:");
	RefreshInfoPanel();
	CopyConsoleWindow(hStdOut,hBackOut,wi.posX,wi.posY,wi.sizeX,wi.sizeY);
	HideCursor(hStdOut,FALSE);
}
////////////////////////////////////
//SaveConsoleBackground
//
// save console background
////////////////////////////////////
void SaveConsoleBackground(void)
{
	wl.SaveBG();
	wr.SaveBG();
	wi.SaveBG();
	wb.SaveBG();
}

////////////////////////////////////
//RestoreConsoleBackground
//
// restore console background
////////////////////////////////////
void RestoreConsoleBackground(HANDLE h)
{
	wl.RestoreBG(h); 
	wr.RestoreBG(h);
	wi.RestoreBG(h);
	wb.RestoreBG(h);
}
////////////////////////////////////
//RestoreKC
//
// restore KC commander
////////////////////////////////////
void RestoreKC(void)
{
	SaveConsoleBackground();
	RefreshPanel(pLeftPanel,&wl,pLeftPanel->curr - wl.curSelRow);
	RefreshPanel(pRightPanel,&wr,pRightPanel->curr - wr.curSelRow);
	SelectPanelCursor(aWindow, (*aPanel), 0,aWindow->curSelRow);
	DrawInfoPanel();
	DrawBar(bar);
	CommandLineServis(&CommandLine,0,0,0);
}

////////////////////////////////////
//SelectFile
//
//
////////////////////////////////////
void SelectFile(void)
{
	long curRS = aWindow->curSelRow;
	if(strcmp((*aPanel)->Items[(*aPanel)->curr].file.cFileName,".."))
	{
		(*aPanel)->Items[(*aPanel)->curr].selected ^= 1;
	}
	PrintNSelectedFiles(hStdOut,(*aPanel),aWindow);
}

//--------------------------------------------------------
//		input actions
//--------------------------------------------------------


//MoveRowDown
///////////////////////////////////////////////////
void MoveRowDown(KWindow *w,TPanel *p)
{
	if(p->nFiles - p->curr - 1 <= 0)
	{
		SelectPanelCursor(w, p, 0,w->curSelRow);
		return;
	}
 	if(!SelectPanelCursor(w, p, 1 , w->curSelRow + 1))
	{
		if(!p->Items[p->curr].selected) w->RowAttribute(w->curSelRow,GetHighlightColor(&p->Items[p->curr].file, p ));
		else w->RowAttribute(w->curSelRow,ctSelectItemX,cbSelectItemX);
		w->curSelRow++;
		p->curr++;
	}
	else
	{
		if(p->curr < p->nFiles)
		{
			RefreshPanel(p,w,++p->curr - (w->sizeY - 3),TRUE);
		}
	}
}

//MovePageDown
///////////////////////////////////////////////////
void MovePageDown(KWindow *w,TPanel *p)
{
	if(p->nFiles < (w->sizeY - 2))
	{
		RefreshPanel(p,w,0);
		w->curSelRow = p->nFiles - 1;
		p->curr = p->nFiles - 1;
		SelectPanelCursor(w, p, 0,w->curSelRow);
	}
	else
	{
		if(p->nFiles - p->curr - 1 <= (2*(w->sizeY - 3)))
		{
			RefreshPanel(p,w,p->nFiles - (w->sizeY - 2));
			w->curSelRow = w->sizeY - 3;
			p->curr = p->nFiles - 1;
			SelectPanelCursor(w, p, 0,w->curSelRow);
		}
		else
		{
			p->curr += (w->sizeY - 2 - 1) - w->curSelRow;
			RefreshPanel(p,w,p->curr);
			w->curSelRow = 0;
			SelectPanelCursor(w, p, 0,w->curSelRow);
		}
	}
}


//MoveRowUp
///////////////////////////////////////////////////
void MoveRowUp(KWindow *w,TPanel *p)
{
	if(p->curr - 1 < 0)
	{
		w->curSelRow = 0;
		p->curr = 0;
		return;
	}
	if(!SelectPanelCursor(w, p, -1 , w->curSelRow - 1))
	{
		if(!p->Items[p->curr].selected) w->RowAttribute(w->curSelRow,GetHighlightColor(&p->Items[p->curr].file,p));
		else w->RowAttribute(w->curSelRow,ctSelectItemX,cbSelectItemX);
		w->curSelRow--;
		p->curr--;
	}
	else
	{
		if(p->curr > 0)
		{
			RefreshPanel(p,w,--p->curr,TRUE);
		}
	}
}

//MovePageUp
///////////////////////////////////////////////////
void MovePageUp(KWindow *w,TPanel *p)
{
	if((p->curr - w->curSelRow) <= (w->sizeY - 3))
	{
		RefreshPanel(p,w,0);
		w->curSelRow = 0;
		p->curr = 0;
	}
	else
	{
		p->curr -= w->curSelRow;
		RefreshPanel(p,w,p->curr-(w->sizeY - 3));
		w->curSelRow = w->sizeY - 3;
	}
	SelectPanelCursor(w, p, 0 , w->curSelRow);
}

///////////////////////////////////////////
//SetActivePanel
//
//sets active panel (LEFT or RIGHT)
//////////////////////////////////////////
void SetActivePanel(int ap)
{
	static BOOL lastPanelFind;
	
	//unselect active row
	if(!(*aPanel)->Items[(*aPanel)->curr].selected) aWindow->RowAttribute(aWindow->curSelRow,GetHighlightColor(&(*aPanel)->Items[(*aPanel)->curr].file,(*aPanel)));
	else aWindow->RowAttribute(aWindow->curSelRow,ctSelectItemX,cbSelectItemX);
	//select new
	if(ap == LEFT)
	{
		ActivePanel = RIGHT;
		aPanel = &pRightPanel;
		aWindow = &wr;
		aDirectory = rDirectory;
	}
	else
	{
		ActivePanel = LEFT;
		aPanel = &pLeftPanel;
		aWindow = &wl;
		aDirectory = lDirectory;
	}
	if(IS_PT((*aPanel)->pt,PT_FIND) || IS_PT((*aPanel)->pt,PT_NET))
	{
		ctSelectItemX = ctSelectItemFind;
		cbSelectItemX = cbFindPanel;
	}
	else
	{
		ctSelectItemX = ctSelectItem;
		cbSelectItemX = cbPanel;
	}
	MySetCurrentDirectory(aDirectory);
	SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);
}

void RefreshPanels(void)
{
	SetActivePanel(ActivePanel);
	FillPanel((*aPanel),aWindow,0);
	SetActivePanel(ActivePanel);
	FillPanel((*aPanel),aWindow,0);
}


void GotoItem(long nItem,TPanel *p,KWindow *w)
{
	if(nItem >= p->nFiles) nItem = p->nFiles - 1;
	if(nItem > (w->sizeY - 3))
	{
		w->curSelRow = (w->sizeY - 3);
		p->curr = nItem;
		RefreshPanel(p,w,nItem - (w->sizeY - 3),TRUE);
//		SelectPanelCursor(w, p, 0 , w->curSelRow);		
	}
	else
	{
		w->curSelRow = (short)nItem;
		p->curr = nItem;
		RefreshPanel(p,w,0,TRUE);
//		SelectPanelCursor(w, (*aPanel), 0 , w->curSelRow);		
	}
 }

//FindItem
// for Alt+char find file name
///////////////////////////////////
BOOL FindItem(char *name,long start,TPanel *p,KWindow *w)
{
	for(long i = start ; i < p->nFiles; i++ )
	{
		if(!strnicmp(p->Items[i].file.cFileName,name,strlen(name)))
		{
			GotoItem(i,p,w);
			return TRUE;
		}
	}
return FALSE;
}


void FindPanelGOTOFilePanel(void)
{
	char s_tmp[STR_SIZE],s_tmp1[STR_SIZE];
	
	cbSelectItemX = cbPanel;
	strcpy(s_tmp,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	strcpy(s_tmp1,(*aPanel)->Items[(*aPanel)->curr].path);
	if(ActivePanel == LEFT) 
	{
		(*aPanel) = &filePanel1; 
	}
	else 
	{
		(*aPanel) = &filePanel2;
	}
	ChangeDirectory(s_tmp1);
	FindItem(s_tmp,0);
}

bool NetPanelGOTOFilePanel( LPNETRESOURCE lpnrs, char *user = NULL, char *password = NULL )
{
#ifndef _MINGW32_
	char local[STR_SIZE]="t:";

	WNetCancelConnection2(local,0,TRUE);
	lpnrs->lpLocalName = local;
	if(ActivePanel == LEFT) {
		(*aPanel) = &filePanel1; 
	} else {
		(*aPanel) = &filePanel2;
	}
	bar = barDefault;
	bUtilActive = FALSE;
	if( WNetAddConnection2(lpnrs,user,password,0) == NO_ERROR ) {
		ChangeDirectory("T:\\");
	} else { 
		InfoMessage(hStdOut,"Error","Network error ! Going to C: .... ");
		DrawBar(bar);
		ChangeDirectory("C:\\");
		return false;
	}
#endif
return true;
}


// MySetCurrentDirectory
/////////////////////////////////////
void MySetCurrentDirectory(char *dir)
{
	if(!SetCurrentDirectory(dir))
	{
		InfoMessage(hStdOut,"Error","Cannot change directory.");
	}
//		ChangeDrive('C',(*aPanel),aWindow);
}

// ChangeDirectory
/////////////////////////////////////
void ChangeDirectory(char *dir)
{
	char nameToSet[STR_SIZE],tmp[STR_SIZE];

		GetCurrentDirectory(STR_SIZE,nameToSet);
		strcpy(tmp,nameToSet);
		
		strrev(tmp);
		for(int i = 0; tmp[i] != '\\' && tmp[i] != 0; i++) nameToSet[i] = tmp[i];
		nameToSet[i] = 0;
		strrev(nameToSet);

		MySetCurrentDirectory(dir);
		if(!strcmp(dir,".."))
		{
			FillPanel((*aPanel),aWindow,0,TRUE,nameToSet);
		}
		else FillPanel((*aPanel),aWindow,0);
}

//ChangeDrive
/////////////////////////////
BOOL ChangeDrive(char drive,TPanel *p,KWindow *w)
{
	char tmp[10];
	sprintf(tmp,"%c:\\",drive);
	if(SetCurrentDirectory(tmp)) FillPanel(p,w,0);
	else return FALSE;
	
return TRUE;
}


void ChangeDriveShift(int currDrv,BOOL bLeft)
{
	char	drives[50];
	char	*p;
	char	newDrv;

	if( IS_PT((*aPanel)->pt,PT_FIND) || IS_PT((*aPanel)->pt,PT_NET) || IS_PT((*aPanel)->pt,PT_TASK) ) return;

	currDrv = toupper(currDrv);
	GetDrivesInString(drives);
	p = strchr(drives,currDrv);
	if(bLeft)
	{
		if(p == drives) return;
		newDrv = (char)*(p-1);
	}
	else
	{
		if(*(p+1) == 0) return;
		newDrv = (char)*(p+1);
	}
	
	if(!ChangeDrive((char)newDrv,(*aPanel),aWindow))
	{
		ChangeDriveShift(newDrv,bLeft);
	}
	if(!strnicmp(lDirectory,rDirectory,2))
	{
		if(ActivePanel == LEFT) strcpy(lDirectory,rDirectory);
		else strcpy(rDirectory,lDirectory);
		ChangeDirectory(aDirectory);
	}
}


//select unselect (window)
//////////////////////////////////
void SelectItems(BOOL bSelect,char *label)
{
	KWindow w(hStdOut);
	TInput i(hStdOut);
	w.Init(label,30,10,20,3,ctDialog,cbDialog);
	w.SaveBG();
	w.Show(hStdOut);
	if(i.Input(SelectMask,31,11,18,ctInput,cbInput) == 13)
	{
		strcpy(SelectMask,i.GetText());
		for(int i = 0 ; i < (*aPanel)->nFiles; i++ )
		{
			if(checkname((*aPanel)->Items[i].file.cFileName,SelectMask)
				&& strcmp((*aPanel)->Items[i].file.cFileName,".."))
				(*aPanel)->Items[i].selected = bSelect;
		}
	}
	w.RestoreBG();
	RefreshPanel((*aPanel),aWindow,(*aPanel)->curr - aWindow->curSelRow);
	SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
}

// THREAD REMINDER
//
//////////////////////////////////
void ReminderThread(void)
{
	int				retval;
	HANDLE			h_mutex;
	INPUT_RECORD	inputBuffer;
//	DWORD			priority,old_priority;

	h_mutex = OpenMutex(MUTEX_ALL_ACCESS,FALSE,reminder_mutex_name);

	while(1)
	{
		Sleep(1000);
//reminder
		retval = ReminderTestTasks();
		if(retval != -1) 
		{
			if(g_KC_hwnd) 
			{
				SetForegroundWindow(g_KC_hwnd);
				ShowWindow(g_KC_hwnd,SW_SHOWNORMAL);
			}
			WaitForSingleObject(h_mutex,INFINITE);

			inputBuffer.Event.KeyEvent.wVirtualKeyCode = VK_F24;
			inputBuffer.Event.KeyEvent.bKeyDown = 1;
			inputBuffer.EventType = KEY_EVENT;
			//send VK_F24 to main loop to run action
			//in scancode send task number :-)
			inputBuffer.Event.KeyEvent.wVirtualScanCode = (WORD)retval;
			WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
			//DialogReminderTaskNotifyEdit(retval);
			ReminderUnactivateTask(retval);
			ReleaseMutex(h_mutex);
		}
/*
//		REFRESH PANEL
  
	char			tmp[STR_SIZE];
//if not waiting reset clock wait
		if(!g_bWaiting){
			g_lastKeyPressTime=clock();
		}
//refresh panels when filecount changes (wait 5 second of inactivity)
		if(g_bWaiting && !fHide && !bUtilActive 
			&& g_lastKeyPressTime<(clock()-(5*CLOCKS_PER_SEC))){
				if(TestPanelChange(pLeftPanel,lDirectory) && !pLeftPanel->find){
					strcpy(tmp,pLeftPanel->Items[pLeftPanel->curr].file.cFileName);
					FillPanelDirThread(pLeftPanel,&wl,lDirectory,0,TRUE,tmp);
				}
				if(TestPanelChange(pRightPanel,rDirectory) && !pRightPanel->find){
					strcpy(tmp,pRightPanel->Items[pRightPanel->curr].file.cFileName);
					FillPanelDirThread(pRightPanel,&wr,rDirectory,0,TRUE,tmp);
				}
		}
*/

//test priority
/*
		priority = GetPriorityClass(GetCurrentProcess());
		if(GetForegroundWindow() == g_KC_hwnd)
		{
			if(priority == IDLE_PRIORITY_CLASS)
				SetPriorityClass(GetCurrentProcess(),old_priority);
		}
		else
		{
			if(priority != IDLE_PRIORITY_CLASS)
			{				
				old_priority = priority;
				SetPriorityClass(GetCurrentProcess(),IDLE_PRIORITY_CLASS);
			}
		}
*/
	}
}



//EnterAction
/////////////////////////////
void EnterAction(INPUT_RECORD& inputBuffer)
{
	char	s_tmp[STR_SIZE],s_regfile[STR_SIZE];
	DWORD priority = 0;

	if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) priority |= IDLE_PRIORITY_CLASS;
	else priority = g_KcPriority;
	if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))  priority |= CREATE_NEW_CONSOLE;

	if(strlen(CommandLine.buffer) || fHide)
	{
		//cd change directory
		if( !strnicmp(CommandLine.buffer,"cd",2))
		{
			char *p = CommandLine.buffer+2;
			while(isspace(*(p))) {p++;};
			ChangeDirectory(p);
		}
		//run command
		else
		{
			if(!fHide) RestoreConsoleBackground();	
			if(!RunProcess(CommandLine.buffer,priority))
			{
				//find if filetype is registered
				if((DWORD)(FindExecutable(CommandLine.buffer,"",s_regfile))>32)
					sprintf(s_tmp,"%s \"%s\"",s_regfile,CommandLine.buffer);
				else sprintf(s_tmp,"cmd /C \"%s\"",CommandLine.buffer);
				RunProcess(s_tmp,priority);
			}
			if(!fHide) 
			{
				RestoreKC();
				RefreshActivePanel();
			}
		}
		//init ctrl + c handler ....
		InitConsoleMode();
		//add to history
		AddHistory(CommandLine.buffer);
		//reset command line
		CommandLine.x = 3;	
		CommandLine.bufpos = 0;	
		strcpy(CommandLine.buffer,"");	
		CommandLineServis(&CommandLine,0,0,0);
	} else {
		if(IS_PT((*aPanel)->pt,PT_FIND)) {  //find
			FindPanelGOTOFilePanel();
		} else if (IS_PT((*aPanel)->pt,PT_TASK)) { //tasks
			if(DialogReminderTaskNotifyEdit(taskPanel.Items[taskPanel.curr].dircompsize,TRUE) == 13 )
				RefreshActivePanel();
		} else if (IS_PT((*aPanel)->pt,PT_NET)) { //net
			WaitBegin();
			if ( netPanel.nFiles > 0 ) {
				pnrs = netPanel.Items[netPanel.curr].netrs;
			}
			if ( LoadNetPanel(&netPanel,pnrs) ) {
				RefreshPanel((*aPanel),aWindow,0);
				aWindow->curSelRow = 0;
				SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
				(*aPanel)->curr = 0;
			} else {
				NetPanelGOTOFilePanel( pnrs );
			}
			WaitEnd();
		} else {
			if((*aPanel)->Items[(*aPanel)->curr].file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				ChangeDirectory((*aPanel)->Items[(*aPanel)->curr].file.cFileName);
			}
			else
			{
				if(!fHide) RestoreConsoleBackground();	
				if(!RunProcess((*aPanel)->Items[(*aPanel)->curr].file.cFileName,priority))
				{
					if(FindExt((*aPanel)->Items[(*aPanel)->curr].file.cFileName,s_tmp,g_fext_run,g_n_fext_run))
					{
						strcat(s_tmp," ");
						strcat(s_tmp,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
						RunProcess(s_tmp,priority);
					}
//when i not found any ext
					else
					{
						//find if filetype is registered
						if((DWORD)(ShellExecute(GetActiveWindow(),"open",(*aPanel)->Items[(*aPanel)->curr].file.cFileName,NULL,NULL,SW_SHOWNORMAL))<32){
							sprintf(s_tmp,"cmd /C \"%s\"",(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
							RunProcess(s_tmp,priority);
						}
					}
				}
				if(!fHide) RestoreKC();
			}
		}
	}
}
/////////////////////////////
//EditView Action 
//
// bView - edit = FALSE, view = TRUE
/////////////////////////////
void EditViewAction( INPUT_RECORD& inputBuffer , BOOL bView , BOOL bNewConsole)
{
	char tmp[STR_SIZE];
	BOOL	b_last_run;
	t_ext	*fext;
	int		next;

	if(bView)
	{
		fext = g_fext_view;
		next = g_n_fext_view;
	}
	else
	{
		fext = g_fext_edit;
		next = g_n_fext_edit;
	}
	//directory
	if((*aPanel)->Items[(*aPanel)->curr].file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY
		&& !(inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))
	{
		ChangeDirectory((*aPanel)->Items[(*aPanel)->curr].file.cFileName);
	}
	//file
	else
	{
		//new name SHIFT + F4
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))
		{
			DialogEditFile((*aPanel)->Items[(*aPanel)->curr].file.cFileName);
			RefreshActivePanel();
		}
		//standard EDIT
		else
		{
			if(IS_PT((*aPanel)->pt,PT_FIND))
			{
				FindPanelGOTOFilePanel();
			}
			if(FindExt((*aPanel)->Items[(*aPanel)->curr].file.cFileName,tmp,fext,next))
			{
				strcat(tmp," ");
				strcat(tmp,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
				if(!fHide) RestoreConsoleBackground();	
				b_last_run = RunProcess(tmp,g_KcPriority);
				if(!fHide) RestoreKC();
			//if you not find F4 program => edit
				if(!b_last_run)
				{
					if(!bNewConsole)
					{
						KcEdit((*aPanel)->Items[(*aPanel)->curr].file.cFileName);
						RefreshActivePanel();
						CommandLineServis(&CommandLine,0,0,0);
					}
					else
					{
						sprintf(tmp,"%s\\kc.exe e \"%s\"",g_start_path,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
						RunProcess(tmp,g_KcPriority|CREATE_NEW_CONSOLE);
						RestoreConsoleBackground();
						RestoreKC();
					}
				}
			}
			else
			{
				if(!bNewConsole)
				{
					//run editor on new console
					KcEdit((*aPanel)->Items[(*aPanel)->curr].file.cFileName,bView);
					RefreshActivePanel();
					CommandLineServis(&CommandLine,0,0,0);
				}
				else
				{
					//run editor on new console
					sprintf(tmp,"%s\\kc.exe e \"%s\"",g_start_path,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
					RunProcess(tmp,g_KcPriority|CREATE_NEW_CONSOLE);
					RestoreConsoleBackground();
					RestoreKC();
				}
			}
		}
	}
}

/////////////////////////////
//HISTORY ACTIONS
/////////////////////////////
void InitHistory(void)
{
	g_n_history = 0;
	g_curr_history = 0;
	for(long i = 0; i < g_max_history; i++) History[i] = NULL;
}

void DeleteHistory(void)
{
	for(long i = 0; i < g_max_history; i++) 
	{
		if(History[i])
		{
			delete History[i];
			History[i] = NULL;
		}
	}
	g_n_history = 0;
	g_curr_history = 0;
}

void AddHistory(char *command)
{
	if(g_n_history == 0 || strcmp(command,History[g_n_history - 1]))
	{
		if(g_n_history >= g_max_history) DeleteHistory();
		History[g_n_history] = new char[strlen(command) + 1];
		kASSERT(History[g_n_history]!=NULL);
		strcpy(History[g_n_history],command);
		g_n_history++;
	}
	g_curr_history = g_n_history;
}

void HistoryUp(void)
{
	if(g_curr_history > 0) 
	{
		g_curr_history--;
		strcpy(CommandLine.buffer,History[g_curr_history]);	
		CommandLine.x = CommandLine.startx + strlen(CommandLine.buffer);
		CommandLine.bufpos = strlen(CommandLine.buffer);
		CommandLineServis(&CommandLine,0,0,0);
	}
}

void HistoryDown(void)
{
	if(g_curr_history < g_n_history - 1) 
	{
		g_curr_history++;
		strcpy(CommandLine.buffer,History[g_curr_history]);	
		CommandLine.x = CommandLine.startx + strlen(CommandLine.buffer);
		CommandLine.bufpos = strlen(CommandLine.buffer);
		CommandLineServis(&CommandLine,0,0,0);
	}
	else
	{
		g_curr_history = g_n_history;
		strcpy(CommandLine.buffer,"");	
		CommandLine.x = 3;	
		CommandLine.bufpos = 0;	
		CommandLineServis(&CommandLine,0,0,0);
	}
}

//-------------------------------------------
// MultiSearchEdit
//on selected files search 
//
//-------------------------------------------
void MultiSearchEdit(BOOL bReadOnly)
{
	char	stmp[STR_SIZE];

	for(int ii = 0 ; ii < (*aPanel)->nFiles; ii++ )
	{
		if((*aPanel)->Items[ii].selected)
		{
			if(!IsDir(&(*aPanel)->Items[ii]))
			{
				if(IS_PT((*aPanel)->pt,PT_FIND))
					sprintf(stmp,"%s\\%s",(*aPanel)->Items[(*aPanel)->curr].path,(*aPanel)->Items[ii].file.cFileName);
				else strcpy(stmp,(*aPanel)->Items[ii].file.cFileName);
				if(KcEdit(stmp,bReadOnly,FALSE,TRUE) != 7) break;
			}
		}
	}
	
}

//-------------------------------------------
// INI file work
//-------------------------------------------

void WriteIniColor(char *key,WORD value,char *fname)
{
	char	s_tmp[STR_SIZE];

	sprintf(s_tmp,"%ld",value);
	WritePrivateProfileString("User_colors",key,s_tmp,fname);
}

void WriteIniHLAttr(char *key,DWORD value,char *fname)
{
	char	s_tmp[STR_SIZE];

	sprintf(s_tmp,"%ld",value);
	WritePrivateProfileString("HighLight",key,s_tmp,fname);
}

void SaveIniFile(char *fname)
{
	long	i;
	char	s_tmp[STR_SIZE];

	sprintf(s_tmp,"%ld",g_KulakSleep);
	WritePrivateProfileString("Kc","sleep_between_IO",s_tmp,fname);
	sprintf(s_tmp,"%ld",colorConfig);
	WritePrivateProfileString("Kc","color_config",s_tmp,fname);
	sprintf(s_tmp,"%ld",g_max_file_size);
	WritePrivateProfileString("Kc","max_edit_size",s_tmp,fname);
	sprintf(s_tmp,"%ld",g_max_find_files);
	WritePrivateProfileString("Kc","max_find_files",s_tmp,fname);
	sprintf(s_tmp,"%ld",g_max_history);
	WritePrivateProfileString("Kc","max_history",s_tmp,fname);
	WritePrivateProfileString("Kc","edit_word_stop_chars",sWordStopChars,fname);
	WritePrivateProfileString("Kc","frame_chars",(char*)g_FrameChar,fname);
	WritePrivateProfileString("Kc","smtp_server",(char*)g_SMTPServer,fname);
	WritePrivateProfileString("Kc","my_email_address",(char*)g_MyEmailAddress,fname);

	for( i = 0; i < g_n_fext_run; i++)
	{
		WritePrivateProfileString("Run",g_fext_run[i].ext,g_fext_run[i].program,fname);
	}
	for( i = 0; i < g_n_fext_edit; i++)
	{
		WritePrivateProfileString("Edit",g_fext_edit[i].ext,g_fext_edit[i].program,fname);
	}
	for( i = 0; i < g_n_fext_view; i++)
	{
		WritePrivateProfileString("View",g_fext_view[i].ext,g_fext_view[i].program,fname);
	}

	WriteIniColor("cb_panel",cbPanel,fname);
	WriteIniColor("ct_panel",ctPanel,fname);
	WriteIniColor("cb_find_panel",cbFindPanel,fname);
	WriteIniColor("ct_find_panel",ctFindPanel,fname);
	WriteIniColor("cb_info_panel",cbInfoPanel,fname);
	WriteIniColor("ct_info_panel",ctInfoPanel,fname);
	WriteIniColor("cb_info_panel_cell",cbInfoPanelCell,fname);
	WriteIniColor("ct_info_panel_cell",ctInfoPanelCell,fname);
	WriteIniColor("cb_panel_cursor",cbPanelCursor,fname);
	WriteIniColor("ct_panel_cursor",ctPanelCursor,fname);
	WriteIniColor("ct_select_item",ctSelectItem,fname);
	WriteIniColor("ct_select_item_find",ctSelectItemFind,fname);
	WriteIniColor("cb_input",cbInput,fname);
	WriteIniColor("ct_input",ctInput,fname);
	WriteIniColor("cb_bar_background",cbBarBackground,fname);
	WriteIniColor("ct_bar_background",ctBarBackground,fname);
	WriteIniColor("cb_bar_foreground",cbBarForeground,fname);
	WriteIniColor("ct_bar_foreground",ctBarForeground,fname);
	WriteIniColor("cb_dialog",cbDialog,fname);
	WriteIniColor("ct_dialog",ctDialog,fname);
	WriteIniColor("cb_error",cbError,fname);
	WriteIniColor("ct_error",ctError,fname);
	WriteIniColor("cb_error_word",cbErrorAttr,fname);
	WriteIniColor("ct_error_word",ctErrorAttr,fname);
	WriteIniColor("cb_selected_block",cbSelectedBlock,fname);
	WriteIniColor("ct_selected_block",ctSelectedBlock,fname);
	WriteIniColor("cb_small_drive",cbSmallDrive,fname);
	WriteIniColor("ct_small_drive",ctSmallDrive,fname);

	WritePrivateProfileString("HighLight","hl1",g_ExtHighlight[0].ext,fname);
	WritePrivateProfileString("HighLight","hl2",g_ExtHighlight[1].ext,fname);
	WritePrivateProfileString("HighLight","hl3",g_ExtHighlight[2].ext,fname);
	WritePrivateProfileString("HighLight","hl4",g_ExtHighlight[3].ext,fname);
	WritePrivateProfileString("HighLight","hl5",g_ExtHighlight[4].ext,fname);
	WritePrivateProfileString("HighLight","hl6",g_ExtHighlight[5].ext,fname);
	WritePrivateProfileString("HighLight","hl7",g_ExtHighlight[6].ext,fname);
	WritePrivateProfileString("HighLight","hl8",g_ExtHighlight[7].ext,fname);
	WriteIniHLAttr("hl_attr1",g_ExtHighlight[0].attr,fname);
	WriteIniHLAttr("hl_attr2",g_ExtHighlight[1].attr,fname);
	WriteIniHLAttr("hl_attr3",g_ExtHighlight[2].attr,fname);
	WriteIniHLAttr("hl_attr4",g_ExtHighlight[3].attr,fname);
	WriteIniHLAttr("hl_attr5",g_ExtHighlight[4].attr,fname);
	WriteIniHLAttr("hl_attr6",g_ExtHighlight[5].attr,fname);
	WriteIniHLAttr("hl_attr7",g_ExtHighlight[6].attr,fname);
	WriteIniHLAttr("hl_attr8",g_ExtHighlight[7].attr,fname);
	
	WritePrivateProfileString("Macros","ctrl0",g_FastMacro[0],fname);
	WritePrivateProfileString("Macros","ctrl1",g_FastMacro[1],fname);
	WritePrivateProfileString("Macros","ctrl2",g_FastMacro[2],fname);
	WritePrivateProfileString("Macros","ctrl3",g_FastMacro[3],fname);
	WritePrivateProfileString("Macros","ctrl4",g_FastMacro[4],fname);
	WritePrivateProfileString("Macros","ctrl5",g_FastMacro[5],fname);
	WritePrivateProfileString("Macros","ctrl6",g_FastMacro[6],fname);
	WritePrivateProfileString("Macros","ctrl7",g_FastMacro[7],fname);
	WritePrivateProfileString("Macros","ctrl8",g_FastMacro[8],fname);
	WritePrivateProfileString("Macros","ctrl9",g_FastMacro[9],fname);

	WritePrivateProfileString("Folder shortcut","folder0",g_PushDir[0],fname);
	WritePrivateProfileString("Folder shortcut","folder1",g_PushDir[1],fname);
	WritePrivateProfileString("Folder shortcut","folder2",g_PushDir[2],fname);
	WritePrivateProfileString("Folder shortcut","folder3",g_PushDir[3],fname);
	WritePrivateProfileString("Folder shortcut","folder4",g_PushDir[4],fname);
	WritePrivateProfileString("Folder shortcut","folder5",g_PushDir[5],fname);
	WritePrivateProfileString("Folder shortcut","folder6",g_PushDir[6],fname);
	WritePrivateProfileString("Folder shortcut","folder7",g_PushDir[7],fname);
	WritePrivateProfileString("Folder shortcut","folder8",g_PushDir[8],fname);
	WritePrivateProfileString("Folder shortcut","folder9",g_PushDir[9],fname);

}


void LoadIniColor(char *key,WORD& value,char *fname)
{
	char	s_tmp[STR_SIZE],s_tmp1[STR_SIZE];

	sprintf(s_tmp1,"%ld",value);
	GetPrivateProfileString("User_colors",key,s_tmp1,s_tmp,STR_SIZE,fname);
	value = (WORD)atoi(s_tmp);
}

void LoadIniHLAttr(char *key,DWORD& value,char *fname)
{
	char	s_tmp[STR_SIZE],s_tmp1[STR_SIZE];

	sprintf(s_tmp1,"%ld",value);
	GetPrivateProfileString("HighLight",key,s_tmp1,s_tmp,STR_SIZE,fname);
	value = (DWORD)atol(s_tmp);
}

void LoadAllIniColors(char *fname)
{
	LoadIniColor("cb_panel",cbPanel,fname);
	LoadIniColor("ct_panel",ctPanel,fname);
	LoadIniColor("cb_find_panel",cbFindPanel,fname);
	LoadIniColor("ct_find_panel",ctFindPanel,fname);
	LoadIniColor("cb_info_panel",cbInfoPanel,fname);
	LoadIniColor("ct_info_panel",ctInfoPanel,fname);
	LoadIniColor("cb_info_panel_cell",cbInfoPanelCell,fname);
	LoadIniColor("ct_info_panel_cell",ctInfoPanelCell,fname);
	LoadIniColor("cb_panel_cursor",cbPanelCursor,fname);
	LoadIniColor("ct_panel_cursor",ctPanelCursor,fname);
	LoadIniColor("ct_select_item",ctSelectItem,fname);
	LoadIniColor("ct_select_item_find",ctSelectItemFind,fname);
	LoadIniColor("cb_input",cbInput,fname);
	LoadIniColor("ct_input",ctInput,fname);
	LoadIniColor("cb_bar_background",cbBarBackground,fname);
	LoadIniColor("ct_bar_background",ctBarBackground,fname);
	LoadIniColor("cb_bar_foreground",cbBarForeground,fname);
	LoadIniColor("ct_bar_foreground",ctBarForeground,fname);
	LoadIniColor("cb_dialog",cbDialog,fname);
	LoadIniColor("ct_dialog",ctDialog,fname);
	LoadIniColor("cb_error",cbError,fname);
	LoadIniColor("ct_error",ctError,fname);
	LoadIniColor("cb_error_word",cbErrorAttr,fname);
	LoadIniColor("ct_error_word",ctErrorAttr,fname);
	LoadIniColor("cb_selected_block",cbSelectedBlock,fname);
	LoadIniColor("ct_selected_block",ctSelectedBlock,fname);
	LoadIniColor("cb_small_drive",cbSmallDrive,fname);
	LoadIniColor("ct_small_drive",ctSmallDrive,fname);
	
	colorConfig = CONFIG_USER;

}

void LoadIniFile(char *fname)
{
	long	i;
	char	s_tmp[1001],s_tmp1[STR_SIZE];
	char	*p;

	GetPrivateProfileString("Kc","sleep_between_IO","0",s_tmp,1000,fname);
	g_KulakSleep = atol(s_tmp);
	GetPrivateProfileString("Kc","color_config","0",s_tmp,1000,fname);
	colorConfig = (WORD)atoi(s_tmp);
	GetPrivateProfileString("Kc","max_find_files","200",s_tmp,1000,fname);
	g_max_find_files = atol(s_tmp);
	GetPrivateProfileString("Kc","max_history","500",s_tmp,1000,fname);
	g_max_history = atol(s_tmp);
	GetPrivateProfileString("Kc","kc_debug","1",s_tmp,1000,fname);
	g_kc_debug = atol(s_tmp);
	strcat(sWordStopChars,"\t\r ");
	GetPrivateProfileString("Kc","frame_chars", (char*)g_FrameChar ,s_tmp,99,fname);
	strcpy( (char*)g_FrameChar, s_tmp );

	GetPrivateProfileString("Kc","smtp_server", (char*)g_SMTPServer ,s_tmp,99,fname);
	strcpy( (char*)g_SMTPServer, s_tmp );
	GetPrivateProfileString("Kc","my_email_address", (char*)g_MyEmailAddress ,s_tmp,99,fname);
	strcpy( (char*)g_MyEmailAddress, s_tmp );


//read run ext	
	GetPrivateProfileString("Run",NULL,NULL,s_tmp,1000,fname);
	p = s_tmp;
	i = 0;
	while(*p != 0)
	{
		GetPrivateProfileString("Run",p,NULL,s_tmp1,100,fname);
		strcpy(g_fext_run[i].ext,p);
		strcpy(g_fext_run[i].program,s_tmp1);
		p = strchr(p, 0) + 1;   // Point to next string.
		i++;
	}
	g_n_fext_run = i;
//read edit ext	
	GetPrivateProfileString("Edit",NULL,NULL,s_tmp,1000,fname);
	p = s_tmp;
	i = 0;
	while(*p != 0)
	{
		GetPrivateProfileString("Edit",p,NULL,s_tmp1,100,fname);
		strcpy(g_fext_edit[i].ext,p);
		strcpy(g_fext_edit[i].program,s_tmp1);
		p = strchr(p, 0) + 1;   // Point to next string.
		i++;
	}
	g_n_fext_edit = i;
//read view ext	
	GetPrivateProfileString("View",NULL,NULL,s_tmp,1000,fname);
	p = s_tmp;
	i = 0;
	while(*p != 0)
	{
		GetPrivateProfileString("View",p,NULL,s_tmp1,100,fname);
		strcpy(g_fext_view[i].ext,p);
		strcpy(g_fext_view[i].program,s_tmp1);
		p = strchr(p, 0) + 1;   // Point to next string.
		i++;
	}
	g_n_fext_view = i;
//load highlight
	GetPrivateProfileString("HighLight","hl1","*.exe;*.com;*.bat;*.cmd;",g_ExtHighlight[0].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl2","",g_ExtHighlight[1].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl3","*.rar;*.j;*.arj;*.zip;*.gz;*.tar;*.tgz;",g_ExtHighlight[2].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl4","*.txt;*.doc;*.wri;",g_ExtHighlight[3].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl5","",g_ExtHighlight[4].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl6","",g_ExtHighlight[5].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl7","",g_ExtHighlight[6].ext,STR_SIZE,fname);
	GetPrivateProfileString("HighLight","hl8","",g_ExtHighlight[7].ext,STR_SIZE,fname);
	LoadIniHLAttr("hl_attr1",g_ExtHighlight[0].attr,fname);
	g_ExtHighlight[1].attr = 16;
	LoadIniHLAttr("hl_attr2",g_ExtHighlight[1].attr,fname);
	LoadIniHLAttr("hl_attr3",g_ExtHighlight[2].attr,fname);
	LoadIniHLAttr("hl_attr4",g_ExtHighlight[3].attr,fname);
	LoadIniHLAttr("hl_attr5",g_ExtHighlight[4].attr,fname);
	LoadIniHLAttr("hl_attr6",g_ExtHighlight[5].attr,fname);
	LoadIniHLAttr("hl_attr7",g_ExtHighlight[6].attr,fname);
	LoadIniHLAttr("hl_attr8",g_ExtHighlight[7].attr,fname);

	GetPrivateProfileString("Macros","ctrl0","",g_FastMacro[0],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl1","",g_FastMacro[1],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl2","",g_FastMacro[2],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl3","",g_FastMacro[3],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl4","",g_FastMacro[4],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl5","",g_FastMacro[5],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl6","",g_FastMacro[6],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl7","",g_FastMacro[7],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl8","",g_FastMacro[8],STR_SIZE,fname);
	GetPrivateProfileString("Macros","ctrl9","",g_FastMacro[9],STR_SIZE,fname);

	GetPrivateProfileString("Folder shortcut","folder0","",g_PushDir[0],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder1","",g_PushDir[1],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder2","",g_PushDir[2],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder3","",g_PushDir[3],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder4","",g_PushDir[4],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder5","",g_PushDir[5],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder6","",g_PushDir[6],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder7","",g_PushDir[7],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder8","",g_PushDir[8],STR_SIZE,fname);
	GetPrivateProfileString("Folder shortcut","folder9","",g_PushDir[9],STR_SIZE,fname);

}

void ExitKC(void)
{
	RestoreConsoleBackground();
//	printf("%s",about);
	SetConsoleTitle(sOldTitle);
	exit(0);
}

/////////////////////////////
//TestLeftRightCtrl
//
//keyb input testing
/////////////////////////////
BOOL TestLeftRightCtrl(INPUT_RECORD& inputBuffer)
{
		if((inputBuffer.Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
		{
			switch(inputBuffer.Event.KeyEvent.wVirtualScanCode)
			{
//ctrl + [
				case 26 : {
							if( (strlen(CommandLine.buffer) + strlen(lDirectory) + 1) < CommandLine.size)
							{
								DWORD dest = CommandLine.bufpos + strlen(lDirectory) + 1;
								char stmp[STR_SIZE];
								
								strcpy(stmp,CommandLine.buffer);
								memset(CommandLine.buffer,0,CL_BUFF_SIZE);
								strcpy(CommandLine.buffer,stmp);

								strcpy(stmp,lDirectory);
								DeleteLastBackslash(stmp);
								memmove(&CommandLine.buffer[dest],&CommandLine.buffer[CommandLine.bufpos],strlen(CommandLine.buffer)-CommandLine.bufpos);
								memcpy(&CommandLine.buffer[CommandLine.bufpos],stmp,strlen(stmp));
								CommandLine.buffer[CommandLine.bufpos + strlen(stmp)] = '\\';
								CommandLine.x += strlen(stmp) + 1;	
								CommandLine.bufpos += strlen(stmp) + 1;	
								CommandLineServis(&CommandLine,0,0,0);
							}
							break;
						  }
//ctrl + ]
				case 27 : {
							if( (strlen(CommandLine.buffer) + strlen(rDirectory) + 1) < CommandLine.size)
							{
								DWORD dest = CommandLine.bufpos + strlen(rDirectory) + 1;
								char stmp[STR_SIZE];

								strcpy(stmp,CommandLine.buffer);
								memset(CommandLine.buffer,0,CL_BUFF_SIZE);
								strcpy(CommandLine.buffer,stmp);
								
								strcpy(stmp,rDirectory);
								DeleteLastBackslash(stmp);
								memmove(&CommandLine.buffer[dest],&CommandLine.buffer[CommandLine.bufpos],strlen(CommandLine.buffer)-CommandLine.bufpos);
								memcpy(&CommandLine.buffer[CommandLine.bufpos],stmp,strlen(stmp));
								CommandLine.buffer[CommandLine.bufpos + strlen(stmp)] = '\\';
								CommandLine.x += strlen(stmp) + 1;	
								CommandLine.bufpos += strlen(stmp) + 1;	
								CommandLineServis(&CommandLine,0,0,0);
							}
							break;
						  }
//CTRL + BACKSLASH
				case 43 : {
							if(fHide) break;
							if(bUtilActive) break;
							if(IS_PT((*aPanel)->pt,PT_FIND)) break;
							ChangeDirectory("\\");
							break;
						  }
			}
			
			switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
			{
//CTRL + ENTER
				case 13 : {
							//test SHIFT couse ctrl+shift used to run
							if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED)) return FALSE;

							if( (strlen(CommandLine.buffer) + strlen((*aPanel)->Items[(*aPanel)->curr].file.cFileName)) < CommandLine.size)
							{
								strcat(CommandLine.buffer,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
								strcat(CommandLine.buffer," ");
								
								CommandLineServis(&CommandLine,0,VK_END,0);
							}
							break;
						  }

//CTRL + PAGE_DOWN
				case 34 : {
							if(fHide) break;
							if(bUtilActive) break;
							if(IS_PT((*aPanel)->pt,PT_FIND)) break;
							if((*aPanel)->Items[(*aPanel)->curr].file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
							{
								ChangeDirectory((*aPanel)->Items[(*aPanel)->curr].file.cFileName);
							}
							break;
						  }
					
//CTRL + PAGE_UP
				case 33 : {
							if(fHide) break;
							if(bUtilActive) break;
							if(IS_PT((*aPanel)->pt,PT_FIND)) break;
							ChangeDirectory("..");
							break;
						  }
//CTRL + E	history -
				case 0x45 : {
							HistoryUp();
							break;
						  }
//CTRL + up
				case VK_UP : {
								if(fHide)  break;
								g_lp_sizey--;
								g_rp_sizey--;
								ChangePanelsSizes();
								break; 
							 }
//CTRL + down
				case VK_DOWN : {
								if(fHide)  break;
								g_lp_sizey++;
								g_rp_sizey++;
								ChangePanelsSizes();
								break;
							}
//CTRL + left
				case VK_LEFT : {
								if(fHide)  break;
								g_lp_sizex--;
								g_rp_sizex++;
								g_rp_posx--;
								ChangePanelsSizes();
								break;
							}
//CTRL + right
				case VK_RIGHT : {
								if(fHide)  break;
								g_lp_sizex++;
								g_rp_sizex--;
								g_rp_posx++;
								ChangePanelsSizes();
								break;
							}
//CTRL + N  goto directory Notes
				case 0x4e : {
							char note_dir[STR_SIZE];

							sprintf(note_dir,"%s\\Notes",g_start_path);
							if(!SetCurrentDirectory(note_dir)) CreateDirectory(note_dir,NULL);
							ChangeDirectory(note_dir);
							break;
						  }
//CTRL + Y  Mike Kulak Fast Notes
				case 0x59 : {
							char note_dir[STR_SIZE];

							sprintf(note_dir,"%s\\Notes",g_start_path);
							CreateDirectory(note_dir,NULL);
							sprintf(note_dir,"%s\\Notes\\KcNotes.not",g_start_path);
							KcEdit(note_dir,FALSE,TRUE);
							break;
						  }
//CTRL + T  tasks list
				case 0x54 : {
							DialogReminderListTasks();
							break;
						  }
//CTRL + A  add reminder task
				case 0x41 : {
							DialogReminderAddTask();
							if (IS_PT((*aPanel)->pt,PT_TASK)) RefreshActivePanel();
							break;
						  }
//CTRL + P  add reminder task
				case 0x50 : {
							DialogPriority();
							break;
						  }
//CTRL + O				
				case 79 : {
							fHide ^= 1;
							if(fHide) RestoreConsoleBackground();
							else RestoreKC();
							return TRUE;
							break;
						  }
//CTRL + I		hide info panel
				case 0x49 : {
							if(fHide) break;
							g_bInfoHide ^= 1;
							if(g_bInfoHide) 
							{
								wi.Hide();
								if(g_lp_sizey>=19 && g_rp_sizey>=19)
								{
									g_lp_sizey = 23;
									g_rp_sizey = 23;
									ChangePanelsSizes();
								}
							}
							else 
							{
								g_bInfoHideForce = FALSE;
								if(g_lp_sizey > 19 || g_rp_sizey > 19)
								{
									g_lp_sizey = 19;
									g_rp_sizey = 19;
									ChangePanelsSizes();
								}
								DrawInfoPanel();
							}
							return TRUE;
							break;
						  }
//CTRL + K				
				case 0x4B : {
							ColorConfig();
							RestoreConsoleBackground();
							RestoreKC();
							return TRUE;
							break;
						  }
//CTRL + W	- open editor in new screen
				case 0x57: {
							EditViewAction(inputBuffer,FALSE,TRUE);
							break;
						  }
//CTRL + Q	- quit
				case 0x51: {
							if(YesNoCancelMessage(hStdOut,"The Kulak Commander","Do you want to quit Kulak Comander?") == 'Y')
							{
								ExitKC();
							}
							break;
						  }
//CTRL + Z	- minimize window
				case 0x5a: {
							if(g_KC_hwnd) 
							{
								ShowWindow(g_KC_hwnd,SW_MINIMIZE);
							}
							break;
						  }
//CTRL + R	- refresh panel
				case 0x52: {
							if(fHide) break;
							if(bUtilActive) break;
							if(IS_PT((*aPanel)->pt,PT_FIND)) break;
							RefreshActivePanel();
							break;
						  }
//CTRL + M	- color config
				case 0x4D: {
							char s_tmp[STR_SIZE];

							if(fHide) break;
							RestoreConsoleBackground();
							switch(colorConfig)
							{
								case CONFIG_COLOR:
								{
									SetMonoKC();
									strcpy(s_tmp,"Kulak Commander MONO configuration");
									break;
								}
								case  CONFIG_MONO:
								{
									LoadAllIniColors(g_ini_file);
									strcpy(s_tmp,"USER COLOR configuration");
									break;
								}
								case CONFIG_USER:
								{
									strcpy(s_tmp,"Kulak Commander COLOR configuration");
									SetColorKC();
									break;
								}
							}
							RestoreKC();
							InfoWaitMessage(GetStdHandle(STD_OUTPUT_HANDLE),"colors",s_tmp,1500);
							break;
						  }
//CTRL + V 	put clipboard to command line 
				case 0x56: {
								char	*buff;
								long	size;
								size = GetBlockFromClipboard(buff);
								if(size < (long)CommandLine.size)
								{
									strcpy(CommandLine.buffer,buff);
									CommandLineServis(&CommandLine,0,VK_END,0);
								}
								else InfoMessage(hStdOut,"Error","Text in clipboard too large !");
								HeapFree(GetProcessHeap(),0,buff);
								break;
						   }
//CTRL + C 	put command line to clipboard
				case VK_INSERT:
				case 0x43: {
							KcLog(__FILE__,"TestLeftRightCtrl",0);
							PutBlockToClipboard(CommandLine.buffer,strlen(CommandLine.buffer));
							break;
						  }
//CTRL + D - panel display type
				case 0x44: {
								switch((*aPanel)->showMethod)
								{
									case PANEL_SHOW_TYPE_NAME : (*aPanel)->showMethod = PANEL_SHOW_TYPE_SIZE; break;
									case PANEL_SHOW_TYPE_SIZE : (*aPanel)->showMethod = PANEL_SHOW_TYPE_SIZE_KB; break;
									case PANEL_SHOW_TYPE_SIZE_KB : (*aPanel)->showMethod = PANEL_SHOW_TYPE_DATE; break;
									case PANEL_SHOW_TYPE_DATE : (*aPanel)->showMethod = PANEL_SHOW_TYPE_DATETIME; break;
									case PANEL_SHOW_TYPE_DATETIME : (*aPanel)->showMethod = PANEL_SHOW_TYPE_ATTR; break;
									case PANEL_SHOW_TYPE_ATTR : (*aPanel)->showMethod = PANEL_SHOW_TYPE_NAME; break;
								}
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
							break;
						  }
//CTRL + H files highlighting
				case 0x48: {
							if (DialogHighLight() == 13)
							{
								ReSortPanel(pLeftPanel,&wl,pLeftPanel->curr);
								ReSortPanel(pRightPanel,&wr,pRightPanel->curr);
							}
							break;
						  }
//CTRL + J on/off highlighting
				case 0x4A: {
							g_bHighlight_on ^= 1;
							ReSortPanel(pLeftPanel,&wl,pLeftPanel->curr);
							ReSortPanel(pRightPanel,&wr,pRightPanel->curr);
							break;
						  }
//CTRL + F push directory
				case 0x46: {
							//strcpy(g_PushDir,aDirectory);
							break;
						  }

//CTRL + G pop directory
				case 0x47: {
							if(fHide) break;
							if(bUtilActive) break;
							if(IS_PT((*aPanel)->pt,PT_FIND)) break;
							//ChangeDirectory(g_PushDir);
							break;
						  }
//CTRL + L push directory
				case 0x4C: {
							DialogMP3List();
							RefreshActivePanel();
							break;
						  }
//0 - 9
//
				case 0x30:
				case 0x31:
				case 0x32:
				case 0x33:
				case 0x34:
				case 0x35:
				case 0x36:
				case 0x37:
				case 0x38:
				case 0x39: {

					
//!!!!!!!!!!!!!!!!  FAST MACROS !!!!!!!!!!!!!!!
				if(fHide) break;
				if(bUtilActive) break;
				if(IS_PT((*aPanel)->pt,PT_FIND)) break;
			
				char	cl[1000];
				int		mac_num = inputBuffer.Event.KeyEvent.wVirtualKeyCode - 0x30;
				DWORD	priority = 0;
				KWindow w(hStdOut);
				TInput	input(hStdOut);

				if((inputBuffer.Event.KeyEvent.dwControlKeyState & RIGHT_CTRL_PRESSED)){
					if(strcmp(g_FastMacro[mac_num],""))
					{
						if (CreateCommandLine((TPanel*)(*aPanel),g_FastMacro[mac_num],cl,1000) < 1000)
						{
							w.Init("run macro",10,10,60,3,ctDialog,cbDialog);
							w.SaveBG();
							w.Show(hStdOut);
							if(input.Input(cl,12,11,56,ctInput,cbInput) == 13)
							{
								w.RestoreBG();
								RestoreConsoleBackground();
								if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))  priority |= CREATE_NEW_CONSOLE;
								RunProcess(input.GetText(),priority);
								RestoreKC();
								RefreshActivePanel();
							}
							else w.RestoreBG();
						}
						else
						{
							InfoMessage(hStdOut,"Error","Macro is too large !");
						}
					}					
				}
				else{				
				//folder short cuts
					int	num=inputBuffer.Event.KeyEvent.wVirtualKeyCode - 0x30;
					if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED)){
						//save directory
						strcpy(g_PushDir[num],aDirectory);
						InfoWaitMessage(GetStdHandle(STD_OUTPUT_HANDLE),"Directory shortcut","Saveing....",500);
					}
					else{
						ChangeDirectory(g_PushDir[num]);
					}
				}
					

							break;
						  }
//!!!!!!!!!!!!!!!!  SORT !!!!!!!!!!!!!!!!!!!!!!
//CTRL + VK_F1				
				case VK_F1: {
								if(!(*aPanel)->ctrl_f1) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_BY_NAME;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F2				
				case VK_F2: {
								if(!(*aPanel)->ctrl_f2) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_BY_NAME_DIR;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F3				
				case VK_F3: {
								if(!(*aPanel)->ctrl_f3) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_BY_EXT;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F4				
				case VK_F4: {
								if(!(*aPanel)->ctrl_f4) break;
								if(fHide) break;
								if(bUtilActive) break;
								KWindow w(hStdOut);
								TInput i(hStdOut);
								w.Init(" Mask ",30,10,20,3,ctDialog,cbDialog);
								w.SaveBG();
								w.Show(hStdOut);
								if(i.Input(g_ext_first,31,11,18,ctInput,cbInput) == 13)
								{
									w.RestoreBG();
									strcpy(g_ext_first,i.GetText());
									(*aPanel)->sortMethod = SORT_BY_EXT_SPECIAL;
									ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								}
								else w.RestoreBG();
								break;
						  }
//CTRL + VK_F5				
				case VK_F5: {
								if(!(*aPanel)->ctrl_f5) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_BY_TIME;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F6				
				case VK_F6: {
								if(!(*aPanel)->ctrl_f6) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_BY_SIZE;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F7
				case VK_F7: {
								if(!(*aPanel)->ctrl_f7) break;
								if(fHide) break;
								if(bUtilActive) break;
								(*aPanel)->sortMethod = SORT_UNSORTED;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
						  }
//CTRL + VK_F10
				case VK_F10:{
								if(!(*aPanel)->ctrl_f10) break;
								if(fHide) break;
								SaveIniFile(g_ini_file);
								InfoWaitMessage(GetStdHandle(STD_OUTPUT_HANDLE),"","Saving configuration KC.INI",1500);
								break;
						  }
//COMMAND LINE CTRL + KEY
//-------------------
				default:  {
							CommandLineServis(&CommandLine,
								inputBuffer.Event.KeyEvent.uChar.AsciiChar,
								inputBuffer.Event.KeyEvent.wVirtualKeyCode,
								inputBuffer.Event.KeyEvent.dwControlKeyState);
	//don't refresh info panel when CL
							return TRUE;
						  }
			}//switch
	//refresh panel after (spec. key) +  key
			if(!fHide) DrawInfoPanel();
			return TRUE;
		}
return FALSE;
}
/////////////////////////////
//TestRightAlt
//
//keyb input testing
/////////////////////////////
BOOL TestRightAlt(INPUT_RECORD& inputBuffer)
{
	if(fHide) return FALSE;
	if(bUtilActive) return FALSE;
	if((inputBuffer.Event.KeyEvent.dwControlKeyState & RIGHT_ALT_PRESSED)) 
	{
		if(isalpha(inputBuffer.Event.KeyEvent.uChar.AsciiChar))
		{				
			ChangeDrive((char)inputBuffer.Event.KeyEvent.wVirtualKeyCode,(*aPanel),aWindow);
			if(!strnicmp(lDirectory,rDirectory,2))
			{
				if(ActivePanel == LEFT) strcpy(lDirectory,rDirectory);
				else strcpy(rDirectory,lDirectory);
				ChangeDirectory(aDirectory);
			}
			DrawInfoPanel();
		}
//refresh panel after (spec. key) +  key
		DrawInfoPanel();
		FlushConsoleInputBuffer(hStdIn);
		return TRUE;
	}

return FALSE;
}
/////////////////////////////
//TestLeftAlt
//
//keyb input testing
/////////////////////////////
//off optimization cause I need some 
//empty loops
#pragma optimize("",off)
BOOL TestLeftAlt(INPUT_RECORD& inputBuffer)
{
		INPUT_RECORD	key_buffer[20];
		DWORD			readKeys;

		if(fHide) return FALSE;

		if((inputBuffer.Event.KeyEvent.dwControlKeyState & LEFT_ALT_PRESSED)
			|| (inputBuffer.Event.KeyEvent.dwControlKeyState & RIGHT_ALT_PRESSED)) 
		{
			if(!bIsInAltSearch)
			{
				if(isprint(inputBuffer.Event.KeyEvent.uChar.AsciiChar))
				{
					bIsInAltSearch = TRUE;
					KWindow w(hStdOut);
					TInput i(hStdOut);

					w.Init("Search",20,21,40,3,ctDialog,cbDialog);
					w.SaveBG();
					w.Show(hStdOut);
					//read all keyboard events !BIG TRICK !
					ReadConsoleInput(hStdIn, key_buffer, 20, &readKeys);
					//write key pressed with ALT key
					WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
					//write original keys to buffer !BIG TRICK !
					WriteConsoleInput(hStdIn, key_buffer, readKeys, &readKeys);
					i.InputFindInPanel("",21,22,38,ctInput,cbInput);
					w.RestoreBG();
					bIsInAltSearch = FALSE;
				}
			}

			if(bUtilActive) return FALSE;

			switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
			{
//Alt + F1
				case 112 : {
							if(!(*aPanel)->alt_f1) break;
								char drive = DialogDrives("LEFT");
								if(drive)
								{
									if(ActivePanel != LEFT)
									{
										SetActivePanel(ActivePanel);
										ChangeDrive((char)drive,(*aPanel),aWindow);
										if(!strnicmp(lDirectory,rDirectory,2))
										{
											strcpy(lDirectory,rDirectory);
											ChangeDirectory(aDirectory);
										}
										SetActivePanel(ActivePanel);
									}
									else ChangeDrive((char)drive,(*aPanel),aWindow);
								}
								break;
							}
//Alt + F2
				case 113 : {
							if(!(*aPanel)->alt_f2) break;
								char drive = DialogDrives("RIGHT");
								if(drive)
								{
									if(ActivePanel != RIGHT)
									{
										SetActivePanel(ActivePanel);
										ChangeDrive((char)drive,(*aPanel),aWindow);
										if(!strnicmp(lDirectory,rDirectory,2))
										{
											strcpy(rDirectory,lDirectory);
											ChangeDirectory(aDirectory);
										}
										SetActivePanel(ActivePanel);
									}
									else ChangeDrive((char)drive,(*aPanel),aWindow);
								}
								break;
							}
//Alt + F3
				case VK_F3 : {
							if(!(*aPanel)->alt_f3) break;
								MultiSearchEdit(TRUE);
								break;
							 }
//Alt + F4
				case VK_F4 :	{
								if(!(*aPanel)->alt_f12) break;
								break;
							}
//Alt + F5   process manager
				case 116 :	{
							if(!(*aPanel)->alt_f5) break;
/*
#ifndef _MINGW32_
								WaitBegin();
								bar = barUtil;
								bUtilActive = TRUE;
								bTaskMgrActive = TRUE;
								SetActivePanel(RIGHT);
								LoadTaskList();
								TasksFillPanel(pLeftPanel);
								cbSelectItemX = cbDialog;
								wl.SetLabel("TASK MANAGER");
								RefreshPanel(pLeftPanel,&wl,0);
								aWindow->curSelRow = 0;
								(*aPanel)->curr = 0;
								aWindow->RowAttribute(aWindow->curSelRow,ctPanelCursor,cbPanelCursor);
								WaitEnd();
#else

#endif
  */
								bar = barTask;
								(*aPanel) = &taskPanel;
								aWindow->SetLabel("Reminder tasks");
								LoadTaskPanel( &taskPanel );
								(*aPanel)->sortMethod = SORT_BY_SIZE;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
							}
//Alt + F6
				case 117 :	{
								if(!(*aPanel)->alt_f6) break;
								WaitBegin((LPTHREAD_START_ROUTINE)WaitWorkingSize);
								ActionSize();
								WaitEnd();
								RefreshPanel((*aPanel),aWindow,(*aPanel)->curr - aWindow->curSelRow);
								SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
								break;
							}
//Alt + F7
				case 118 :	{
								if(!(*aPanel)->alt_f7) break;
								if(DialogFindFile() == 13)
								{
									(*aPanel)=&findPanel;
									SET_PT( (*aPanel)->pt, PT_FIND );
									cbSelectItemX = cbFindPanel;
									SortPanel((*aPanel)->Items,(*aPanel)->nFiles);
									RefreshPanel((*aPanel),aWindow,0);
									aWindow->curSelRow = 0;
									SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
									(*aPanel)->curr = 0;
								}
								break;
							}
//Alt + F8
				case 119 :	{
								if(!(*aPanel)->alt_f8) break;
								if(findPanel.Items == NULL) break;
								(*aPanel) = &findPanel;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
							}

//Alt + F9
				case VK_F9 :	{
								if(!(*aPanel)->alt_f9) break;
								DialogFastMacros();
								break;
							}
//Alt + F10 Network
				case VK_F10 :	{
								if(!(*aPanel)->alt_f10) break;
#ifndef _MINGW32_
								WaitBegin();
								bar = barUtil;
								bUtilActive = TRUE;
								LoadNetPanel(&netPanel,NULL);
								(*aPanel)=&netPanel;
								SET_PT((*aPanel)->pt, PT_NET);
								cbSelectItemX = cbFindPanel;
								SortPanel((*aPanel)->Items,(*aPanel)->nFiles);
								RefreshPanel((*aPanel),aWindow,0);
								aWindow->curSelRow = 0;
								SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
								(*aPanel)->curr = 0;
								WaitEnd();
								}
#else

#endif
								break;
//Alt + F12
				case VK_F12 :	{
								if(!(*aPanel)->alt_f12) break;
								bar = barTask;
								(*aPanel) = &taskPanel;
								LoadTaskPanel( &taskPanel );
								(*aPanel)->sortMethod = SORT_BY_SIZE;
								ReSortPanel((*aPanel),aWindow,(*aPanel)->curr);
								break;
							}
//Alt + left
				case VK_LEFT : {
								ChangeDriveShift(aDirectory[0],TRUE);
								break;
							}
//Alt + right
				case VK_RIGHT : {
								ChangeDriveShift(aDirectory[0],FALSE);
								break;
							}
//Alt + up
				case VK_UP : {
							HistoryUp();
							break;
						  }
//Alt + down
				case VK_DOWN : {
							HistoryDown();
							break;
						  }
			}//switch
	
	//refresh panel after (spec. key) +  key
			DrawInfoPanel();
			return TRUE;
		}
return FALSE;
}
#pragma optimize("",on)
/////////////////////////////
//TestKeys
//
//keyb input testing
/////////////////////////////
BOOL TestKeys(INPUT_RECORD& inputBuffer)
{
	long l_tmp;

		switch(inputBuffer.Event.KeyEvent.wVirtualKeyCode)
		{

//ESC
			case VK_ESCAPE :{
							if(strlen(CommandLine.buffer) > 0)
							{
								//reset command line
								CommandLine.x = 3;	
								CommandLine.bufpos = 0;	
								strcpy(CommandLine.buffer,"");	
								CommandLineServis(&CommandLine,0,0,0);
								break;
							}
							if(( IS_PT((*aPanel)->pt,PT_TASK) || IS_PT((*aPanel)->pt,PT_FIND) || IS_PT((*aPanel)->pt,PT_NET) )&& !fHide)	
							{
								bar = barDefault;
								bUtilActive = FALSE;
								if(ActivePanel == LEFT) (*aPanel) = &filePanel1; else (*aPanel) = &filePanel2;
								cbSelectItemX = cbPanel;
								MySetCurrentDirectory(aDirectory);
								FillPanel((*aPanel),aWindow,0);
							}
							else 
							{
								//task manager
								if(bTaskMgrActive && ActivePanel == LEFT)
								{
									bar = barDefault;
									bUtilActive = FALSE;
									bTaskMgrActive = FALSE;
									RefreshActivePanel();
									DrawBar(bar);
								}
								else
								{
									fHide ^= 1;
									if(fHide) RestoreConsoleBackground();
									else RestoreKC();
								}
							}
							break;
						 }	
//F1 - help
			case VK_F1:{
							if(!(*aPanel)->f1) break;
							KcEdit(g_kc_help,TRUE);
							break;
					   }
//F2 - Link
			case VK_F2 :{
						if(bUtilActive) break;
						if(fHide) break;
						if(!(*aPanel)->f2) break;
						
						if(IS_PT((*aPanel)->pt,PT_TASK)) {
							DialogReminderAddTask();
							RefreshActivePanel();
						} else {
							char srcname[STR_SIZE];
							strcpy(srcname,(*aPanel)->Items[(*aPanel)->curr].file.cFileName);
							if(DialogCreateNTFSHardLink() == 13)
							{
								l_tmp = (*aPanel)->curr;
								SetActivePanel(ActivePanel);
								FillPanel((*aPanel),aWindow,0);
								SetActivePanel(ActivePanel);
								if(!IS_PT((*aPanel)->pt,PT_FIND))
								{
									FillPanel((*aPanel),aWindow,0);
									GotoItem(l_tmp);
								}
							}
						}
						break;
					  }
//F3 - view
			case VK_F3:{
						if(fHide) break;
						if(bUtilActive) break;
						if(!(*aPanel)->f3) break;
						EditViewAction(inputBuffer,TRUE,FALSE);
						break;
					   }
//F4 - edit
			case VK_F4:{
						if(fHide) break;
						if(bUtilActive) break;
						if(!(*aPanel)->f4) break;
						if(IS_PT((*aPanel)->pt,PT_TASK)) {
							if(DialogReminderTaskNotifyEdit(taskPanel.Items[taskPanel.curr].dircompsize,TRUE) == 13 )
								RefreshActivePanel();
						} else {
							EditViewAction(inputBuffer,FALSE,FALSE);
						}
						break;
					  }
//F5 - copy			
			case VK_F5:{
						if(fHide) break;
						if(bUtilActive) break;
						if(!(*aPanel)->f5) break;
						if(DialogCopyFiles( inputBuffer ) == 13)
						{
							l_tmp = (*aPanel)->curr;
							SetActivePanel(ActivePanel);
							FillPanel((*aPanel),aWindow,0);
							SetActivePanel(ActivePanel);
							if(!IS_PT((*aPanel)->pt,PT_FIND))
							{
								FillPanel((*aPanel),aWindow,0);
								GotoItem(l_tmp);
							}
						}
						break;
					  }
//F6 - move
			case VK_F6 :{
						if(fHide) break;
						if(bUtilActive) break;
						if(!(*aPanel)->f6) break;
						if(DialogMoveFiles( inputBuffer ) == 13)
						{
							if(IS_PT((*aPanel)->pt,PT_FIND))
							{
								FreePanel(&findPanel);
								if(ActivePanel == LEFT) (*aPanel) = &filePanel1; else (*aPanel) = &filePanel2;
							}
							l_tmp = (*aPanel)->curr;
							SetActivePanel(ActivePanel);
							FillPanel((*aPanel),aWindow,0);
							SetActivePanel(ActivePanel);
							FillPanel((*aPanel),aWindow,0);
							GotoItem(l_tmp);
						}
						break;
					  }
//F7 - create directory
			case VK_F7 :{
						if(bUtilActive) break;
						if(fHide) break;
						if(!(*aPanel)->f7) break;
						
						char dirname[STR_SIZE];
						if(DialogCreateDirectory(dirname) == 13)
						{
							FillPanel((*aPanel),aWindow,0,TRUE,dirname);
						}
						break;
					  }
//F8 - delete
			case VK_F8 :{
						if(fHide) break;
						if(bUtilActive) break;
						if(!(*aPanel)->f8) break;
						if(IS_PT((*aPanel)->pt,PT_TASK)) {
							DialogReminderDeleteTask();
							RefreshActivePanel();
						} else if(DialogDeleteFiles() == 13) {
							
							if(IS_PT((*aPanel)->pt,PT_FIND))
							{
								FreePanel(&findPanel);
								if(ActivePanel == LEFT) (*aPanel) = &filePanel1; else (*aPanel) = &filePanel2;
							}
							l_tmp = (*aPanel)->curr;
							FillPanel((*aPanel),aWindow,0);
							GotoItem(l_tmp);
							if(!strcmp(lDirectory,rDirectory)) 
							{
								SetActivePanel(ActivePanel);
								FillPanel((*aPanel),aWindow,0);
								SetActivePanel(ActivePanel);
							}
						}
						break;
					  }
//F9 - attributes
			case VK_F9 :{
							if(fHide) break;
							if(bUtilActive) break;
							if(!(*aPanel)->f9) break;
							if(DialogAttrFiles() == 13)
								RefreshActivePanel();
							break;
						}
//F10 - quit
			case VK_F10 :{
							if(!(*aPanel)->f10) break;
							if(YesNoCancelMessage(hStdOut,"The Kulak Commander","Do you want to quit Kulak Comander?") == 'Y')
							{
								ExitKC();
							}
							break;
					  }
//ENTER
			case VK_RETURN : {
						EnterAction(inputBuffer);
						break;
					  }
//UP
			case 38 : {
						if(fHide) { HistoryUp(); break; }
						//panel sizes
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))
							SelectFile();
						MoveRowUp(aWindow,(*aPanel));
						break;
					  }
//DOWN
			case 40 : {
						if(fHide) { HistoryDown(); break; }
						//panel sizes
						if((inputBuffer.Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED))
							SelectFile();
						MoveRowDown(aWindow,(*aPanel));
						break;
					  }
//PAGE_DOWN
			case 34 : {
						if(fHide) break;
						MovePageDown(aWindow,(*aPanel));
						break;
					  }
//PAGE_UP
			case 33 : {
						if(fHide) break;
						MovePageUp(aWindow,(*aPanel));
						break;
					  }
//HOME
			case 36 : {
						if(fHide) break;
						RefreshPanel((*aPanel),aWindow,0);
						aWindow->curSelRow = 0;
						(*aPanel)->curr = 0;
						SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);		
						break;
					  }
//END
			case 35 : {
						if(fHide) break;
						if((*aPanel)->nFiles < (aWindow->sizeY - 2))
						{
							RefreshPanel((*aPanel),aWindow,0);
							aWindow->curSelRow = (*aPanel)->nFiles - 1;
							(*aPanel)->curr = (*aPanel)->nFiles - 1;
							SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);
						}
						else
						{
							RefreshPanel((*aPanel),aWindow,(*aPanel)->nFiles - (aWindow->sizeY - 2));
							aWindow->curSelRow = aWindow->sizeY - 3;
							(*aPanel)->curr = (*aPanel)->nFiles - 1;
							SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);
						}	
						break;
					  }
//TAB
			case 9	: {
						if(fHide) break;
						if(bUtilActive) break;
						SetActivePanel(ActivePanel);
						break;
					  }
//INSERT (select item)
			case 45 : {
						if(fHide) break;
						if(!(*aPanel)->vk_insert) break;
						SelectFile();
						MoveRowDown(aWindow,(*aPanel));
						break;
					  }
//gray + (select items)
			case 107 :{
						if(fHide) break;
						if(!(*aPanel)->vk_plus) break;
						SelectItems(TRUE,"Select");
						break;	
					  }
//gray - (unselect items)
			case 109 :{
						if(fHide) break;
						if(!(*aPanel)->vk_minus) break;
						SelectItems(FALSE,"Unselect");
						break;	
					  }
//gray * (invert)
			case 106 :{
						if(fHide) break;
						if(!(*aPanel)->vk_asterisk) break;
						for(int i = 0 ; i < (*aPanel)->nFiles; i++ )
						{
							if(strcmp((*aPanel)->Items[i].file.cFileName,".."))
								(*aPanel)->Items[i].selected ^= 1;
						}
						RefreshPanel((*aPanel),aWindow,(*aPanel)->curr - aWindow->curSelRow);
						SelectPanelCursor(aWindow, (*aPanel), 0 , aWindow->curSelRow);
						break;	
					  }
//COMMAND LINE KEY
//-------------------
			default:  {
							CommandLineServis(&CommandLine,
								inputBuffer.Event.KeyEvent.uChar.AsciiChar,
								inputBuffer.Event.KeyEvent.wVirtualKeyCode,
								inputBuffer.Event.KeyEvent.dwControlKeyState);
	//don't refresh info panel when CL
							return TRUE;
					  }

		}//end switch
	return FALSE;
}

//////////////////////////////////
void MainKeyboardLoop(void)
{
	DWORD	id;
	HANDLE	h_mutex,h_thread;
	
//init command line
	CommandLine.startx = 3;	
	CommandLine.starty = 23;	
	CommandLine.x = 3;	
	CommandLine.y = 23;	
	CommandLine.size = 77;	
	CommandLine.bufpos = 0;	
	CommandLineServis(&CommandLine,0,0,0);
//init reminder
	CreateMutex(NULL,TRUE,reminder_mutex_name);
	h_mutex = OpenMutex(MUTEX_ALL_ACCESS,FALSE,reminder_mutex_name);
	h_thread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ReminderThread,NULL,0,&id);
	SetThreadPriority(h_thread,THREAD_PRIORITY_IDLE);
//main loop	
	while(1)
	{
		ReleaseMutex(h_mutex);

//refresh down bar
		if(!fHide)
		{
			keyStatus = GetAsyncKeyState(VK_CONTROL) & 0x8000;
			if(keyStatus  && !bCtrlDown && !bUtilActive) 
			{
				DrawBar(barCtrl);
				bCtrlDown = TRUE;
			}
			if(!keyStatus && bCtrlDown) 
			{
				DrawBar(bar);
				bCtrlDown = FALSE;
			}
			keyStatus = GetAsyncKeyState(VK_MENU) & 0x8000;
			if(keyStatus  && !bAltDown && !bUtilActive) 
			{
				DrawBar(barAlt);
				bAltDown = TRUE;
			}
			if(!keyStatus && bAltDown) 
			{
				DrawBar(bar);
				bAltDown = FALSE;
			}
		}

		gotoxy(CommandLine.x,CommandLine.y);
		
		SetCursor(hStdOut,TRUE,CURSOR_DEFAULT);
//set waiting flag		
		g_bWaiting=TRUE;
//wait for key		
		ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
		Sleep(20);
		g_bWaiting=FALSE;
		g_lastKeyPressTime=clock();

		if(dwInputEvents > 0)
		{
			if(inputBuffer.EventType == KEY_EVENT)
			{
				if(inputBuffer.Event.KeyEvent.bKeyDown)	
				{
//test if reminder send VK_F24 
					WaitForSingleObject(h_mutex,INFINITE);
					if(inputBuffer.Event.KeyEvent.wVirtualKeyCode == VK_F24)
					{
						while(kbhit()) mygetch();
						DialogReminderTaskNotifyEdit(inputBuffer.Event.KeyEvent.wVirtualScanCode);
						continue;
					}
					if(TestLeftRightCtrl(inputBuffer)) continue;
					//if(TestRightAlt(inputBuffer)) continue;
					if(TestLeftAlt(inputBuffer)) continue;
					if(TestKeys(inputBuffer)) continue;
					if(!fHide) DrawInfoPanel();
				}//if(KeyDown....
			}//if
		}//if
		
	
	}//while
}

//
// init ctrl + c handler
//
// !!! this function mus be executed after run process on KC console
// !!! because process could change console settings
//
void InitConsoleMode()
{
	SetConsoleMode(hStdIn,ENABLE_LINE_INPUT|ENABLE_ECHO_INPUT|ENABLE_MOUSE_INPUT);	
	SetConsoleCtrlHandler( (PHANDLER_ROUTINE) CtrlHandler,TRUE);
}

/////////////////////////////////////////////////////
// CtrlHandler (disable ctrl + c....)
/////////////////////////////////////////////////////
BOOL CtrlHandler(DWORD fdwCtrlType) 
{  
	switch (fdwCtrlType) 
	{ 
 // Handle the CTRL+C signal. 
        case CTRL_BREAK_EVENT: 
 
			Beep(500, 100); 
            return TRUE; 
		case CTRL_C_EVENT: 
			//on ctrl+c put to keyboard buffer ctrl+c			
//			INPUT_RECORD	inputBuffer;
//			inputBuffer.Event.KeyEvent.wVirtualKeyCode = (WORD)0x43;
//			inputBuffer.Event.KeyEvent.dwControlKeyState = LEFT_CTRL_PRESSED;
//			WriteConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
			return TRUE; 
 
        //CTRL+CLOSE: confirm that the user wants to exit.
        case CTRL_CLOSE_EVENT: 
 
        //Pass other signals to the next handler.
        case CTRL_LOGOFF_EVENT: 
        case CTRL_SHUTDOWN_EVENT: 
 
        default: 
            return FALSE; 
 
	}//switch
 
} 

// CreateLink - uses the shell's IShellLink and IPersistFile interfaces 
//   to create and store a shortcut to the specified object. 
// Returns the result of calling the member functions of the interfaces. 
// lpszPathObj - address of a buffer containing the path of the object 
// lpszPathLink - address of a buffer containing the path where the 
//   shell link is to be stored 
// lpszDesc - address of a buffer containing the description of the 
//   shell link 
 /*
HRESULT CreateLink(LPCSTR lpszPathObj, 
    LPSTR lpszPathLink, LPSTR lpszDesc) 
{ 
    HRESULT hres; 
    IShellLink* psl; 

    // Get a pointer to the IShellLink interface. 
    hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&psl); 
    if (SUCCEEDED(hres)) { 
        IPersistFile *ppf; 
 
        // Set the path to the shortcut target, and add the 
        // description. 
        psl->SetPath(lpszPathObj); 
        psl->SetDescription(lpszDesc); 
 
       // Query IShellLink for the IPersistFile interface for saving the 
       // shortcut in persistent storage. 
        hres = psl->QueryInterface(IID_IPersistFile, 
            (void**)&ppf); 
 
        if (SUCCEEDED(hres)) { 
            WORD wsz[MAX_PATH]; 
 
            // Ensure that the string is ANSI. 
            MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, 
                wsz, MAX_PATH); 
 
            // Save the link by calling IPersistFile::Save. 
            hres = ppf->Save(wsz, TRUE); 
            ppf->Release(); 
        } 
        psl->Release(); 
    } 
    return hres; 
} 

void CreateLink(void)
{
	LPVOID	pvReserved = NULL;

	CoInitialize(pvReserved);
	CreateLink( "d:\\fw.log","d:\\link_fw_log", "special link....");
	CoUninitialize();

}
*/
void ParseArguments(int argc, char *argv[])
{
	if( argc > 1)
	{
		if(!stricmp(argv[1],"e") && argv[2])
		{
			SetConsoleTitle( argv[2] );
			KcEdit(argv[2]);
		}
		else
		{
			printf("\nuse : kc.exe\t\t//run commander\n      kc.exe e filename\t//run editor");
		}
		exit(1);
	}
}

int main(int argc, char *argv[])
{

//	CreateLink();
//	return 0;
	
	char	*p_filename;
	int		i;

//
	GetOSVersion();
	if(dwOSVersion == WIN_NT) 
	{		
		printf("OS: WinNT  => NORMAL_PRIORITY_CLASS");
		g_KcPriority = NORMAL_PRIORITY_CLASS;
	}
	else 
	{
		printf("OS: Win95  => HIGH_PRIORITY_CLASS");
		g_KcPriority = HIGH_PRIORITY_CLASS;
	}
	SetPriorityClass(GetCurrentProcess(),g_KcPriority );
//minimize KC memory use
	SetProcessWorkingSetSize(GetCurrentProcess(),0xffffffff,0xffffffff);
//about	
#ifdef _MINGW32_
	sprintf(about,"MINGW32 - Kulak Commander v1.0 (C)2000 V.Kulakovsky dqLm b%ld %s %s pid:%lu",CURRENT_BUILD,__DATE__,__TIME__,GetCurrentProcessId());
#else
	sprintf(about,"Kulak Commander v1.0 (C)2000 V.Kulakovsky dqLm b%ld %s %s pid:%lu",CURRENT_BUILD,__DATE__,__TIME__,GetCurrentProcessId());
#endif
	printf("\n\n%s\n",about);
	GetConsoleTitle(sOldTitle,STR_SIZE);
	SetConsoleTitle(about);
	_tzset();
//get full path to KC.INI
	GetFullPathName(argv[0],STR_SIZE,g_start_path,&p_filename);
	*p_filename = (char)0;
	sprintf(g_ini_file,"%skc.ini",g_start_path);
	sprintf(g_kc_help,"%skc.kch",g_start_path);

//disable CTRL + BREAK | + C	
	InitConsoleMode();
//init color config
	LoadIniFile(g_ini_file);
	LoadIniEHL(g_ini_file);
	if(colorConfig == CONFIG_USER) LoadAllIniColors(g_ini_file);
	else if(colorConfig == CONFIG_MONO) SetMonoKC();
		 else SetColorKC();
//Parse KC ARGUMENTS
	ParseArguments(argc,argv);

//--------------------------------------------------------------
//create unique MuteNames couse each running KC must have
//unique mutex names
	sprintf(work_mutex_name,"WorkMutexName_%lu",GetCurrentProcessId());
	sprintf(reminder_mutex_name,"reminderMutexName_%lu",GetCurrentProcessId());
//find KC HWND if you are too fast - wait
	printf("\n");
	for(i = 0; i < 10; i++)
	{
		EnumWindows( (WNDENUMPROC) EnumProcessListFunc,0 );
		if ( g_KC_hwnd != NULL ) break;
		printf("..waiting for kc HWND\n");
		Sleep(500);
	}
	if(g_KC_hwnd == NULL) printf("kc HWND not found \7\n");

//-----------------
//create back screen
	hBackOut = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
//create tmp screen
	hTmpOut = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
      FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CONSOLE_TEXTMODE_BUFFER,
      NULL);
	if(hBackOut == INVALID_HANDLE_VALUE)
	{
		printf("hBackOut = INVALID_HANDLE_VALUE\n"); return 1;
	}

//init tasks
	ReminderLoadTasks(g_ini_file);
//init history
	History = new char*[g_max_history];
	kASSERT(History!=NULL);
	InitHistory();

	pLeftPanel = &filePanel1;
	pRightPanel = &filePanel2;
	memset(&filePanel1,0,sizeof(TPanel));
	memset(&filePanel2,0,sizeof(TPanel));
	memset(&findPanel,0,sizeof(TPanel));
	memset(&netPanel,0,sizeof(TPanel));
	InitPanels();
	wl.Init("",g_lp_posx,g_lp_posy,g_lp_sizex,g_lp_sizey,ctPanel,cbPanel);
	wr.Init("",g_rp_posx,g_rp_posy,g_rp_sizex,g_rp_sizey,ctPanel,cbPanel);
	wi.Init("",g_ip_posx,g_ip_posy,g_ip_sizex,g_ip_sizey,ctInfoPanel,cbInfoPanel);
	wb.Init("",0,24,80,1,ctInfoPanel,cbInfoPanel);
	wl.SaveBG();
	wr.SaveBG();
	wi.SaveBG();
	wb.SaveBG();

	ActivePanel = LEFT;
	aPanel = &pLeftPanel;
	aWindow = &wl;

	findPanel.sortMethod = SORT_BY_EXT;
	findPanel.showMethod = PANEL_SHOW_TYPE_NAME;
	netPanel.sortMethod = SORT_BY_NAME;
	netPanel.showMethod = PANEL_SHOW_TYPE_NAME;
//set active panel
	ActivePanel = LEFT;
	aPanel = &pLeftPanel;
	aWindow = &wl;
	aDirectory = lDirectory;
//init l panel
	pLeftPanel->sortMethod = SORT_BY_EXT;
	pLeftPanel->showMethod = PANEL_SHOW_TYPE_SIZE;
	pLeftPanel->curr = 0;
	wl.curSelRow = 0;
//init r panel
	pRightPanel->sortMethod = SORT_BY_EXT;
	pRightPanel->showMethod = PANEL_SHOW_TYPE_SIZE;
	pRightPanel->curr = 0;
	wr.curSelRow = 0;
	GetCurrentDirectory(STR_SIZE-1,rDirectory);

//init panels
	ActivePanel = RIGHT;
	aPanel = &pRightPanel;
	aWindow = &wr;
	aDirectory = rDirectory;
	FillPanel(pRightPanel,&wr,0);
	ActivePanel = LEFT;
	aPanel = &pLeftPanel;
	aWindow = &wl;
	aDirectory = lDirectory;
	FillPanel(pLeftPanel,&wl,0);
	
	SetActivePanel(ActivePanel);
	SetActivePanel(ActivePanel);

	DrawInfoPanel();
	DrawBar(bar);
	SetCursor(hStdOut,TRUE,CURSOR_DEFAULT);
//set error mode
	UINT lastErrMode = SetErrorMode(SEM_FAILCRITICALERRORS);
	MainKeyboardLoop();
	SetErrorMode(lastErrMode);

	return 0;

}
