#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <conio.h>
#include "misc.h"

DWORD	dwOSVersion;

void GetOSVersion(void)
{
	DWORD 	dwVersion = GetVersion();
 
// Get major and minor version numbers of Windows

	DWORD 	dwWindowsMajorVersion =  (DWORD)(LOBYTE(LOWORD(dwVersion)));
	DWORD 	dwWindowsMinorVersion =  (DWORD)(HIBYTE(LOWORD(dwVersion)));

// Get build numbers for Windows NT or Win32s

	if (dwVersion < 0x80000000)                // Windows NT
		dwOSVersion = WIN_NT;
	else if (dwWindowsMajorVersion < 4)        // Win32s
		dwOSVersion = WIN_32S;
	else         // Windows 95 -- No build numbers provided
		dwOSVersion = WIN_95;
}

void KulakSleep(DWORD ms)
{
	if(ms) Sleep(ms);
}

void SpeekerBeep(int n)
{
		for(int i = 0; i < n; i++)
		{
			Beep(500,30);
			Sleep(25);
			//MessageBeep(MB_OK);
		}
}

void gotoxy(int x,int y)
{
	COORD coord;

	coord.X = x;
	coord.Y = y;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),coord);
}

void clprintf(HANDLE hCon,const short ct,const short cb,const short x,const short y,char *str,...)
{
	va_list ap;
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;
	char	stmp[STR_SIZE];

	va_start(ap,str);
	vsprintf(stmp,str,ap);
	va_end(ap);
	dwWriteCoord.X = x;
	dwWriteCoord.Y = y;
	gotoxy(x,y);
	size_t size = strlen(stmp);
	FillConsoleOutputAttribute(hCon,ct|cb,size,dwWriteCoord, &cCharsWritten);
	WriteConsoleOutputCharacter(hCon,stmp,size,dwWriteCoord, &cCharsWritten);
		
}

void CopyConsoleScreen(HANDLE dest,HANDLE src)
{	
	COORD dwBufferSize,dwBufferCoord;	//for bg
	SMALL_RECT srReadRegion;			
	CONSOLE_SCREEN_BUFFER_INFO ci;
	CHAR_INFO *lpBgBuffer;				//buffer for bg

	GetConsoleScreenBufferInfo(src,&ci);
	
	dwBufferSize.X = ci.dwSize.X;
	dwBufferSize.Y = ci.dwSize.Y;
	dwBufferCoord.X = 0;
	dwBufferCoord.Y = 0;
	srReadRegion.Left = 0;
	srReadRegion.Top = 0;
	srReadRegion.Right = ci.dwSize.X;
	srReadRegion.Bottom = ci.dwSize.Y;

    lpBgBuffer = new CHAR_INFO[dwBufferSize.X * dwBufferSize.Y * sizeof(CHAR_INFO)];
	kASSERT(lpBgBuffer!=NULL);
	if(lpBgBuffer)	
	{
		ReadConsoleOutput(src,lpBgBuffer,dwBufferSize,dwBufferCoord,&srReadRegion);
		WriteConsoleOutput(dest,lpBgBuffer,dwBufferSize,dwBufferCoord,&srReadRegion);
		delete [] lpBgBuffer;
	}
}

void CopyConsoleWindow(HANDLE dest,HANDLE src,WORD x,WORD y, WORD xs, WORD ys)
{	
	COORD dwBufferSize,dwBufferCoord;	//for bg
	SMALL_RECT srReadRegion;			
	CONSOLE_SCREEN_BUFFER_INFO ci;
	CHAR_INFO *lpBgBuffer;				//buffer for bg

	GetConsoleScreenBufferInfo(src,&ci);
	
	dwBufferSize.X = xs;
	dwBufferSize.Y = ys;
	dwBufferCoord.X = 0;
	dwBufferCoord.Y = 0;
	srReadRegion.Left = x;
	srReadRegion.Top = y;
	srReadRegion.Right = x + xs;
	srReadRegion.Bottom = y + ys;

    lpBgBuffer = new CHAR_INFO[dwBufferSize.X * dwBufferSize.Y * sizeof(CHAR_INFO)];
	kASSERT(lpBgBuffer!=NULL);
	if(lpBgBuffer)	
	{
		ReadConsoleOutput(src,lpBgBuffer,dwBufferSize,dwBufferCoord,&srReadRegion);
		WriteConsoleOutput(dest,lpBgBuffer,dwBufferSize,dwBufferCoord,&srReadRegion);
		delete [] lpBgBuffer;
	}
}


void ReadAttribute(HANDLE hCon,WORD *attr,short x,short y,unsigned size)
{
	COORD	dwWriteCoord;
	DWORD	cCharsWritten;

	dwWriteCoord.X = x;
	dwWriteCoord.Y = y;
	ReadConsoleOutputAttribute(hCon,attr, size,dwWriteCoord, &cCharsWritten);
}

void WriteAttribute(HANDLE hCon,WORD *attr,short x,short y,unsigned size)
{
	COORD dwWriteCoord;
	DWORD cCharsWritten;

	dwWriteCoord.X = x;
	dwWriteCoord.Y = y;
	WriteConsoleOutputAttribute(hCon,attr, size,dwWriteCoord, &cCharsWritten);
}

void SetAttribute(HANDLE hCon,short ct,short cb,short x,short y,unsigned size)
{
	COORD dwWriteCoord;
	DWORD cCharsWritten;

	dwWriteCoord.X = x;
	dwWriteCoord.Y = y;
	FillConsoleOutputAttribute(hCon,ct|cb, size,dwWriteCoord, &cCharsWritten);
}


BOOL TestDir(char *dir)
{
	char olddir[STR_SIZE];
	
	GetCurrentDirectory(STR_SIZE,olddir);
	if(SetCurrentDirectory(dir))
	{
		SetCurrentDirectory(olddir);
		return TRUE;
	}
	return FALSE;
}

void DeleteLastBackslash(char *str)
{
	if(str[strlen(str)-1] == '\\') str[strlen(str)-1] = 0;
}

//////////////////////////////////////////
// FormatStringRight
//
// input	: str,size
// return	: formated string in "str" right to size
//////////////////////////////////////////
void FormatStringRight(DWORD size,char *str)
{
	char	tmp[STR_SIZE];
	DWORD	strsize = (DWORD)strlen(str);
	
	strcpy(tmp,str);
	if(strsize > size)
	{
		memcpy(str,&tmp[strsize - size],size);
		str[size] = 0;
	}
	else
	{
		memset(str,' ',size - strsize);
		strcpy(str + (size - strsize),tmp);
	}
}


void CreateSpaceString(char *dest,char *src,int size)
{
	memset(dest,' ',size);
	dest[size] = 0;
	if((int)strlen(src) < size) memcpy(dest,src,strlen(src));
	else memcpy(dest,src,size);
}

void StringLeftOrRight(char *left,char *right,int size)
{
	char	s_tmp[STR_SIZE];
	int		i;

	CreateSpaceString(s_tmp,left,size);
	i = strlen(s_tmp);
	FormatStringRight(size,right);
	i = strlen(right);
	for( i = 0; i < size ; i++)
	{
		if(right[i] != ' ' && right[i-1] == ' ' && s_tmp[i] != ' ') s_tmp[i-1] = '{';
		if(right[i] != ' ') s_tmp[i] = right[i];
	}
	s_tmp[size] = 0;
	strcpy(left,s_tmp);
}


BOOL get_2parts_from_end(char *s,char *part1,char *part2,char separator,BOOL b_ret_empty)
{
	char tmp[STR_SIZE];
	char *p;

	strcpy(tmp,s);
	p = strrchr(tmp,separator);
	if(!p) 
	{
		strcpy(part1,s);
		if(!b_ret_empty) strcpy(part2,s);
		else strcpy(part2,"");
		return (FALSE);
	}
	else
	{
		*p = 0;
		strcpy(part1,tmp);
		strcpy(part2,p+1);
	}
	return (TRUE);
}

int mygetch(void)
{
	int r = getch();
	Sleep(20);
	return r;
}	

int mygetchVK(void)
{
	INPUT_RECORD inputBuffer;
	DWORD dwInputEvents; 
	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);

	while(1)
	{
		ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
		Sleep(20);
		if(dwInputEvents > 0 
			&& inputBuffer.Event.KeyEvent.bKeyDown
			&& inputBuffer.EventType == KEY_EVENT)
		{
			return (int)(inputBuffer.Event.KeyEvent.wVirtualKeyCode);
		}	
	}	
	return 0;
}

int mygetchASCII(void)
{
	INPUT_RECORD inputBuffer;
	DWORD dwInputEvents; 
	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);

	while(1)
	{
		ReadConsoleInput(hStdIn, &inputBuffer, 1, &dwInputEvents);
		Sleep(20);
		if(dwInputEvents > 0 
			&& inputBuffer.Event.KeyEvent.bKeyDown
			&& inputBuffer.EventType == KEY_EVENT)
		{
			return (int)(inputBuffer.Event.KeyEvent.uChar.AsciiChar);
		}	
	}	
	return 0;
}

BOOL SetCursor(HANDLE h,BOOL visible,DWORD size)
{
	CONSOLE_CURSOR_INFO ci;

	ci.dwSize = size;
	ci.bVisible = visible;
	return SetConsoleCursorInfo(h,&ci);
}

void HideCursor(HANDLE h,BOOL hide){
	CONSOLE_CURSOR_INFO hide_ci;
	static CONSOLE_CURSOR_INFO cci;
	static CONSOLE_SCREEN_BUFFER_INFO csbi;

	if(hide){
		GetConsoleScreenBufferInfo(h,&csbi);
		GetConsoleCursorInfo(h,&cci);
		hide_ci.dwSize = CURSOR_DEFAULT;
		hide_ci.bVisible = FALSE;
		SetConsoleCursorInfo(h,&hide_ci);
	}
	else{
		SetConsoleCursorPosition(h,csbi.dwCursorPosition);
		SetConsoleCursorInfo(h,&cci);
	}

}

void StrCut2Dot(char * str,int maxsize)
{
	if((unsigned)maxsize > strlen(str)) return;
	
	if(strlen(str) > (unsigned)(maxsize))
	{
		strrev(str);
		str[(maxsize - 4) - 2] = '.';
		str[(maxsize - 4) - 1] = '.';
		str[(maxsize - 4)] = 0;
		strrev(str);
	}

}

//-------------------------------------------------
//  put block to clipboard
//-------------------------------------------------
BOOL PutBlockToClipboard(char *buffer,long size)
{
	HGLOBAL hglbCopy; 
    LPTSTR  lptstrCopy; 

	if(!OpenClipboard(NULL)) return FALSE;
	EmptyClipboard();
	hglbCopy = GlobalAlloc(GMEM_DDESHARE, (size + 1) * sizeof(char)); 
	if(!hglbCopy) 
	{
		CloseClipboard(); return FALSE;
	}
	lptstrCopy = (LPTSTR)GlobalLock((HGLOBAL)hglbCopy); 
	memcpy(lptstrCopy, buffer, size * sizeof(TCHAR)); 
	GlobalUnlock(hglbCopy); 
	
	SetClipboardData(CF_TEXT, hglbCopy); 
	CloseClipboard(); 

	return TRUE;
}

//-------------------------------------------------
//  get block from clipboard
//-------------------------------------------------
long GetBlockFromClipboard(char*& buffer)
{
    HGLOBAL	hglbCopy; 
    LPTSTR  lptstrCopy; 
	UINT	format = 0;
	DWORD	size;

	if(!OpenClipboard(NULL)) return -1;
	format = EnumClipboardFormats(CF_TEXT);
	if(!format)
	{
		CloseClipboard(); return -1;
	}
	hglbCopy = (HGLOBAL)GetClipboardData(CF_TEXT); 
	lptstrCopy = (LPTSTR)GlobalLock((HGLOBAL)hglbCopy); 
	size = strlen(lptstrCopy);
	buffer = (char*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,(size+1)*sizeof(char));
	memcpy(buffer,lptstrCopy,size); 
	GlobalUnlock(hglbCopy); 

	CloseClipboard(); 
return size;
}


//-------------------------------------------------
//  file time manipulation
//-------------------------------------------------
BOOL MyGetFileTime(char *fname,LPFILETIME ct,LPFILETIME lat,LPFILETIME lwt)
{
	BOOL b;
	HANDLE h = CreateFile(fname,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	
	if(h == INVALID_HANDLE_VALUE) return FALSE;
	else
	{
		b = GetFileTime(h,ct,lat,lwt);
		CloseHandle(h);
	}
	return b;
}

BOOL MySetFileTime(char *fname,LPFILETIME ct,LPFILETIME lat,LPFILETIME lwt)
{
	BOOL b;
	HANDLE h = CreateFile(fname,GENERIC_WRITE ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	
	if(h == INVALID_HANDLE_VALUE) return FALSE;
	else
	{
		b = SetFileTime(h,ct,lat,lwt);
		CloseHandle(h);
	}
	return b;
}
