#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "globals.h"
#include "Reminder.h"

Ttask	g_task[REMINDER_MAX_TASKS];

int ReminderFindFreeTask(void)
{
	for (int i = 0; i < REMINDER_MAX_TASKS; i++)
		if(g_task[i].active == FALSE) return i;
return -1;
}

int ReminderFindTask(int from)
{
	if( from >= REMINDER_MAX_TASKS) return -1;
	for (int i = from; i < REMINDER_MAX_TASKS; i++)
		if(g_task[i].active == TRUE) return i;
return -1;
}

void ReminderResetTasks(void)
{
	for (int i = 0; i < REMINDER_MAX_TASKS; i++) 
		g_task[i].active = FALSE;
}

char* ReminderGetTaskTime(int t)
{
	static char s_tmp[50]="error";
	struct tm *tmtime = localtime(&g_task[t].tWakeUp);
	if(tmtime != NULL)
	{
		strftime(s_tmp,99,"%d-%m-%Y %H:%M:%S",tmtime);
		s_tmp[strlen(s_tmp)] = 0;
	}
	return (s_tmp);
}

char* ReminderGetTaskTime1(int t)
{
	static char s_tmp[50]="error";
	char s_tmp1[50];
	time_t ttt = time(NULL);
	struct tm *ttmp = localtime(&g_task[t].tWakeUp);
	struct tm tmtime = *ttmp;
	ttmp = localtime(&ttt);
	struct tm curr_time = *ttmp;
	int min;

	if( tmtime.tm_year == curr_time.tm_year &&
		tmtime.tm_mon == curr_time.tm_mon &&
		tmtime.tm_mday == curr_time.tm_mday ) {
		min = (g_task[t].tWakeUp - ttt) / 60;
		sprintf( s_tmp1," (%02d:%02d)   ",min/60,min%60);
		strftime(s_tmp,99,"%I:%M %p",&tmtime);
		strcat(s_tmp,s_tmp1);
	} else {
		strftime(s_tmp,99,"%d-%m-%Y %I:%M %p",&tmtime);
	}
	s_tmp[strlen(s_tmp)] = 0;
	return (s_tmp);
}


char* ReminderGetTaskStrTime(int t)
{
	return (g_task[t].strTime);
}

char* ReminderGetTaskName(int t)
{
	return (g_task[t].name);
}

char* ReminderGetTaskEmail(int t)
{
	return (g_task[t].email);
}


void ReminderUnactivateTask(int t)
{
	g_task[t].active = FALSE;
}


BOOL ReminderParseTime(char *ttime,time_t *wakeup)
{
	time_t	tnow;
	long	add;

	time(&tnow);
	
	switch(toupper(ttime[0]))
	{
		case 'D' :	{
						add = atol(&ttime[1]) * 60 * 60 * 24;
						break;
					}
		case 'H' :	{
						add = atol(&ttime[1]) * 60 * 60;
						break;
					}
		case 'M' :	{
						add = atol(&ttime[1]) * 60;
						break;
					}
		case 'S' :	{
						add = atol(&ttime[1]);
						break;
					}
		default :	{
						struct tm	tmtime;
						//init tm struct
						time(wakeup);
						tmtime = *localtime(wakeup);
						if(strchr(ttime,'/')) {
							sscanf(ttime,"%d/%d/%d %d:%d",&tmtime.tm_mday,&tmtime.tm_mon,&tmtime.tm_year,&tmtime.tm_hour,&tmtime.tm_min);
							tmtime.tm_year = tmtime.tm_year<50?tmtime.tm_year+100:tmtime.tm_year;
							tmtime.tm_isdst = -1;
							tmtime.tm_sec = 0;
							tmtime.tm_mon--;
						} else {
							tmtime.tm_min = 0;
							sscanf(ttime,"%d:%d",&tmtime.tm_hour,&tmtime.tm_min);
							tmtime.tm_isdst = -1;
							tmtime.tm_sec = 0;
						}
						*wakeup = mktime(&tmtime);
						if(*wakeup == (time_t)-1) return FALSE;
						if( tnow > *wakeup ) *wakeup += (3600*24);
						return TRUE;
					}
	}
	
	*wakeup = (time_t)(tnow + add);
	return TRUE;
}

//if ok return number of task 
//else	-1 = no free task
//		-2 = error time
int ReminderAddTask(char *ttime,char *tname, char color, char *email )
{
	int		task;
	time_t	ltime;
	
	task = ReminderFindFreeTask();
	if( task == -1 ) return -1;

	if(!ReminderParseTime(ttime,&ltime)) return -2;
		
	g_task[task].tWakeUp = ltime;
	strcpy(g_task[task].name,tname);
	g_task[task].active = TRUE;
	memcpy(g_task[task].strTime,ttime,49);
	g_task[task].strTime[49] = 0;
	g_task[task].color = color;
	strcpy(g_task[task].email,email);
	return task;
}

int ReminderTestTasks(void)
{
	time_t	ltime;
	time(&ltime);

	for (int i = 0; i < REMINDER_MAX_TASKS; i++) 
	{
		if(g_task[i].active)
		{
			if(ltime >= g_task[i].tWakeUp)
			{
				return(i);
			}
		}
	}
return (-1);
}

BOOL ReminderSaveTasks(char *fname)
{
	int		taskNum = 0;	
	char	s_tmp[STR_SIZE],s_tmp1[STR_SIZE];

	for (int i = 0; i < REMINDER_MAX_TASKS; i++) 
	{
			sprintf(s_tmp,"%ld",g_task[i].active);
			sprintf(s_tmp1,"task%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			sprintf(s_tmp,"%ld",g_task[i].tWakeUp);
			sprintf(s_tmp1,"time%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			sprintf(s_tmp,"%s",g_task[i].name);
			sprintf(s_tmp1,"name%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			sprintf(s_tmp,"%s",g_task[i].strTime);
			sprintf(s_tmp1,"last_opt%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			sprintf(s_tmp,"%c",g_task[i].color);
			sprintf(s_tmp1,"color%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			sprintf(s_tmp,"%s",g_task[i].email);
			sprintf(s_tmp1,"email%ld",taskNum);
			WritePrivateProfileString("Reminder",s_tmp1,s_tmp,fname);
			taskNum++;
	}
return TRUE;
}

BOOL ReminderLoadTasks(char *fname)
{
	int		taskNum = 0;	
	char	s_tmp[STR_SIZE],s_tmp1[STR_SIZE];

	for (int i = 0; i < REMINDER_MAX_TASKS; i++) 
	{
			sprintf(s_tmp1,"task%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"0",s_tmp,1000,fname);
			g_task[i].active = (BOOL)atoi(s_tmp);
			
			sprintf(s_tmp1,"time%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"0",s_tmp,1000,fname);
			g_task[i].tWakeUp = (time_t)atol(s_tmp);

			sprintf(s_tmp1,"name%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"0",s_tmp,1000,fname);
			strcpy(g_task[i].name,s_tmp);

			sprintf(s_tmp1,"last_opt%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"0",s_tmp,1000,fname);
			strcpy(g_task[i].strTime,s_tmp);

			sprintf(s_tmp1,"color%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"W",s_tmp,1000,fname);
			g_task[i].color = s_tmp[0];
			
			sprintf(s_tmp1,"email%ld",taskNum);
			GetPrivateProfileString("Reminder",s_tmp1,"",s_tmp,1000,fname);
			strcpy(g_task[i].email,s_tmp);

			taskNum++;
	}
return TRUE;
}
